include <imhdr.h>

procedure err_fname(ptr,fname)

#--------------------------------------------------------------------------------------
#      ERR_FNAME -- Create the file name for an error file.  The name
#                   will be the same as the data file with "ERR" tacked 
#                   onto it just before the dot in the filename.  If there
#                   is no file extension, then "ERR" is simply appeneded.
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) ptr:        (pointer) Pointer to data file to be associated with error file
#      (<) fname:      (char) Output file name of error file
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        18-NOV-1992
#      UPDATE:
#
#--------------------------------------------------------------------------------------

# Parameters

pointer ptr
char fname[ARB]

# Local variables

pointer sp,cp1
int index

# Functions

int strldx()

begin

      # Get stack workspace

      call smark(sp)
      call salloc(cp1,SZ_FNAME,TY_CHAR)

      # Get the original file name and look for a dot.  If there is no dot
      # then create the file name by just appeding ERR to the name

      call strcpy(IM_HDRFILE(ptr),Memc[cp1],SZ_FNAME)
      index = strldx(".",Memc[cp1])
      if (index == 0) {
         call strcpy(Memc[cp1],fname,SZ_FNAME)
         call strcat("ERR",fname,SZ_FNAME) }

      # If there is a dot, then append "ERR" to the file name before extension

      else {
         call strcpy(Memc[cp1+index-1],fname,SZ_FNAME) # copy extension to fname
         call strcpy("ERR",Memc[cp1+index-1],SZ_FNAME-index+1) # add ERR to root
         call strcat(fname,Memc[cp1],SZ_FNAME) # concatinate extension
         call strcpy(Memc[cp1],fname,SZ_FNAME) # move file name to fname
      }

      # Free workspace

      call sfree(sp)
end
                                                                  
