procedure err_imdel(ptr)

#--------------------------------------------------------------------------------------
#      ERR_IMDEL -- Delete an error file associated with a data file
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) ptr:        (pointer) Pointer to data file associated with error file
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        18-NOV-1992
#      UPDATE:
#
#--------------------------------------------------------------------------------------

# Parameters

pointer ptr

# Local variables

pointer sp,cp1

errchk imdelf

begin
 
      # Get some workspace

      call smark(sp)
      call salloc(cp1,SZ_FNAME,TY_CHAR)

      # Get the file name and delete it

      call err_fname(ptr,Memc[cp1])
      call imdelete(Memc[cp1])

      # Delete reference to this error array from the data image

      call imdelf(ptr,"ERR_FILE")

      # Release workspace

      call sfree(sp)
end
