include <imhdr.h>

                   

procedure ndtrns(iptr,optr,ndim,npix,order)

# Parameters

pointer iptr,optr
int ndim,npix[ndim],order[ndim]

# Local variables

int njout[IM_MAXDIM],i,ntot,index1,loc1[IM_MAXDIM],index2

begin

      # Begin by calculating the number of pixels in each dimension.
      # Also count the total number of pixels to be transposed...

      njout[1] = npix[order[1]]
      do i = 2,ndim {
         njout[i] = njout[i-1]*npix[order[i]]
      }
      ntot = njout[ndim]

      # Initialise location counters...

      do i = 1,ndim
         loc1[i] = 1
      loc1[1] = 0

      # Now loop for the pixels 

      do index1 = 1,ntot {
         
         # Find where in the hyper-cubes each pixel belongs...

         do i = 1,ndim {
            loc1[i] = loc1[i] + 1
            if (loc1[i] > npix[i])
               loc1[i] = 1
            else
               break
         }
         index2 = 0
         do i = ndim,2,-1 
            index2 = index2 + njout[i-1]*(loc1[order[i]] - 1)
         index2 = index2 + loc1[order[1]] 

         # Now move the pixel over

         Mems[optr+index2-1] = Mems[iptr+index1-1]
      }
end

                   

procedure ndtrni(iptr,optr,ndim,npix,order)

# Parameters

pointer iptr,optr
int ndim,npix[ndim],order[ndim]

# Local variables

int njout[IM_MAXDIM],i,ntot,index1,loc1[IM_MAXDIM],index2

begin

      # Begin by calculating the number of pixels in each dimension.
      # Also count the total number of pixels to be transposed...

      njout[1] = npix[order[1]]
      do i = 2,ndim {
         njout[i] = njout[i-1]*npix[order[i]]
      }
      ntot = njout[ndim]

      # Initialise location counters...

      do i = 1,ndim
         loc1[i] = 1
      loc1[1] = 0

      # Now loop for the pixels 

      do index1 = 1,ntot {
         
         # Find where in the hyper-cubes each pixel belongs...

         do i = 1,ndim {
            loc1[i] = loc1[i] + 1
            if (loc1[i] > npix[i])
               loc1[i] = 1
            else
               break
         }
         index2 = 0
         do i = ndim,2,-1 
            index2 = index2 + njout[i-1]*(loc1[order[i]] - 1)
         index2 = index2 + loc1[order[1]] 

         # Now move the pixel over

         Memi[optr+index2-1] = Memi[iptr+index1-1]
      }
end

                   

procedure ndtrnl(iptr,optr,ndim,npix,order)

# Parameters

pointer iptr,optr
int ndim,npix[ndim],order[ndim]

# Local variables

int njout[IM_MAXDIM],i,ntot,index1,loc1[IM_MAXDIM],index2

begin

      # Begin by calculating the number of pixels in each dimension.
      # Also count the total number of pixels to be transposed...

      njout[1] = npix[order[1]]
      do i = 2,ndim {
         njout[i] = njout[i-1]*npix[order[i]]
      }
      ntot = njout[ndim]

      # Initialise location counters...

      do i = 1,ndim
         loc1[i] = 1
      loc1[1] = 0

      # Now loop for the pixels 

      do index1 = 1,ntot {
         
         # Find where in the hyper-cubes each pixel belongs...

         do i = 1,ndim {
            loc1[i] = loc1[i] + 1
            if (loc1[i] > npix[i])
               loc1[i] = 1
            else
               break
         }
         index2 = 0
         do i = ndim,2,-1 
            index2 = index2 + njout[i-1]*(loc1[order[i]] - 1)
         index2 = index2 + loc1[order[1]] 

         # Now move the pixel over

         Meml[optr+index2-1] = Meml[iptr+index1-1]
      }
end

                   

procedure ndtrnr(iptr,optr,ndim,npix,order)

# Parameters

pointer iptr,optr
int ndim,npix[ndim],order[ndim]

# Local variables

int njout[IM_MAXDIM],i,ntot,index1,loc1[IM_MAXDIM],index2

begin

      # Begin by calculating the number of pixels in each dimension.
      # Also count the total number of pixels to be transposed...

      njout[1] = npix[order[1]]
      do i = 2,ndim {
         njout[i] = njout[i-1]*npix[order[i]]
      }
      ntot = njout[ndim]

      # Initialise location counters...

      do i = 1,ndim
         loc1[i] = 1
      loc1[1] = 0

      # Now loop for the pixels 

      do index1 = 1,ntot {
         
         # Find where in the hyper-cubes each pixel belongs...

         do i = 1,ndim {
            loc1[i] = loc1[i] + 1
            if (loc1[i] > npix[i])
               loc1[i] = 1
            else
               break
         }
         index2 = 0
         do i = ndim,2,-1 
            index2 = index2 + njout[i-1]*(loc1[order[i]] - 1)
         index2 = index2 + loc1[order[1]] 

         # Now move the pixel over

         Memr[optr+index2-1] = Memr[iptr+index1-1]
      }
end

                   

procedure ndtrnd(iptr,optr,ndim,npix,order)

# Parameters

pointer iptr,optr
int ndim,npix[ndim],order[ndim]

# Local variables

int njout[IM_MAXDIM],i,ntot,index1,loc1[IM_MAXDIM],index2

begin

      # Begin by calculating the number of pixels in each dimension.
      # Also count the total number of pixels to be transposed...

      njout[1] = npix[order[1]]
      do i = 2,ndim {
         njout[i] = njout[i-1]*npix[order[i]]
      }
      ntot = njout[ndim]

      # Initialise location counters...

      do i = 1,ndim
         loc1[i] = 1
      loc1[1] = 0

      # Now loop for the pixels 

      do index1 = 1,ntot {
         
         # Find where in the hyper-cubes each pixel belongs...

         do i = 1,ndim {
            loc1[i] = loc1[i] + 1
            if (loc1[i] > npix[i])
               loc1[i] = 1
            else
               break
         }
         index2 = 0
         do i = ndim,2,-1 
            index2 = index2 + njout[i-1]*(loc1[order[i]] - 1)
         index2 = index2 + loc1[order[1]] 

         # Now move the pixel over

         Memd[optr+index2-1] = Memd[iptr+index1-1]
      }
end

                   

procedure ndtrnx(iptr,optr,ndim,npix,order)

# Parameters

pointer iptr,optr
int ndim,npix[ndim],order[ndim]

# Local variables

int njout[IM_MAXDIM],i,ntot,index1,loc1[IM_MAXDIM],index2

begin

      # Begin by calculating the number of pixels in each dimension.
      # Also count the total number of pixels to be transposed...

      njout[1] = npix[order[1]]
      do i = 2,ndim {
         njout[i] = njout[i-1]*npix[order[i]]
      }
      ntot = njout[ndim]

      # Initialise location counters...

      do i = 1,ndim
         loc1[i] = 1
      loc1[1] = 0

      # Now loop for the pixels 

      do index1 = 1,ntot {
         
         # Find where in the hyper-cubes each pixel belongs...

         do i = 1,ndim {
            loc1[i] = loc1[i] + 1
            if (loc1[i] > npix[i])
               loc1[i] = 1
            else
               break
         }
         index2 = 0
         do i = ndim,2,-1 
            index2 = index2 + njout[i-1]*(loc1[order[i]] - 1)
         index2 = index2 + loc1[order[1]] 

         # Now move the pixel over

         Memx[optr+index2-1] = Memx[iptr+index1-1]
      }
end


                 
