include <imhdr.h>
include <fset.h>
include <mwset.h>

procedure t_ndtrans()

# Local variables

pointer sp,ifile,ofile,iptr,optr,trcodei,trcodeo,chord,mw,ltr,cd,r,w,ltm,
   ltv,ncd,nr,temp,temp1,temp2
int ndim,odims[IM_MAXDIM],i,nchar,index,len_blk,idims[IM_MAXDIM],nread,
   order[IM_MAXDIM],pdim,ival,axbits
char cnum
bool verbose

# Functions

pointer immap(),rt_crfile(),mw_openim()
int strlen(),itoc(),stridx(),clgeti(),fstati(),imaccf(),mw_stati()
bool clgetb(),envgetb()

begin

      # Mark and allocate stack workspace

      call smark(sp)
      call salloc(ifile,SZ_FNAME,TY_CHAR)
      call salloc(trcodei,SZ_LINE,TY_CHAR)
      call salloc(trcodeo,SZ_LINE,TY_CHAR)
      call salloc(chord,SZ_LINE,TY_CHAR)
      call salloc(ofile,SZ_FNAME,TY_CHAR)

      # Flush buffered output immediately

      if (fstati(STDOUT,F_REDIR) == NO) call fseti(STDOUT,F_FLUSHNL,YES)

      # Open the input file

      call clgstr("input",Memc[ifile],SZ_FNAME)
      iferr(iptr = immap(Memc[ifile],READ_ONLY,0)) call error(0,
         "Couldn't open input file")
      ndim = IM_NDIM(iptr)
      if (ndim < 2) call error(0,"Input file must have at least 2 dimensions")
      do i = 1,ndim
         idims[i] = IM_LEN(iptr,i)

      # Read order for transposition

      call rt_par_arri("order",ndim,nread,order)
      if (nread != ndim) call error(0,
         "Order parameter must have one entry per dimension")
      do i = 1,ndim 
         nchar = itoc(order[i],Memc[chord+i-1],1)
      do i = ndim+1,IM_MAXDIM
         order[i] = i

      # Set output file dimensions
 
      do i = 1,ndim
         odims[i] = IM_LEN(iptr,order[i])

      # Now open the output file...

      call clgstr("output",Memc[ofile],SZ_FNAME)
      iferr (optr = rt_crfile(Memc[ofile],NEW_COPY,iptr,ndim,odims,
         IM_PIXTYPE(iptr))) call error(0,"Couldn't open output file")

      # Get the maximum size of a block to transfer and verbose parameter
    
      len_blk = clgeti("len_blk")
      verbose = clgetb("verbose")

      # Do the transposition...

      call sub_ndtrans(iptr,ndim,idims,order,len_blk,verbose,optr)

      # Update the image WCS...

      if (!envgetb("nomwcs")) {
         mw = mw_openim(iptr)
         pdim = mw_stati(mw,MW_NPHYSDIM)
         ival = 2**pdim - 1
         call bitpak(ival,axbits,1,pdim)

         # Get workspace for wcs transposition

         call salloc(ltr,pdim*pdim,TY_DOUBLE)
         call salloc(cd,pdim*pdim,TY_DOUBLE)
         call salloc(r,pdim,TY_DOUBLE)
         call salloc(w,pdim,TY_DOUBLE)
         call salloc(ltm,pdim*pdim,TY_DOUBLE)
         call salloc(ltv,pdim,TY_DOUBLE)
         call salloc(ncd,pdim*pdim,TY_DOUBLE)
         call salloc(nr,pdim,TY_DOUBLE)
         call salloc(temp,pdim*pdim,TY_DOUBLE)
         call salloc(temp1,pdim,TY_DOUBLE)
         call salloc(temp2,pdim,TY_DOUBLE)

         # Transpose WCS info and write it in...

         call ndmwtrans(mw,pdim,axbits,order,Memd[ltr],Memd[cd],Memd[r],
            Memd[w],Memd[ltm],Memd[ltv],Memd[ncd],Memd[nr],Memd[temp],
            Memd[temp1],Memd[temp2])
         call mw_saveim(mw,optr)
         call mw_close(mw)
      }

      # If there is a flag in the file header for a previous transposition, then
      # update it.

      if (imaccf(optr,"trcode") == YES) {
         call imgstr(optr,"trcode",Memc[trcodei],SZ_LINE)
         do i = 1,strlen(Memc[chord]) {
            nchar = itoc(i,cnum,1)
            index = stridx(cnum,Memc[chord])
            Memc[trcodeo+index-1] = Memc[trcodei+i-1]
         }
      }
      else {
         call strcpy(Memc[chord],Memc[trcodeo],SZ_LINE)
      }
      call imastr(optr,"trcode",Memc[trcodeo])

      # Unmap the files

      call imunmap(iptr)
      call imunmap(optr)

      # Ditch workspace

      call sfree(sp)
end


procedure sub_ndtrans(iptr,ndim,idims,order,len_blk,verbose,optr)

# Parameters

pointer iptr,optr
int ndim,len_blk,idims[IM_MAXDIM],order[IM_MAXDIM]
bool verbose

# Local variables

long one_l,vsin[IM_MAXDIM],vsout[IM_MAXDIM],vein[IM_MAXDIM],veout[IM_MAXDIM],
   zero_l
int i,j,nblock,nb[IM_MAXDIM],ib[IM_MAXDIM],npix[IM_MAXDIM]
pointer ptr1,ptr2

# Functions

pointer imggss(),imggsi(),imggsl(),imggsr(),imggsd(),imggsx()
pointer impgss(),impgsi(),impgsl(),impgsr(),impgsd(),impgsx()

begin

      # Initial all the dimensional arrays

      one_l = 1
      zero_l = 0
      call amovkl(zero_l,vsin,IM_MAXDIM)
      call amovkl(zero_l,vein,IM_MAXDIM)
      call amovkl(zero_l,vsout,IM_MAXDIM)
      call amovkl(zero_l,veout,IM_MAXDIM)

      # Break the (hyper-)cubes into blocks.  Find out how many
      # blocks there will be...

      nblock = 1
      do i = 1,ndim { 
         nb[i] = IM_LEN(iptr,i)/len_blk + 1
         nblock = nblock*nb[i]
         ib[i] = 1
      }
      ib[1] = 0

      # Send a friendly message if one is requested...

      if (verbose) {
         call printf("The data array will be transferred in %d blocks\n")
         call pargi(nblock)
         call printf(" \n")
      }

      # Now loop for the blocks...

      do i = 1,nblock {
     
         # Which block is this?

         do j = 1,ndim {
            ib[j] = ib[j] + 1
            if (ib[j] > nb[j]) 
               ib[j] = 1
            else
               break
         }

         # Now set the limits for the block

         do j = 1,ndim {
            vsin[j] = len_blk*(ib[j] - 1) + 1
            if (vsin[j] > idims[j]) vsin[j] = 1
            vein[j] = vsin[j] + len_blk - 1
            if (vein[j] > idims[j]) vein[j] = idims[j]
         }
         do j = 1,ndim {
            vsout[j] = vsin[order[j]]
            veout[j] = vein[order[j]]
         }

         # What is the length of each side of the block?

         do j = 1,ndim
            npix[j] = vein[j] - vsin[j] + 1

         # Grab the data sections.  Switch for data type... Then
         # do the transposition...

         switch (IM_PIXTYPE(optr)) {
         case TY_SHORT:
            ptr1 = imggss(iptr,vsin,vein,ndim)
            ptr2 = impgss(optr,vsout,veout,ndim)
            call ndtrns(ptr1,ptr2,ndim,npix,order)
         case TY_INT:
            ptr1 = imggsi(iptr,vsin,vein,ndim)
            ptr2 = impgsi(optr,vsout,veout,ndim)
            call ndtrni(ptr1,ptr2,ndim,npix,order)
         case TY_USHORT, TY_LONG:
            ptr1 = imggsl(iptr,vsin,vein,ndim)
            ptr2 = impgsl(optr,vsout,veout,ndim)
            call ndtrnl(ptr1,ptr2,ndim,npix,order)
         case TY_REAL:
            ptr1 = imggsr(iptr,vsin,vein,ndim)
            ptr2 = impgsr(optr,vsout,veout,ndim)
            call ndtrnr(ptr1,ptr2,ndim,npix,order)
         case TY_DOUBLE:
            ptr1 = imggsd(iptr,vsin,vein,ndim)
            ptr2 = impgsd(optr,vsout,veout,ndim)
            call ndtrnd(ptr1,ptr2,ndim,npix,order)
         case TY_COMPLEX:
            ptr1 = imggsx(iptr,vsin,vein,ndim)
            ptr2 = impgsx(optr,vsout,veout,ndim)
            call ndtrnx(ptr1,ptr2,ndim,npix,order)
         default:
            call error(0,"unknown pixel type")
         }

         # Send a message...

         if (verbose) {
            call printf("%d blocks done out of %d\n")
            call pargi(i)
            call pargi(nblock)
         }
      } # end of the block loop
end

procedure ndmwtrans(mw,pdim,axbits,order,ltr,cd,r,w,ltm,ltv,ncd,nr,temp,
   temp1,temp2)

# Parameters

pointer mw
int axbits,pdim,order[pdim]
double ltr[pdim,pdim],cd[pdim,pdim],r[pdim],w[pdim],ltm[pdim,pdim],
   ltv[pdim],ncd[pdim,pdim],nr[pdim],temp[pdim,pdim],temp1[pdim],temp2[pdim]

# Local variables

int axes[IM_MAXDIM],axmap,szatstr,naxes,j,j1,j2,i,i1,i2,axval[IM_MAXDIM]
pointer sp,attrib[IM_MAXDIM],atstr[IM_MAXDIM],mwtmp
bool breakout

# Functions

int mw_stati(),itoc(),strlen()
pointer mw_open()

begin

      # Get some workspace

      call smark(sp)
      do i = 1,pdim
         call salloc(attrib[i],SZ_LINE,TY_CHAR)

      # Convert axis bitflags to the axis lists.

      call mw_gaxlist(mw,axbits,axes,naxes)
      if (naxes < 2) return

      # Switch off axis mapping

      axmap = mw_stati(mw,MW_USEAXMAP)
      call mw_seti(mw,MW_USEAXMAP,NO)
      szatstr = SZ_LINE

      # Get the Wterm which corresponds to the original logical to
      # world transformation.

      call mw_gwtermd(mw,r,w,cd,pdim)
      call mw_gltermd(mw,ltm,ltv,pdim)
      call mwvmuld(ltm,r,nr,pdim)
      call aaddd(nr,ltv,nr,pdim)
      call mwinvertd(ltm,ltr,pdim)
      call mwmmuld(cd,ltr,ncd,pdim)

      # Define which physical axes the logical axes correspond to and
      # transpose the above Wterm.

      call amovd(ncd,temp,pdim*pdim)
      call amovd(w,temp1,pdim)
      call amovd(nr,temp2,pdim)
      do j = 1,naxes {
         j1 = axes[j]
         j2 = axes[order[j]]
         do i = 1,naxes {
            i1 = axes[i]
            i2 = axes[order[i]]
            temp[i1,j1] = ncd[i2,j2]
         }
         temp1[j1] = w[j2]
         temp2[j1] = nr[j2]
      }
      call amovd(temp,ncd,pdim*pdim)
      call amovd(temp1,w,pdim)
      call amovd(temp2,nr,pdim)


      # Perform the transpose of the Lterm.

      call mw_mkidmd(ltr,pdim)
      do j = 1,naxes {
         if (j != order[j]) {
            j1 = axes[j]
            j2 = axes[order[j]]
            ltr[j1,j1] = 0.0d0
            ltr[j1,j2] = 1.0d0
         }
      }
      call aclrd(ltv,pdim)
      call aclrd(r,pdim)
      call mw_translated(mw,ltv,ltr,r,pdim)

      # Get the new Lterm, recompute the Wterm and store it.

      call mw_gltermd(mw,ltm,ltv,pdim)
      call mwmmuld(ncd,ltm,cd,pdim)
      call mwinvertd(ltm,ltr,pdim)
      call asubd(nr,ltv,r,pdim)
      call mwvmuld(ltr,r,nr,pdim)
      call mw_swtermd(mw,nr,w,cd,pdim)

      # Make a new temporary wcs and set the system name.

      mwtmp = mw_open(NULL,pdim)
      call mw_gsystem(mw,Memc[attrib[1]],SZ_LINE)
      iferr (call mw_newsystem(mwtmp,Memc[attrib[1]],pdim))
         call mw_ssystem(mwtmp,Memc[attrib[1]])

      # Copy the wterm and the lterm to it.

      call mw_gwtermd(mw,r,w,ltr,pdim)
      call mw_swtermd(mwtmp,r,w,ltr,pdim)
      call mw_gltermd(mw,ltr,r,pdim)
      call mw_sltermd(mwtmp,ltr,r,pdim)

      # Set the axis map and the axis types.

      call mw_gaxmap(mw,axes,axval,pdim)
      call mw_saxmap(mwtmp,axes,axval,pdim)
      do i = 1,naxes {
         j = axes[i]
         iferr (call mw_gwattrs(mw,j,"wtype",Memc[attrib[j]],SZ_LINE))
            call strcpy("linear",Memc[attrib[j]],SZ_LINE)
      }
      do i = 1,naxes {
         j1 = axes[order[i]]
         j2 = axes[i]
         call mw_swtype(mwtmp,j2,1,Memc[attrib[j1]],"")
      }
         
      # Copy the axis attributes

      do i = 1,pdim
         call malloc(atstr[i],szatstr,TY_CHAR)
      for (i = 1; ; i = i + 1) {
         do j = 1,pdim 
            if (itoc(i,Memc[attrib[j]],SZ_LINE) <= 0)
               Memc[attrib[j]] = EOS
         repeat {
            do j = 1,naxes
               iferr (call mw_gwattrs(mw,axes[j],Memc[attrib[j]],
                  Memc[atstr[j]],szatstr))
                  Memc[atstr[j]] = EOS
            breakout = true
            do j = 1,pdim {
               if (strlen(Memc[atstr[j]]) > szatstr) {
                  breakout = false
                  break
               }
            }
            if (breakout) 
               break
            else {
               szatstr = szatstr + SZ_LINE
               do j = 1,pdim
                  call realloc(atstr[i],szatstr,TY_CHAR)
            }
         }
         breakout = true
         do j = 1,pdim {
            if (Memc[atstr[j]] != EOS) {
               breakout = false
               break
            }
         }
         if (breakout)
            break
         else {
            do j = 1,naxes {
               j1 = axes[j]
               j2 = axes[order[j]]
               if (Memc[atstr[j2]] != EOS)  
                  call mw_swattrs(mwtmp,j1,Memc[attrib[j2]],Memc[atstr[j2]])
            }
         }
      }
      do j = 1,pdim
         call mfree(atstr[j],TY_CHAR)
      call mw_close(mw)

      # Delete the old wcs and set equal to the new one.

      call sfree(sp)
      mw = mwtmp
      call mw_seti(mw,MW_USEAXMAP,axmap)
end
