define BIASXSKIP  6.0
define BIASYSKIP  101.0

procedure bdsecttek(data,nd,mode,value)

# Parameters

double data[nd]
int nd,mode
char value[ARB]

# Local variables

bool wm
real axs,xs,ays,ys,axe,aye,dxs,dxe,dys,dye,xb,yb,x1,x2,y1,y2,len,bxs,bxe,
   bys,bye

begin

      # First see if you are in windowing mode...

      wm = (nint(data[1]) == 1)

      # Define the light sensitive part of the chip

      axs = real(data[2])
      xs = real(data[3])
      ays = real(data[4])
      ys = real(data[5])
      axe = axs + xs - 1.0
      aye = ays + ys - 1.0

      # Define the section of the chip that was actually read out, assuming that
      # windowing has been enabled.

      if (wm) {
         dxs = real(data[6])
         xs = real(data[7])
         dys = real(data[8])
         ys = real(data[9])
         dxe = dxs + xs
         dxs = dxs + 1
         dye = dys + ys
         dys = dys + 1
         xb = real(data[10])
         yb = real(data[11])
      }  else {
         dxs = 1.0
         dys = 1.0
         dxe = real(data[12])
         dye = real(data[13])
         xb = 1.0
         yb = 1.0
      }

      # Ok, if the mode variable is 1, then calculate the data section...

      switch (mode) {
         case 1:
            x1 = (axs - dxs)/xb + 1.0
            x1 = max(1.0,x1)
            len = (min(axe,dxe) - max(axs,dxs) + 1.0)/xb
            x2 = x1 + len - 1.0
            y1 = (ays - dys)/yb + 1.0
            y1 = max(1.0,y1)
            len = (min(aye,dye) - max(ays,dys) + 1.0)/yb
            y2 = y1 + len - 1.0
            call sprintf(value,ARB,"[%d:%d,%d:%d]")
               call pargi(nint(x1))
               call pargi(nint(x2))
               call pargi(nint(y1))
               call pargi(nint(y2))
         case 2:
            bxs = BIASXSKIP
            bxe = axs - BIASXSKIP
            bys = BIASYSKIP
            bye = real(data[13]) - BIASYSKIP
            if (dxs > bxe) 
               call error(1,"The bias strip has been windowed out")

            # Now define the bias strip limits based on header info

            x1 = (bxs - dxs)/xb + 1.0
            x1 = max(1.0,x1)
            len = (min(bxe,dxe) - max(bxs,dxs) + 1.0)/xb
            x2 = x1 + len - 1.0
            y1 = (bys - dys)/yb + 1.0
            y1 = max(1.0,y1)
            len = (min(bye,dye) - max(bys,dys) + 1.0)/yb
            y2 = y1 + len - 1.0
            call sprintf(value,SZ_LINE,"[%d:%d,%d:%d]")
               call pargi(nint(x1))
               call pargi(nint(x2))
               call pargi(nint(y1))
               call pargi(nint(y2))
      }
end

procedure bdsectaat(data,nd,mode,outstr,maxch)

# Parameters

int nd,mode,maxch
double data[nd]
char outstr[ARB]

# Local variables

int x1d,x2d,y1d,y2d,x1b,x2b,y1b,y2b,x1,x2,y1,y2,cs,comb1,comb2

begin

      # First see which combination yields the largest area.  Assume
      # that that is the data section...

      comb1 = abs(nint((data[2] - data[1])*(data[4] - data[3])))
      comb2 = abs(nint((data[6] - data[5])*(data[8] - data[7])))

      # Begin by getting all the info you need

      if (comb1 > comb2) {
         x1d = nint(data[1])
         x2d = nint(data[2])
         y1d = nint(data[3])
         y2d = nint(data[4])
         x1b = nint(data[5])
         x2b = nint(data[6])
         y1b = nint(data[7])
         y2b = nint(data[8])
      } else {
         x1b = nint(data[1])
         x2b = nint(data[2])
         y1b = nint(data[3])
         y2b = nint(data[4])
         x1d = nint(data[5])
         x2d = nint(data[6])
         y1d = nint(data[7])
         y2d = nint(data[8])
      }

      # Which case are you dealing with...

      if (x1b > x1d) 
         cs = 1
      else if (x1b < x1d)
         cs = 2
      else {
         if (y1b < y1d)
            cs = 3
         else
            cs = 4
      }

      # Switch for case

      switch (cs) {

         # Bias strip is on the right 

         case 1:
            if (mode == 1) {
               x1 = 1
               x2 = x2d - x1d + 1
               y1 = 1
               y2 = y2d - y1d + 1
            } else {
               x1 = x2d - x1d + 2
               x2 = x1 + (x2b - x1b + 1)
               x1 = x1 + BIASXSKIP - 1
               x2 = x2 - BIASXSKIP + 1
               y1 = BIASYSKIP
               y2 = y2b - y1b + 1 - BIASYSKIP
            }
    
         # Bias strip is on the left

         case 2:
            if (mode == 1) {
               x1 = x2b - x1b + 2
               x2 = x1 + (x2d - x1d + 1)
               y1 = 1
               y2 = y2d -y1d + 1
            } else {
               x1 = BIASXSKIP
               x2 = x2b - x1b + 1 - BIASXSKIP
               y1 = BIASYSKIP
               y2 = y2b - y1b + 1 - BIASYSKIP
            }

         # Bias strip on the bottom

         case 3:
            if (mode == 1) {
               x1 = 1
               x2 = x2d - x1d + 1
               y1 = y2b - y1b + 2
               y2 = y1 + (y2d - y1d + 1)
            } else {
               x1 = BIASYSKIP
               x2 = x2b - x1b + 1 - BIASYSKIP
               y1 = BIASXSKIP
               y2 = y2b - y1b + 1 - BIASXSKIP
            }

         # Bias strip on the top

         case 4:
            if (mode == 1) {
               x1 = 1
               x2 = x2d - x1d + 1
               y1 = 1 
               y2 = y2d - y1d + 1
            } else {
               x1 = BIASYSKIP
               x2 = x2b - x1b + 1 - BIASYSKIP
               y1 = y2d - y1d + 2
               y2 = y1 + (y2b - y1b + 1)
               y1 = y1 + BIASXSKIP - 1
               y2 = y2 - BIASXSKIP + 1
            }
      }

      # Format the output string

      call sprintf (outstr,maxch,"[%d:%d,%d:%d]")
         call pargi(x1)
         call pargi(x2)
         call pargi(y1)
         call pargi(y2)
end
