procedure i_initid(input,isect,autoid)

file    input     {prompt="Name of input file"}
int     isect     {prompt="Which line?"}
int     autoid    {prompt="What level of automation in id?"}
file    coordlist {prompt="Name of arcline file"}
real    cenwave   {prompt="Approximate central wavelength"}
real    disper    {prompt="Approximate dispersion"}
int     dflip     {prompt="Direction of dispersion"}

pset    *rpars = ""

begin

      file in
      int is,aid,nsol

      # Get the query parameters

      in = input
      is = isect
      aid = autoid

      # For non-automatic identifications, call the identify routine
      # and do the id by hand...

      if (aid >= 2) {
         identify(in,section="line "//is,database=database,
            coordlist=coordlist,units="",nsum=1,match=rpars.match,
            maxfeatures=rpars.maxfeatures,zwidth=100.0,ftype="emission",
            fwidth=rpars.fwidth,cradius=rpars.cradius,
            threshold=rpars.cthresh,minsep=rpars.sep,
            function=rpars.i_function,order=rpars.i_order,sample="*",
            niterate=rpars.niterate,low_rej=rpars.i_low,
            high_rej=rpars.i_high,grow=0,autowrite=yes,
            graphics="stdgraph",cursor="",aidpars="")

      # Otherwise call the automatic routine.  If it succeeds use identify to
      # do the fit.  If it fails, then get the user to identify the lines by
      # hand.

      } else {
         autoarc.disp = disper
         autoarc(in,is,1,apshift=0.0,coordlist=coordlist,arclog="",
            dflip=dflip,cenwave=cenwave) | scan(nsol)
         if (nsol > 0) {
            print("f \n q \n l \n f \n q \n q \n") |
               identify(in,section="line "//is,database=database,
                  coordlist=coordlist,units="",nsum=1,match=rpars.match,
                  maxfeatures=rpars.maxfeatures,zwidth=100.0,ftype="emission",
                  fwidth=rpars.fwidth,cradius=rpars.cradius,
                  threshold=rpars.cthresh,minsep=rpars.sep,
                  function=rpars.i_function,order=rpars.i_order,sample="*",
                  niterate=rpars.niterate,low_rej=rpars.i_low,
                  high_rej=rpars.i_high,grow=0,autowrite=yes,
                  cursor="STDIN",aidpars="", >G "dev$null", >& "dev$null")
         } else {
            print("Automatic arc id routine failed -- do id by hand")
            identify(in,section="line "//is,database=database,
               coordlist=coordlist,units="",nsum=1,match=rpars.match,
               maxfeatures=rpars.maxfeatures,zwidth=100.0,ftype="emission",
               fwidth=rpars.fwidth,cradius=rpars.cradius,
               threshold=rpars.cthresh,minsep=rpars.sep,
               function=rpars.i_function,order=rpars.i_order,sample="*",
               niterate=rpars.niterate,low_rej=rpars.i_low,
               high_rej=rpars.i_high,grow=0,autowrite=yes,
               graphics="stdgraph",cursor="",aidpars="")
         }
      }

end            
