procedure i_reid(refname,input,nspec)

file    refname     {prompt="Name of reference image"}
file    input       {prompt="Name of input image"}
int     nspec       {prompt="Number of spectra?"}
file    coordlist   {prompt="Name of coordinate list"}

pset    *rpars = ""

begin

      file rname,in
      int ns,is

      # Get the query parameters

      rname = refname
      in = input
      ns = nspec

      # Call the reidentification task. If the files are different, then
      # use IDENTIFY and cross-correlate the peaks.  If not, then try
      # using REIDENTIFY.

      if (rname != in) {
         for (is = 1; is <= ns; is += 1) {
            printf(":read %s %d \n a \n c \n f \n q \n l \n f \n q \n q \n",rname,is) | 
               identify(in,section="line "//is,database=database,
                  coordlist=coordlist,units="",nsum=1,match=rpars.match,
                  maxfeatures=rpars.maxfeatures,zwidth=100.0,ftype="emission",
                  fwidth=rpars.fwidth,cradius=rpars.cradius,
                  threshold=rpars.cthresh,minsep=rpars.sep,
                  function=rpars.i_function,order=rpars.i_order,sample="*",
                  niterate=rpars.niterate,low_rej=rpars.i_low,
                  high_rej=rpars.i_high,grow=0,autowrite=yes,
                  cursor="STDIN",aidpars="",>G "dev$null", >& "dev$null")
         }
      } else { 
         reidentify(rname,in,interactive=no,section="line 1",
            newaps=no,override=no,refit=yes,trace=no,step=1,
            nsum=1,shift=0.0,nlost=0,cradius=rpars.cradius,
            threshold=rpars.cthresh,addfeatures=yes,coordlist=coordlist,
            match=rpars.match,maxfeatures=rpars.maxfeatures,
            minsep=rpars.sep,database=database,logfile="STDOUT",plotfile="",
            verbose=yes,graphics="stdgraph",cursor="",aidpars="")
      }
end
