# Parameters for FOS2

spec1.telescope = "WHT"
spec1.maxords = 2
spec1.dispaxis = 2
spec1.guifile = "spec1$std.gui"
spec1.observatory = "lapalma"
spec1.extfile = "rgo$flux/lpoext.tab"

rpars.interactive = no
rpars.recenter = yes
rpars.resize = yes
rpars.edit = no
rpars.fittrace = no
rpars.review = no

rpars.line = 150
rpars.nsum = -20

rpars.extras  =  no

rpars.lower = -4.0
rpars.upper = 4.0

rpars.b_function = "legendre"
rpars.b_order = 2
rpars.b_sample = ""
rpars.maxsky = 12
rpars.bufsky = 0
rpars.b_naverage = -3
rpars.b_niterate = 1
rpars.b_low_reject = 3
rpars.b_high_reject = 3
rpars.b_grow = 0

rpars.nspec = 2
rpars.fedge = 0.1
rpars.width = 5.0
rpars.radius = 10.0
rpars.nsig = 4.0

rpars.minsep = 30
rpars.maxsep = 200
rpars.order = "increasing"

rpars.npeaks = INDEF
rpars.shift = no

rpars.llimit = INDEF
rpars.ulimit = INDEF
rpars.ylevel = 0.1
rpars.peak = yes
rpars.bkg = yes
rpars.r_grow = 0.0
rpars.avglimits = no

rpars.t_nsum = 10
rpars.t_step = 10
rpars.t_nlost = 3
rpars.t_width = 5.0
rpars.t_function = "spline3"
rpars.t_sample = "*"
rpars.t_order = 3
rpars.t_naverage = 1
rpars.t_niterate = 1
rpars.t_low_reject = 3
rpars.t_high_reject = 3
rpars.t_grow = 0
                          
rpars.background = "fit"
rpars.skybox = 1
rpars.weights = "variance"
rpars.pfit = "fit1d"
rpars.clean = yes
rpars.nclean = 0.5
rpars.niterate = 1
rpars.saturation = INDEF
rpars.readnoise = 9.9
rpars.gain = 2.3
rpars.lsigma = 3.0
rpars.usigma = 3.0
rpars.nsubaps = 1

rpars.select = "interp"
rpars.sort = "jd"
rpars.time = no
rpars.timewrap = 17

rpars.match = 2
rpars.fwidth = 4
rpars.cradius = 5 
rpars.cthresh = 10.0
rpars.sep = 2.0
rpars.contrast = 0.05
rpars.edge = 1  
rpars.maxfeatures = 50
rpars.pkthresh = 10.0
rpars.i_function = "chebyshev"
rpars.i_order = 3
rpars.i_niterate = 1
rpars.i_low = 3.0
rpars.i_high = 3.0

rpars.linearize = yes
rpars.log = no
rpars.flux = yes

refspectra.group = ""

idpars.dfrac = 0.05
idpars.ndisp = 31
idpars.limit_angle = 1.40 
idpars.ns_select = 3
idpars.ng_select = 10
idpars.test_stat = 1
idpars.wfact = 1.0
idpars.padding = 0.1

crzap.xboxsz = 2
crzap.yboxsz = 11

instrpars.cenwave = "fos2cw()"
instrpars.disp_app = "fos2disp()"
instrpars.dflip = "-1"
instrpars.trimsec = "bdsect(CCDWMODE,CCDXIMST,CCDXIMSI,CCDYIMST,CCDYIMSI,CCDWXO1,CCDWXS1,CCDWYO1,CCDWYS1,CCDXBIN,CCDYBIN,CCDXSIZE,CCDYSIZE,1,CCDCHIP)"
instrpars.biassec = "bdsect(CCDWMODE,CCDXIMST,CCDXIMSI,CCDYIMST,CCDYIMSI,CCDWXO1,CCDWXS1,CCDWYO1,CCDWYS1,CCDXBIN,CCDYBIN,CCDXSIZE,CCDYSIZE,2,CCDCHIP)"
instrpars.ra = "RA"
instrpars.dec = "DEC"
instrpars.epoch = "EPOCH"
instrpars.ut = "UTOBS"
instrpars.st = "ST"
instrpars.date_obs = "DATE_OBS"
instrpars.exposure = "EXPTIME"

keep
