procedure iterstat(image)

string  image   {prompt="Input image(s)"}
real    nsigrej {5.,min=0.,prompt="Number of sigmas for limits"}
int     maxiter {10,min=1,prompt="Maximum number of iterations"}
bool    verbose {yes,prompt="Show results of iterations?"}
real    lower   {INDEF,prompt="Initial lower limit for data range"}
real    upper   {INDEF,prompt="Initial upper limit for data range"}

struct  *inimglist

begin

      string  imglist         # equals image
      string  infile          # temporary list for files
      string  img             # image name from fscan
      real    mn              # mean from imstat
      real    sig             # stddev from imstat
      real    med             # midpt from imstat
      real    mod             # mode from imstat
      real    ll              # lower limit for imstat
      real    ul              # upper limit for imstat
      int     nx, npx         # number of pixels used
      int     m               # dummy for countdown

      # Get query parameter

      imglist = image

      # Expand file lists into temporary files.

      infile =  mktemp("tmp$iterstat")
      sections(imglist,option="fullname",>infile)
      inimglist = infile

      # Loop through images

      while (fscan(inimglist,img) != EOF) {
         imstat(img,fields="mean,stddev,npix,midpt,mode",
            lower=lower,upper=upper,format=no) | scan(mn,sig,npx,med,mod)
         m = 1
         while (m <= maxiter)  {
            if (verbose)
               print(img,": mean=",mn," rms=",sig," npix=",npx,
                    " median=",med," mode=",mod)
            ll = mn - (nsigrej*sig)
            ul = mn + (nsigrej*sig)
            if (lower != INDEF && ll < lower) 
               ll = lower
            if (upper != INDEF && ul > upper) 
               ul = upper
            imstat(img,fields="mean,stddev,npix,midpt,mode",
               lower=ll,upper=ul,format=no) | scan(mn,sig,nx,med,mod)
            if (nx == npx)
               break
            npx = nx
            m = m + 1
         }

         print(" ",img,": mean= ",mn," rms= ",sig," npix= ",npx,
            " median= ",med," mode= ",mod)
      }
      delete(infile,verify=no)
      inimglist = ""
end
