#{ ING 1d spectral reduction package

# Load packages

images
noao
imred
ccdred
onedspec
utilities
if (deftask("tables")) {
   if (defpar("tables.motd"))  
      tables.motd = no
   tables
} else {
   error(0,"You must have TABLES available on your system")
}

package spec1

# Tasks

task     aatfors    = "spec1$x_spec1.e"
task     aatrgo     = "spec1$x_spec1.e"
task     apscript   = "spec1$x_apextract.e"
task     arcstat    = "spec1$x_spec1.e"
task     autoarc    = "spec1$x_spec1.e"
task     backsamps  = "spec1$x_spec1.e"
task     crzap      = "spec1$crzap.cl"
task     evalexpr   = "spec1$x_spec1.e"
task     filllist   = "spec1$x_spec1.e"
task     fos1       = "spec1$x_spec1.e"
task     fos2       = "spec1$x_spec1.e"
task     illumination = "spec1$x_spec1.e"
task     iterstat   = "spec1$iterstat.cl"
task     i_reid     = "spec1$i_reid.cl"
task     i_initid   = "spec1$i_initid.cl"
task     ids        = "spec1$x_spec1.e"
task     isis       = "spec1$x_spec1.e"
task     logtex     = "spec1$logtex.cl"
task     mkapid     = "spec1$x_spec1.e"
task     mkarclog   = "spec1$x_spec1.e"
task     mksens     = "spec1$mksens.cl"
task     preccd     = "spec1$preccd.cl"
task     profile    = "spec1$x_spec1.e"
task     response   = "spec1$x_spec1.e"
task     rspecred   = "spec1$rspecred.cl"
task     runlog     = "spec1$x_spec1.e"
task     sarclog    = "spec1$x_spec1.e"
task     setup      = "spec1$setup.cl"
task     stddir     = "spec1$x_spec1.e"
task     stdname    = "spec1$stdname.cl"
task     strpextn   = "spec1$strpextn.cl"
task     tippex     = "spec1$tippex.cl"

# Psets

task     cenpars    = "spec1$cenpars.par"
task     idpars     = "spec1$idpars.par"
task     rpars      = "spec1$rpars.par"
task     instrpars  = "spec1$instrpars.par"
task     promptme   = "spec1$promptme.par"

# Hidden tasks

hidetask apscript,evalexpr,filllist,preccd,strpextn,mkarclog,sarclog,instrpars
hidetask i_reid,i_initid,tippex,arcstat,rspecred,runlog,cenpars,idpars
hidetask iterstat,crzap,stdname,stddir,mkapid,profile,backsamps
hidetask promptme,illumination,response

# Apextract tasks

task    apall,
        apedit,
        apfind,
        apfit,
        apflatten,
        apmask,
        apnormalize,
        aprecenter,
        apresize,
        apscatter,
        apsum,
        aptrace         = "apextract$x_apextract.e"
task    apparams        = "apextract$apparams.par"
task    apall1          = "apextract$apall1.par"
task    apfit1          = "apextract$apfit1.par"
task    apflat1         = "apextract$apflat1.par"
task    apnorm1         = "apextract$apnorm1.par"
task    apdefault       = "apextract$apdefault.par"
task    apscat1         = "apextract$apscat1.par"
task    apscat2         = "apextract$apscat2.par"

hidetask apall,apedit,apfind,apfit,apflatten,apmask,apnormalize,aprecenter
hidetask apresize,apscatter,apsum,aptrace,apparams,apall1,apfit1,apflat1
hidetask apnorm1,apdefault,apscat1,apscat2

clbye
