include <error.h>        

procedure t_arcstat()

# Local variables

pointer sp,iname,rootname,dbname,line,slist,junkstr,dt,outfile,optr
int fd,apnum,ispec,record,nfeat,ntot,i,iwt,junkint,iref
real sum,sumsq,junkr,w1,w2,resid,mean,sig

# Functions

int open(),fscan(),dtlocate(),dtgeti(),dtscan(),clgeti()
pointer immap()
                     
begin

      # Get some workspace

      call smark(sp)
      call salloc(iname,SZ_FNAME,TY_CHAR)
      call salloc(rootname,SZ_FNAME,TY_CHAR)
      call salloc(dbname,SZ_FNAME,TY_CHAR)
      call salloc(line,SZ_LINE,TY_CHAR)
      call salloc(slist,SZ_FNAME,TY_CHAR)
      call salloc(junkstr,SZ_LINE,TY_CHAR)
      call salloc(outfile,SZ_FNAME,TY_CHAR)

      # Get input file name and database name. Strip any extra rubbish
      # off the input file name. 

      call clgstr("input",Memc[iname],SZ_FNAME)
      call xt_imroot(Memc[iname],Memc[rootname],SZ_FNAME)
      call sprintf(Memc[iname],SZ_LINE,"id%s")
         call pargstr(Memc[rootname])
      call clgstr("database",Memc[dbname],SZ_FNAME)

      # Open the database file...

      dt = NULL
      iferr (call dtremap(dt,Memc[dbname],Memc[iname],READ_ONLY)) {
         call eprintf("Can't map file %s in %s/\n")
            call pargstr(Memc[iname])
            call pargstr(Memc[dbname])
         call erract(EA_ERROR)
      }

      # Open the slist file...

      call clgstr("slistf",Memc[slist],SZ_FNAME)
      iferr (fd = open(Memc[slist],READ_ONLY,TEXT_FILE)) {
         call eprintf("Can't find file %s")
            call pargstr(Memc[slist])
         call erract(EA_ERROR)
      }

      # Open the output file.  This is the header of the object file.  We want
      # to write the rms results here.  If we can't open them then don't bother
      # to write the results to a header.

      call clgstr("outfile",Memc[outfile],SZ_FNAME)
      iferr (optr = immap(Memc[outfile],READ_WRITE,0))
         optr = NULL

      # Is this reference spectrum 1 or 2?

      iref = clgeti("iref")

      # Now loop for each entry in the slist file...

      while (fscan(fd) != EOF) {

         # Get the spectrum number and the aperture number

         call gargwrd(Memc[junkstr],SZ_LINE)
         call gargi(ispec)
         call gargi(apnum)

         # Get database record for aperture and find out how many
         # features were identified

         call sprintf(Memc[line],SZ_LINE,"identify %s - Ap %d")
            call pargstr(Memc[rootname])
            call pargi(apnum)
         iferr (record = dtlocate(dt,Memc[line])) {
            call eprintf("Can't find database record for aperture %d\n")
               call pargi(apnum)
            call erract(EA_ERROR)
         }
         nfeat = dtgeti(dt,record,"features")

         # Now read the feature information and do the required summations
         
         sum = 0.0
         sumsq = 0.0
         ntot = 0
         do i = 1,nfeat {
            junkint = dtscan(dt)
            call gargr(junkr)
            call gargr(w1)
            call gargr(w2)
            call gargr(junkr)
            call gargi(junkint)
            call gargi(iwt)
            if (IS_INDEF(w1) || IS_INDEF(w2)) iwt = 0
            if (iwt > 0) {
               resid = w1 - w2
               sum = sum + resid
               sumsq = sumsq + resid**2
               ntot = ntot + 1
            }
         }

         # Calculate rms.  Deal with error situations...

         if (ntot <= 2) 
            sig = INDEF
         else {
            mean = sum/real(ntot)
            sig = sumsq/real(ntot) - mean*mean
            if (sig < 0.0) 
               sig = INDEF
            else
               sig = sqrt(sig)
         }
         
         # Now report the situation...

         call printf(
            "Spectrum: %d,  Aperture: %d,  No. lines: %d,  RMS error: %0.6g\n")
            call pargi(ispec)
            call pargi(apnum)
            call pargi(ntot)
            call pargr(sig)

         # If the header to an output file exists, then write the result here.

         if (optr != NULL) {
            call sprintf(Memc[junkstr],SZ_LINE,"DCE%03d_%d")
               call pargi(ispec)
               call pargi(iref)
            call imaddr(optr,Memc[junkstr],sig)
         }
      }

      # Free workspace and close things up

      if (optr != NULL) call imunmap(optr)
      call dtunmap(dt)
      call close(fd)
      call sfree(sp)
end
