include <evvexpr.h>
include <error.h>

define SZEXPR 1024

procedure t_evalexpr()

# Local variables

pointer sp,hparam,infile,expr,op,iptr,inlist,pp,tmp
int lgetop,lufcn,ordno,list

# Functions

int locpr(),immap(),imaccf(),clgeti(),imtopen(),imtgetim()
pointer evvexpr(),clopset()

# Common block for input file header pointer and order number

common /iptr/ iptr,ordno

# External subroutines

extern get_op,ufcn

begin

      # Get some workspace

      call smark(sp)
      call salloc(hparam,SZ_LINE,TY_CHAR)
      call salloc(tmp,SZ_LINE,TY_CHAR)
      call salloc(expr,SZEXPR,TY_CHAR)
      call salloc(inlist,SZ_FNAME,TY_CHAR)
      call salloc(infile,SZ_FNAME,TY_CHAR)
      
      # Get the name of the header parameter and the expression
      # needed to form it...The expression should be in the instrpars pset.

      call clgstr("hparam",Memc[hparam],SZ_LINE)
      call strcpy(Memc[hparam],Memc[tmp],SZ_LINE)
      call strlwr(Memc[tmp])
      pp = clopset("instrpars")
      call clgpseta(pp,Memc[tmp],Memc[expr],SZEXPR)
      call clcpset(pp)

      # Get the list of input file names and open it

      call clgstr("inlist",Memc[inlist],SZ_FNAME)
      list = imtopen(Memc[inlist])

      # Get order number

      ordno = clgeti("ordno")

      # Initialise a few things...

      lgetop = locpr(get_op)
      lufcn = locpr(ufcn)

      # Ok, loop for the image list

      while (imtgetim(list,Memc[infile],SZ_FNAME) != EOF) {
         iptr = immap(Memc[infile],READ_WRITE,0)

         # Does the header item already exist?  If so, then get out of here...
 
         if (imaccf(iptr,Memc[hparam]) == YES)
            next

         # Evaluate the expression

         op = evvexpr(Memc[expr],lgetop,NULL,lufcn,NULL,0)

         # Put the value into the header now...

         switch(O_TYPE(op)) {
            case TY_REAL,TY_DOUBLE,TY_COMPLEX:
               call imaddr(iptr,Memc[hparam],O_VALR(op))
            case TY_BOOL,TY_SHORT,TY_INT,TY_LONG:
               call imaddi(iptr,Memc[hparam],O_VALI(op))
            case TY_CHAR:
               call imastr(iptr,Memc[hparam],O_VALC(op))
         }
         call xvv_freeop(op)
         call imunmap(iptr)
      }

      # Get out of here

     call imtclose(list)
     call sfree(sp)
end

procedure get_op(data,operand,op)

# Parameters

char operand[ARB]
pointer op,data

# Local variables

pointer iptr,wptr1,wptr2
int ordno,ip,lbracket,rbracket,maxch,junk,ival
real rval
double dval

# Functions

int imgeti(),imgftype(),stridx(),ctoi(),ctor(),ctod()
real imgetr()
bool imgetb(),streq()

# Common block for input file header pointer and order number

common /iptr/ iptr,ordno

define exit_ 99

begin

      # Get the operand out of the header according to the operand type.

      iferr {
         switch (imgftype(iptr,operand)) {
            case TY_BOOL:
               call xvv_initop(op,0,TY_INT)
               O_VALI(op) = imgetb(iptr,operand)
            case TY_SHORT,TY_INT,TY_LONG:
               call xvv_initop(op,0,TY_INT)
               O_VALI(op) = imgeti(iptr,operand)
            case TY_REAL,TY_DOUBLE,TY_COMPLEX:
               call xvv_initop(op,0,TY_REAL)
               O_VALR(op) = imgetr(iptr,operand)
            default:
               call xvv_initop(op,SZ_LINE,TY_CHAR)
               call imgstr(iptr,operand,O_VALC(op),SZ_LINE)
         }

      # If the operand doesn't exist, then have a look to see if contains
      # <>.  If so, then it's a quoted string...

      } then {
         lbracket = stridx("{",operand)
         rbracket = stridx("}",operand)
         if (lbracket > 0 && rbracket > 0 && lbracket < rbracket) {
            maxch = rbracket - lbracket - 1
            call xvv_initop(op,SZ_LINE,TY_CHAR)
            call strcpy(operand[lbracket+1],O_VALC(op),maxch)
            goto exit_
         }

         # Ok, it's not a quoted string.  Prompt the user for a value and
         # try and make some sort of decsion about the data type.

         call malloc(wptr1,SZ_LINE,TY_CHAR)
         call malloc(wptr2,SZ_LINE,TY_CHAR)
         call promptme(iptr,operand,Memc[wptr1],SZ_LINE)
         call sscan(Memc[wptr1])
            call gargwrd(Memc[wptr2],SZ_LINE)
         call strlwr(Memc[wptr2])

         # First check and see if it's an integer...

         ip = 1
         junk = ctoi(Memc[wptr1],ip,ival)
         if (Memc[wptr1+ip-1] == EOS) {
            call xvv_initop(op,0,TY_INT)
            O_VALI(op) = ival
            call imaddi(iptr,operand,ival)
            goto exit_
         }

         # Next do a similar test to see if it's a real...

         ip = 1
         junk = ctor(Memc[wptr1],ip,rval)
         if (Memc[wptr1+ip-1] == EOS) {
            call xvv_initop(op,0,TY_REAL)
            O_VALR(op) = rval
            call imaddr(iptr,operand,rval)
            goto exit_
         }

         # Next do a similar test to see if it's a double (necessary
         # since some wise-guy will probably try to use a D for exponentiation

         ip = 1
         junk = ctod(Memc[wptr1],ip,dval)
         if (Memc[wptr1+ip-1] == EOS) {
            call xvv_initop(op,0,TY_REAL)
            O_VALR(op) = real(dval)
            call imaddr(iptr,operand,real(dval))
            goto exit_
         }

         # Next, see if object is boolean...

         if (streq(Memc[wptr2],"true") || streq(Memc[wptr2],"yes") 
            || streq(Memc[wptr2],"t") || streq(Memc[wptr2],"y")) {
            call xvv_initop(op,0,TY_INT)
            O_VALI(op) = 1
            call imaddb(iptr,operand,true)
            goto exit_
         } else if (streq(Memc[wptr2],"false") || streq(Memc[wptr2],"no")
            || streq(Memc[wptr2],"f") || streq(Memc[wptr2],"n")) {
            call xvv_initop(op,0,TY_INT)
            O_VALI(op) = 0
            call imaddb(iptr,operand,false)
            goto exit_
         }

         # Nothing else, it must be a string...

         call xvv_initop(op,SZ_LINE,TY_CHAR)
         call strcpy(Memc[wptr1],O_VALC(op),SZ_LINE)
         call imastr(iptr,operand,Memc[wptr1])

         # Exit point for this part of the routine
exit_
         call mfree(wptr1,TY_CHAR)
         call mfree(wptr2,TY_CHAR)
      }
end

