procedure t_filllist()

# Local variables

pointer sp,inlist,outfile,fname1,fname2,extn,list
int fd,nout

# Functions

pointer imtopen()
int access(),open(),imtgetim()
bool streq()

begin

      # Get some workspace

      call smark(sp)
      call salloc(inlist,SZ_LINE,TY_CHAR)
      call salloc(outfile,SZ_FNAME,TY_CHAR)
      call salloc(fname1,SZ_FNAME,TY_CHAR)
      call salloc(fname2,SZ_FNAME,TY_CHAR)
      call salloc(extn,SZ_FNAME,TY_CHAR)

      # Get the input file list and the name of the output file

      call clgstr("inlist",Memc[inlist],SZ_LINE)
      call clgstr("outlist",Memc[outfile],SZ_FNAME)

      # Open the output file.  If it already exists, then ditch the old
      # version and open a new one.

      if (access(Memc[outfile],0,0) == YES) 
         call delete(Memc[outfile])
      fd = open(Memc[outfile],NEW_FILE,TEXT_FILE)

      # Get the defined image extension

      call envgets("imtype",Memc[fname1],SZ_FNAME)
      call sprintf(Memc[extn],SZ_FNAME,".%s")
         call pargstr(Memc[fname1])
      
      # Open the input file list and begin the loop

      list = imtopen(Memc[inlist])
      while (imtgetim(list,Memc[fname1],SZ_FNAME) != EOF) {
      
         # Strip off the image extension if it exists

         call strpextn(fname1,extn,fname2,nout,SZ_FNAME)

         # Now add this file to the output list so long as it isn't a multispec
         # output file.

         if (nout > 3) {
            if (!streq(Memc[fname2+nout-3],".ms")) {
               call fprintf(fd,"%s\n")
                  call pargstr(Memc[fname2])
            }
         } else if (nout > 0) {
            call fprintf(fd,"%s\n")
               call pargstr(Memc[fname2])
         }
      }

      # Close output file

      call close(fd)

      # Tidy and exit

      call imtclose(list)
      call sfree(sp)
end

procedure strpextn(in,extn,out,nout,maxch)

# Parameters

pointer in,out,extn
int nout,maxch

# Local variables

int nextn,nin

# Functions

int strlen()
bool streq()

begin

      # Strip off the extension if it exists

      nextn = strlen(Memc[extn])
      nin = strlen(Memc[in])
      if (nin < nextn)
         call strcpy(Memc[in],Memc[out],maxch)
      else {
         if (streq(Memc[in+nin-nextn],Memc[extn])) 
            call strcpy(Memc[in],Memc[out],nin-nextn)
         else
            call strcpy(Memc[in],Memc[out],maxch)
      }

      # Get output file name length

      nout = strlen(Memc[out])
end
