include <error.h>

procedure t_mkapid()

# Local variables

pointer sp,infile,outfile,title,ra,dec,data,substr,iptr
int nsp,jst,jfn,maxch,len,fd,i
char colon

# Functions

pointer immap()
int clgeti(),access(),stridxs(),strlen(),stridx(),open()

begin

      # Get some workspace

      call smark(sp)
      call salloc(infile,SZ_FNAME,TY_CHAR)
      call salloc(outfile,SZ_FNAME,TY_CHAR)
      call salloc(title,SZ_LINE,TY_CHAR)
      call salloc(ra,SZ_LINE,TY_CHAR)
      call salloc(dec,SZ_LINE,TY_CHAR)
      call salloc(data,SZ_LINE,TY_CHAR)
      call salloc(substr,SZ_LINE,TY_CHAR)

      # Get the input name and open the file...

      call clgstr("input",Memc[infile],SZ_FNAME)
      iferr (iptr = immap(Memc[infile],READ_WRITE,0)) {
         call eprintf("Can't open file %s \n")
            call pargstr(Memc[infile])
         call erract(EA_ERROR)
      }

      # Get the number of spectra and the output apid table name.  If the
      # output file already exists, then blow it away.

      nsp = clgeti("nspec")
      call clgstr("output",Memc[outfile],SZ_FNAME)
      if (access(Memc[outfile],0,0) == YES)
         call delete(Memc[outfile])
      fd = open(Memc[outfile],NEW_FILE,TEXT_FILE)

      # Useful character constant

      colon = ':'

      # Get the RA from the file header if it exists...

      Memc[ra] = EOS
      ifnoerr (call imgstr(iptr,"ra",Memc[data],SZ_LINE)) {
         jst = stridxs("0123456789",Memc[data])
         for (jfn = jst+1; jfn <= strlen(Memc[data]); jfn = jfn + 1) {
            if (stridxs("0123456789:.",Memc[data+jfn-1]) != 1)
               break
         }
         jfn = jfn - 1
         maxch = jfn - jst + 1
         call strcpy(Memc[data+jst-1],Memc[substr],maxch)
         if (stridx(colon,Memc[substr]) == 2) {
            call sprintf(Memc[ra],SZ_LINE,"0%s")
               call pargstr(Memc[substr])
         } else {
            call strcpy(Memc[substr],Memc[ra],SZ_LINE)
         }
      }

      # Get the DEC from the file header if it exists...

      Memc[dec] = EOS
      ifnoerr (call imgstr(iptr,"dec",Memc[data],SZ_LINE)) {
         jst = stridxs("0123456789+-",Memc[data])
         for (jfn = jst+1; jfn <= strlen(Memc[data]); jfn = jfn + 1) {
            if (stridxs("0123456789:.+-",Memc[data+jfn-1]) != 1)
               break
         }
         jfn = jfn - 1
         maxch = jfn - jst + 1
         call strcpy(Memc[data+jst-1],Memc[substr],maxch)
         if (stridx(colon,Memc[substr]) == 2) {
            call sprintf(Memc[dec],SZ_LINE,"+0%s")
               call pargstr(Memc[substr])
         } else if (stridx(colon,Memc[substr]) == 3) {
            if (stridxs("+-",Memc[substr]) == 0) {
               call sprintf(Memc[dec],SZ_LINE,"+%s")
                  call pargstr(Memc[substr])
            } else {
               call sprintf(Memc[dec],SZ_LINE,"%1s0%s")
                  call pargc(Memc[substr])
                  call pargstr(Memc[substr+1])
            }
         } else {
            call strcpy(Memc[substr],Memc[dec],SZ_LINE)
         }
      }

      # Get the title from the header...

      Memc[title] = EOS
      call imgstr(iptr,"i_title",Memc[title],SZ_LINE)
      len = strlen(Memc[title])
      for (i = 1; i <= len; i = i + 1) {
         if (Memc[title+i-1] == '\"')
            Memc[title+i-1] = ' '
      }

      # Write the stuff out to the apid table.

      for (i = 1; i <= nsp; i = i + 1) {
         if (nsp == 1) {
            call fprintf(fd,"1 1 %s %s %s\n")
               call pargstr(Memc[title])
               call pargstr(Memc[ra])
               call pargstr(Memc[dec])
         } else {
            call fprintf(fd,"%d 1 %s %s %s spectrum %d\n")
               call pargi(i)
               call pargstr(Memc[title])
               call pargstr(Memc[ra])
               call pargstr(Memc[dec])
               call pargi(i)
         }
      }

      # Tidy and exit

      call close(fd)
      call imunmap(iptr)
      call sfree(sp)
end
