include "arclog.h"
include <tbset.h>

procedure t_mkarclog()

# Local variables

pointer sp,adbname,arcfile,db,tp,cptr[3],testfile
real cw,dw
int nrows,newrow,i

# Functions

real clgetr()
int tbpsta(),tbtacc()
pointer tbtopn()
bool streq()

begin

      # Get workspace 

      call smark(sp)
      call salloc(adbname,SZ_FNAME,TY_CHAR)
      call salloc(arcfile,SZ_FNAME,TY_CHAR)
      call salloc(db,SZ_FNAME,TY_CHAR)
      call salloc(testfile,SZ_FNAME,TY_CHAR)

      # Get the name of the arcfile, the central wavelength and dispersion

      call clgstr("arcfile",Memc[arcfile],SZ_FNAME)
      cw = clgetr("cenwave")
      dw = clgetr("dispwave")

      # Get the name of the database directory and create the arclog file name
  
      call clgstr("database",Memc[db],SZ_FNAME)
      call sprintf(Memc[adbname],SZ_FNAME,"%s/%s")
         call pargstr(Memc[db])
         call pargstr(AL_NAME)

      # See if the arclog exists.  If it does, then just open it.  If it
      # doesn't, then create it from scratch.

      if (tbtacc(Memc[adbname]) == YES) {
         tp = tbtopn(Memc[adbname],READ_WRITE,NULL)
         call tbcfnd(tp,COL1,cptr[1],1)
         call tbcfnd(tp,COL2,cptr[2],1)
         call tbcfnd(tp,COL3,cptr[3],1)
      } else {
         tp = tbtopn(Memc[adbname],NEW_FILE,NULL)
         call tbtcre(tp)
         call tbcdef(tp,cptr[1],COL1,"","%s",-SZ_FNAME,1,1)
         call tbcdef(tp,cptr[2],COL2,"Angstroms","%15.7g",TY_REAL,1,1)
         call tbcdef(tp,cptr[3],COL3,"Ang/Pix","%15.7g",TY_REAL,1,1)
         call tbtflu(tp)
      }

      # Get the number of rows in the file 

      nrows = tbpsta(tp,TBL_NROWS) 

      # Check the table and make sure the current arcfile doesn't already
      # exist in the table.

      newrow = nrows + 1
      for (i = 1; i <= nrows; i = i + 1) {
         call tbegtt(tp,cptr[1],i,Memc[testfile],SZ_FNAME)
         if (streq(Memc[testfile],Memc[arcfile])) {
            newrow = i
            break
         }
      }

      # Add in the new entry.

      call tbeptt(tp,cptr[1],newrow,Memc[arcfile])
      call tbeptr(tp,cptr[2],newrow,cw)
      call tbeptr(tp,cptr[3],newrow,dw)

      # Close up the table and release the workspace

      call tbtclo(tp)
      call sfree(sp)
end
