include <imhdr.h>                      
include <error.h>
include <tbset.h>
include <smw.h>

define    DBNAME    "RUNLOG"
define    NCOLS     15

procedure t_runlog()

# Local variables

pointer sp,iname,db,dbname,oname,tname,title,instfile,param,optr,tp,
   cptr[NCOLS],value,bsamp,mw,sh,dumptr
int nrows,ired,fd,ist,len,nloop,i,j,apnum,nline,nband
char hdflat[8],hdillum[8]
bool flat,illum,bgrnd,tippex,fluxcal,dispcor

# Functions

pointer immap(),tbtopn()
int tbtacc(),clgeti(),open(),fscan(),nscan(),strlen(),strsearch(),imaccf(),
   tbpsta()
bool streq(),fndhd()
real imgetr()

begin

      # Get workspace

      call smark(sp)
      call salloc(iname,SZ_FNAME,TY_CHAR)
      call salloc(db,SZ_FNAME,TY_CHAR)
      call salloc(dbname,SZ_FNAME,TY_CHAR)
      call salloc(oname,SZ_FNAME,TY_CHAR)
      call salloc(tname,SZ_FNAME,TY_CHAR)
      call salloc(title,SZ_LINE,TY_CHAR)
      call salloc(instfile,SZ_FNAME,TY_CHAR)
      call salloc(param,SZ_LINE,TY_CHAR)
      call salloc(value,SZ_LINE,TY_CHAR)
      call salloc(bsamp,SZ_LINE,TY_CHAR)

      # Get the input file

      call clgstr("input",Memc[iname],SZ_FNAME)

      # Get the name of the database directory and create the arclog file name
  
      call clgstr("database",Memc[db],SZ_FNAME)
      call sprintf(Memc[dbname],SZ_FNAME,"%s/%s")
         call pargstr(Memc[db])
         call pargstr(DBNAME)

      # See if the arclog exists.  If it does, then just open it.  If it
      # doesn't, then create it from scratch.

      if (tbtacc(Memc[dbname]) == YES) {
         tp = tbtopn(Memc[dbname],READ_WRITE,NULL)
         call tbcfnd(tp,"file",cptr[1],1)
         call tbcfnd(tp,"title",cptr[2],1)
         call tbcfnd(tp,"outfile",cptr[3],1)
         call tbcfnd(tp,"flat",cptr[4],1)
         call tbcfnd(tp,"illum",cptr[5],1)
         call tbcfnd(tp,"bgrnd",cptr[6],1)
         call tbcfnd(tp,"bsample",cptr[7],1)
         call tbcfnd(tp,"tippex",cptr[8],1)
         call tbcfnd(tp,"fluxcal",cptr[9],1)
         call tbcfnd(tp,"spectrum",cptr[10],1)
         call tbcfnd(tp,"wave0",cptr[11],1)
         call tbcfnd(tp,"dwave",cptr[12],1)
         call tbcfnd(tp,"disperr1",cptr[13],1)
         call tbcfnd(tp,"disperr2",cptr[14],1)
         call tbcfnd(tp,"redmethod",cptr[15],1)
         
      } else {
         tp = tbtopn(Memc[dbname],NEW_FILE,NULL)
         call tbtcre(tp)
         call tbcdef(tp,cptr[1],"file","","%-s",-64,1,1)
         call tbcdef(tp,cptr[2],"title","","%-s",-32,1,1)
         call tbcdef(tp,cptr[3],"outfile","","%-s",-64,1,1)
         call tbcdef(tp,cptr[4],"flat","","%b",TY_BOOL,1,1)
         call tbcdef(tp,cptr[5],"illum","","%b",TY_BOOL,1,1)
         call tbcdef(tp,cptr[6],"bgrnd","","%b",TY_BOOL,1,1)
         call tbcdef(tp,cptr[7],"bsample","","%-s",-32,1,1)
         call tbcdef(tp,cptr[8],"tippex","","%b",TY_BOOL,1,1)
         call tbcdef(tp,cptr[9],"fluxcal","","%b",TY_BOOL,1,1)
         call tbcdef(tp,cptr[10],"spectrum","","%d",TY_INT,1,1)
         call tbcdef(tp,cptr[11],"wave0","Angstroms","%10.7g",TY_REAL,1,1)
         call tbcdef(tp,cptr[12],"dwave","Angstroms/pixel","%10.5g",TY_REAL,1,1)
         call tbcdef(tp,cptr[13],"disperr1","Angstroms","%10.5g",TY_REAL,1,1)
         call tbcdef(tp,cptr[14],"disperr2","Angstroms","%10.5g",TY_REAL,1,1)
         call tbcdef(tp,cptr[15],"redmethod","","%s",-2,1,1)
         call tbtflu(tp)
      }

      # Get the number of rows in the file 

      nrows = tbpsta(tp,TBL_NROWS) 

      # Is this a 1d or 2d reduction?

      ired = clgeti("ired")

      # Get the title and the output file name. Open the output file

      call sprintf(Memc[oname],SZ_FNAME,"%s%s")
         call pargstr(Memc[iname])
      if (ired == 1)
         call pargstr(".ms")
      else
         call pargstr(".tds")                              
      iferr (optr = immap(Memc[oname],READ_ONLY,0)) {
         call eprintf("Can't get file: %s\n")
            call pargstr(Memc[oname])
         call erract(EA_ERROR)
      }
      call imgstr(optr,"i_title",Memc[title],SZ_LINE)
                                            
      # Get the instrument file and open it.  Read it and extract the header
      # parameter names for flat fielding and illumination correction

      call clgstr("instfile",Memc[instfile],SZ_FNAME)
      iferr(fd = open(Memc[instfile],READ_ONLY,TEXT_FILE)) {
         call eprintf("Can't open instrument file: %s\n")
            call pargstr(Memc[instfile])
         call erract(EA_ERROR)
      }
      while (fscan(fd) != EOF) {
         call gargwrd(Memc[param],SZ_LINE)
         if ((nscan() == 0) || (Memc[param] == '#'))
            next
         call strlwr(Memc[param])
         if (streq(Memc[param],"flatcor"))
            call gargwrd(hdflat,8)
         else if (streq(Memc[param],"illumcor"))
            call gargwrd(hdillum,8)
      }
      call close(fd)
      if (strlen(hdflat) == 0 || strlen(hdillum) == 0) 
         call error("Either flat or illum not defined in instrument file")
      
      # See if the files were flat fielded and illumination corrected

      flat = fndhd(optr,hdflat)
      illum = fndhd(optr,hdillum)

      # See if a background subtraction was done.

      if (ired == 1) {
         call imgstr(optr,"BANDID1",Memc[param],SZ_LINE)
         ist = strsearch(Memc[param],"background") + 1
         call sscan(Memc[param+ist-1])
            call gargwrd(Memc[value],SZ_LINE)
         len = strlen(Memc[value])
         if (Memc[value+len-1] == ',')
            Memc[value+len-1] = EOS
         if (streq(Memc[value],"none")) {
            bgrnd = false
            call strcpy(Memc[bsamp],"none",SZ_LINE)
         } else {
            bgrnd = true
         }
      } else {
         bgrnd = fndhd(optr,"bk-flag")
         if (bgrnd) 
            call imgstr(optr,"bsamp",Memc[bsamp],SZ_LINE)
         else 
            call strcpy("none",Memc[bsamp],SZ_LINE)
      }

      # See if tippexing, flux calibration and dispersion calibration were done.
 
      tippex = fndhd(optr,"tp-flag")
      fluxcal = fndhd(optr,"ca-flag")
      dispcor = fndhd(optr,"dc-flag")

      # Ok, if this is a 1d reduction, then loop for all spectra.  If this is
      # a 2d reduction, then only do this once.

      if (ired == 1) 
         nloop = IM_LEN(optr,2)
      else
         nloop = 1
      for (i = 1; i <= nloop; i = i + 1) {
         nrows = nrows + 1

         # Only put name and title in once for clarity.

         if (i == 1) {
            call tbrptt(tp,cptr[1],Memc[iname],SZ_FNAME,1,nrows)
            call tbrptt(tp,cptr[2],Memc[title],SZ_FNAME,1,nrows)
            call tbrptt(tp,cptr[3],Memc[oname],SZ_FNAME,1,nrows)
         } else {
            call tbrptt(tp,cptr[1],"",SZ_FNAME,1,nrows)
            call tbrptt(tp,cptr[2],"",SZ_FNAME,1,nrows)
            call tbrptt(tp,cptr[3],"",SZ_FNAME,1,nrows)
         }
  
         # Get background parameters for background subtracted 1d extractions

         if (ired == 1 && bgrnd) {
            call sprintf(Memc[param],SZ_LINE,"bsamp_%d")
               call pargi(i)
            iferr (call imgstr(optr,Memc[param],Memc[bsamp],SZ_LINE))
               call strcpy("Unknown",Memc[bsamp],SZ_LINE)
         }

         # Add in basic reduction parameters

         call tbrptb(tp,cptr[4],flat,1,nrows)
         call tbrptb(tp,cptr[5],illum,1,nrows)
         call tbrptb(tp,cptr[6],bgrnd,1,nrows)
         call tbrptt(tp,cptr[7],Memc[bsamp],SZ_LINE,1,nrows)
         call tbrptb(tp,cptr[8],tippex,1,nrows)
         call tbrptb(tp,cptr[9],fluxcal,1,nrows)
         call tbrpti(tp,cptr[10],i,1,nrows)
            
         # Now if the spectra have been wavelength calibrated, then
         # open each spectrum and get the wavelength zeropoint and 
         # dispersion.  Get the errors in the scrunch too.

         if (dispcor) {
            dumptr = NULL
            nline = i
            nband = 1
            call rgetimage(Memc[oname],nline,nband,apnum,dumptr,mw,sh)
            call tbrptr(tp,cptr[11],real(SMW_W1(mw)),1,nrows)
            call tbrptr(tp,cptr[12],real(SMW_DW(mw)),1,nrows)
            call shdr_close(sh)
            call smw_close(mw)
            call imunmap(dumptr)
            do j = 1,2 {
               call sprintf(Memc[param],SZ_LINE,"DCE%03d_%d")
                  call pargi(i)
                  call pargi(j)
               if (imaccf(optr,Memc[param]) == NO) 
                  call tbrptr(tp,cptr[12+j],INDEF,1,nrows)
               else
                  call tbrptr(tp,cptr[12+j],imgetr(optr,Memc[param]),1,nrows)
            }
         } else {
            do j = 1,4
               call tbrptr(tp,cptr[10+i],INDEF,1,nrows)
         }

         # Finally add in the reduction method.

         call sprintf(Memc[param],SZ_LINE,"%dd")
            call pargi(ired)
         call tbrptt(tp,cptr[15],Memc[param],SZ_LINE,1,nrows)
      }
  
      # Ok, close things up and get out of here...

      call tbtclo(tp)
      call imunmap(optr)
      call sfree(sp)
end
                
bool procedure fndhd(iptr,headitem)

# Parameters

pointer iptr
char headitem[ARB]
bool exist

# Functions

int imaccf()

begin

      if (imaccf(iptr,headitem) == YES)
         exist = true
      else
         exist = false

      return(exist)
end
