include <math.h>

define LATITUDE DEGTORAD(28.7583) # Latitude of La Palma

procedure t_stime()

# Local variables

pointer sp,ilist,ra,dec,am,fname,result,iptr,list
real sinphi,cosphi,ratime,decrad,airmass,cosz,arg,lst

# Functions

int imtgetim()
pointer immap(),imtopen()
real imgetr()

begin

      # Get some workspace

      call smark(sp)
      call salloc(ilist,SZ_LINE,TY_CHAR)
      call salloc(ra,SZ_LINE,TY_CHAR)
      call salloc(dec,SZ_LINE,TY_CHAR)
      call salloc(am,SZ_LINE,TY_CHAR)
      call salloc(fname,SZ_FNAME,TY_CHAR)
      call salloc(result,SZ_LINE,TY_CHAR)

      # Get the list of input images

      call clgstr("inlist",Memc[ilist],SZ_LINE)
      list = imtopen(Memc[ilist])

      # Get the ra, dec and airmass keywords 

      call clgstr("ra",Memc[ra],SZ_LINE)      
      call clgstr("dec",Memc[dec],SZ_LINE)      
      call clgstr("am",Memc[am],SZ_LINE)

      # Calculate a few things for speed

      sinphi = sin(LATITUDE)
      cosphi = cos(LATITUDE)

      # Now loop for each of the images

      while (imtgetim(list,Memc[fname],SZ_FNAME) != EOF) {

         # Open the image and get the header parameters

         iferr(iptr = immap(Memc[fname],READ_WRITE,0)) {
            call eprintf("Can't find image %s\n")
               call pargstr(Memc[fname])
            next
         }
         ratime = imgetr(iptr,Memc[ra])
         decrad = DEGTORAD(imgetr(iptr,Memc[dec]))
         airmass = imgetr(iptr,Memc[am])

         # Calculate the lst

         cosz = 1.0/airmass
         arg = (cosz - sin(decrad)*sinphi)/(cos(decrad)*cosphi) 
         lst = RADTODEG(acos(arg))/15.0 + ratime
         lst = mod(lst,24.0)
         if (lst < 0.0) 
            lst = lst + 24.0
         call sprintf(Memc[result],SZ_LINE,"%010.1h")
            call pargr(lst)

         # Now write the lst to the header parameter ST

         call imastr(iptr,"ST",Memc[result])

         # Close up the file

         call imunmap(iptr)
      }

      # Close up the list structure and free workspace

      call imtclose(list)
      call sfree(sp)
end             
