# Parameters for RGO Faint Objects Red Spectrograph on the AAT

spec2.telescope = "AAT"
spec2.dispaxis = 2
spec2.guifile = "spec2$aatfors.gui"
spec2.observatory = "aao"
spec2.extfile = "rgo$flux/aaoext.tab"

rpars.interactive = no

rpars.b_function = "legendre"
rpars.b_order = 2
rpars.b_sample = ""
rpars.b_naverage = -3
rpars.b_niterate = 1
rpars.b_low_reject = 3
rpars.b_high_reject = 3
rpars.b_grow = 0

rpars.select = "interp"
rpars.sort = "jd"
rpars.time = no
rpars.timewrap = 17

rpars.match = 2
rpars.fwidth = 4
rpars.cradius = 5 
rpars.cthresh = 10.0
rpars.sep = 2.0
rpars.contrast = 0.05
rpars.edge = 1  
rpars.maxfeatures = 50
rpars.pkthresh = 10.0
rpars.i_function = "chebyshev"
rpars.i_order = 4
rpars.sp_order = 3
rpars.i_niterate = 1
rpars.i_low = 2.5
rpars.i_high = 2.5

rpars.log = no
rpars.flux = yes

refspectra.group = ""

idpars.dfrac = 0.05
idpars.ndisp = 31
idpars.limit_angle = 1.40 
idpars.ns_select = 3
idpars.ng_select = 10
idpars.test_stat = 1
idpars.wfact = 1.0
idpars.padding = 0.1


instrpars.cenwave = "aatrgowave(GRATANGL,1)"
instrpars.disp_app = "aatrgowave(GRATANGL,2)"
instrpars.dflip = "aatrgodflip()"
instrpars.trimsec = "aatrgobd(WINDOXS1,WINDOXE1,WINDOYS1,WINDOYE1,WINDOXS2,WINDOXE2,WINDOYS2,WINDOYE2,1)"
instrpars.biassec = "aatrgobd(WINDOXS1,WINDOXE1,WINDOYS1,WINDOYE1,WINDOXS2,WINDOXE2,WINDOYS2,WINDOYE2,2)"
instrpars.ra = "MEANRA/15.0"
instrpars.dec = "MEANDEC"
instrpars.epoch = ""
instrpars.ut = "UTSTART"
instrpars.st = "STSTART"
instrpars.date_obs = "UTDATE"
instrpars.exposure = "EXPOSED"

keep
