procedure setup(instr)        

string     instr     {prompt="Instrument ID (type ? for a list)"}
bool       gui = yes {prompt="Use the graphical user interface?"}
string     query     {prompt="Instrument ID (type q to quit)",mode="q"}

begin

      string instrum,tel
      file instfile,instmen

      # Get query parameter and convert it to lower case

      instrum = instr
      print(instrum) | lcase | scan(instrum)

      # Set up the apextract default parameters for this instrument

      instfile = "spec2$instr/"//instrum//".cl"
      instmen = "spec2$instr/instruments.men"

      # Loop until you get a valid instrument name

      while (instrum == "" || !access(instfile)) {
         if (instrum == "?" || instrum == "") {
            printf("\n")
            print("List of available instruments:")
            type(instmen)
            printf("\n")
         } else {
            printf("\n")
            print("Instrument ",instrum," not found -- try one of these"
            type(instmen)
            printf("\n")
         }
         instrum = query
         print(instrum) | lcase | scan(instrum)
         if (instrum == "q")
            bye
         instfile = "spec2$instr/"//instrum//".cl"
      }

      # Now define the instrument in the package parameters...

      spec2.instrument = instrum

      # Run instrumental setup script

      cl (<instfile)

      # Define a null gui file if you don't want to use a gui

      if (!gui)
         spec2.guifile = ""
      update("spec2")

      # Little kludge to get the update to work right...

      spec2.records = ""
      update("spec2")

end
                          
