include <gset.h>
include <fset.h>
include <ctype.h>

define   HELPFIL       "quickie$doc/rbshelp.key"
define   PROMPT        "RBS help"

procedure t_rbs()

# Local variables

pointer sp,strval,guifile,cmd,command,command1,command2,gp,
   term,ilist,logfile,data,fframe
int nspec,nplot,blkfact,wcs,key,ip,op,junk,ld,acc
long oldtime,ltime
bool fconv,crproc,lcal,hcopy,quit,bsub,ffield
real x,y,stw,app

# Functions

int clgeti(),access(),clgcur(),ctoi(),open()
real clgetr(),ctor()
long clktime()
bool clgetb(),streq()
pointer gopenui()

begin

      # Get stack workspace

      call smark(sp)
      call salloc(strval,SZ_LINE,TY_CHAR)
      call salloc(guifile,SZ_LINE,TY_CHAR)
      call salloc(ilist,SZ_LINE,TY_CHAR)
      call salloc(cmd,SZ_LINE,TY_CHAR)
      call salloc(command,SZ_COMMAND,TY_CHAR)
      call salloc(command1,SZ_COMMAND,TY_CHAR)
      call salloc(command2,SZ_COMMAND,TY_CHAR)
      call salloc(term,SZ_FNAME,TY_CHAR)
      call salloc(logfile,SZ_FNAME,TY_CHAR)
      call salloc(data,SZ_LINE,TY_CHAR)
      call salloc(fframe,SZ_FNAME,TY_CHAR)

      # Open a log file

      call strcpy("rbs.log",Memc[logfile],SZ_FNAME)
      if (access(Memc[logfile],0,0) == YES)
         acc = APPEND
      else
         acc = NEW_FILE
      ld = open(Memc[logfile],acc,TEXT_FILE)      
      oldtime = 0
      if (acc == NEW_FILE) {
         call fprintf(ld,"      *****RBS quick look software log file******\n")
         call fprintf(ld," \n")
         ltime = clktime(oldtime)
         call cnvdate(ltime,Memc[data],SZ_LINE)
         call fprintf(ld,"First opened on %s\n")
            call pargstr(Memc[data])
      }
      call fseti(ld,F_FLUSHNL,YES)

      # Get initial values of all the parameters...
      
      call clgstr ("gui",Memc[guifile], SZ_FNAME)
      call clgstr ("image",Memc[ilist], SZ_LINE)
      nspec = clgeti("nspec")
      stw   = clgetr("stw")
      app   = clgetr("app")
      nplot = clgeti("nplot")
      blkfact = clgeti("blkfact")
      fconv = clgetb("fconv")
      crproc = clgetb("crproc")
      lcal = clgetb("lcal")
      hcopy = clgetb("hcopy")
      bsub = clgetb("bsub")
      ffield = clgetb("ffield")
      call clgstr("fframe",Memc[fframe],SZ_FNAME)

      # From what type of terminal is this being run?

      call envgets("terminal",Memc[term],SZ_FNAME)

      # If the gui file exists, then do the work with a gui...

      if (access(Memc[guifile],0,0) == YES && streq(Memc[term],"xgterm")) {
         call clcmdw("set guidir = quickie$stdfiles/")
         gp = gopenui ("stdgraph",NEW_FILE,Memc[guifile],STDGRAPH)
         call gclear(gp)
         call gmsg(gp,"image",Memc[ilist])
         call gmsgi(gp,"nspec",nspec)
         call gmsgr(gp,"stw",stw)
         call gmsgr(gp,"app",app)
         call gmsgi(gp,"nplot",nplot)
         call gmsgi(gp,"blkfact",blkfact)
         call gmsgb(gp,"fconv",fconv)
         call gmsgb(gp,"crproc",crproc)
         call gmsgb(gp,"lcal",lcal)
         call gmsgb(gp,"hcopy",hcopy)
         call gmsgb(gp,"bsub",bsub)
         call gmsgb(gp,"ffield",ffield)
         call gmsg(gp,"fframe",Memc[fframe])
       
         # Enter the gui cursor loop 

         quit = false
         while (clgcur("cursor",x,y,wcs,key,Memc[strval],SZ_LINE) != EOF) {
            switch (key) {

               # Exit from the gui

               case 'e':
                  break

               # Reduce button has been hit
 
               case 'r':

                  # Form find command...

                  call sprintf(Memc[command1],SZ_COMMAND,
                     "frbs \"%s\" nspec=%d stw=%0.6g app=%0.6g blkfact=%d fconv=%b ")
                     call pargstr(Memc[ilist])
                     call pargi(nspec)
                     call pargr(stw)
                     call pargr(app)
                     call pargi(blkfact)
                     call pargb(fconv)
                  call sprintf(Memc[command2],SZ_COMMAND,
                     " crproc=%b lcal=%b bsub=%b ffield=%b fframe=\"%s\"")
                     call pargb(crproc)       
                     call pargb(lcal)
                     call pargb(bsub)
                     call pargb(ffield)
                     call pargstr(Memc[fframe])
                  call strcpy(Memc[command1],Memc[command],SZ_COMMAND)
                  call strcat(Memc[command2],Memc[command],SZ_COMMAND)

                  # Write to log file...

                  ltime = clktime(oldtime)
                  call cnvdate(ltime,Memc[data],SZ_LINE)
                  call fprintf(ld," \n")
                  call fprintf(ld,"*****%s\n")
                     call pargstr(Memc[data])
                  call fprintf(ld,"%s \n")
                     call pargstr(Memc[command])
     
                  # Do the find command...

                  call gdeactivate(gp,0)
                  call clcmdw(Memc[command])

                  # Set up plot command...

                  call sprintf(Memc[command],SZ_COMMAND,
                     "prbs image=\"%s\" nplot=%d hcopy=%b ")
                     call pargstr(Memc[ilist])
                     call pargi(nplot)
                     call pargb(hcopy)
                   
                  # Write to log file...

                  call fprintf(ld,"%s \n")
                     call pargstr(Memc[command])
                     
                  # Do the plot command

                  call greactivate(gp,0)
                  call clcmdw(Memc[command])
                  call gdeactivate(gp,0)
                  call printf("Done with %s\n")
                     call pargstr(Memc[ilist])
                  call flush(STDOUT)
                  call greactivate(gp,0)

               # Help button has been pushed

               case '?':
                  call gpagefile(gp,HELPFIL,PROMPT)

               # Plot only button has been pushed

               case 'p':
                  call sprintf(Memc[command],SZ_COMMAND,
                     "prbs image=\"%s\" nplot=%d hcopy=%b ")
                     call pargstr(Memc[ilist])
                     call pargi(nplot)
                     call pargb(hcopy)
                  call clcmdw(Memc[command])
                  call gdeactivate(gp,0)
                  call printf("Done with %s\n")
                     call pargstr(Memc[ilist])
                  call flush(STDOUT)
                  call greactivate(gp,0)

               # A parameter has been changed.  First find out which one

               case ':':
                  for (ip=1;IS_WHITE(Memc[strval+ip-1]);ip=ip+1)
                     ;
                  op = 1
                  while (Memc[strval+ip-1] != EOS && !IS_WHITE(Memc[strval+ip-1])) {
                       Memc[cmd+op-1] = Memc[strval+ip-1]
                       op = op + 1
                       ip = ip + 1
                  }
                  Memc[cmd+op-1] = EOS
                  for ( ;IS_WHITE(Memc[strval+ip-1]);ip=ip+1)
                      ;
                  if (streq(Memc[cmd],"image")) {
                     call strcpy (Memc[strval+ip-1],Memc[ilist], SZ_LINE)
                  } else if (streq(Memc[cmd],"nspec")) {
                     junk = ctoi(Memc[strval],ip,nspec)
                  } else if (streq(Memc[cmd],"stw")) {
                     junk = ctor(Memc[strval],ip,stw)
                  } else if (streq(Memc[cmd],"app")) {
                     junk = ctor(Memc[strval],ip,app)
                  } else if (streq(Memc[cmd],"nplot")) {
                     junk = ctoi(Memc[strval],ip,nplot)
                  } else if (streq(Memc[cmd],"blkfact")) {
                     junk = ctoi(Memc[strval],ip,blkfact)
                  } else if (streq(Memc[cmd],"fconv")) {
                     fconv = streq(Memc[strval+ip-1],"1")
                  } else if (streq(Memc[cmd],"crproc")) {
                     crproc = streq(Memc[strval+ip-1],"1")
                  } else if (streq(Memc[cmd],"lcal")) {
                     lcal = streq(Memc[strval+ip-1],"1")
                  } else if (streq(Memc[cmd],"hcopy")) {
                     hcopy = streq(Memc[strval+ip-1],"1")
                  } else if (streq(Memc[cmd],"bsub")) {
                     bsub = streq(Memc[strval+ip-1],"1")
                  } else if (streq(Memc[cmd],"ffield")) {
                     ffield = streq(Memc[strval+ip-1],"1")
                  } else if (streq(Memc[cmd],"fframe")) {
                     call strcpy(Memc[strval+ip-1],Memc[fframe],SZ_FNAME)
                  }
            } # end of switch
         } # End of cursor loop
         call gclose (gp)
         if (hcopy) call clcmdw("gflush")
         call clcmdw("set guidir = \"\"")

      # If no gui is being used, then just run the cl files...

      } else {   

         # Form find command...

         call sprintf(Memc[command1],SZ_COMMAND,
            "frbs \"%s\" nspec=%d stw=%0.6g app=%0.6g blkfact=%d fconv=%b ")
            call pargstr(Memc[ilist])
            call pargi(nspec)
            call pargr(stw)
            call pargr(app)
            call pargi(blkfact)
            call pargb(fconv)
         call sprintf(Memc[command2],SZ_COMMAND,
            " crproc=%b lcal=%b bsub=%b ffield=%b fframe=\"%s\"")
            call pargb(crproc)       
            call pargb(lcal)
            call pargb(bsub)
            call pargb(ffield)
            call pargstr(Memc[fframe])
         call strcpy(Memc[command1],Memc[command],SZ_COMMAND)
         call strcat(Memc[command2],Memc[command],SZ_COMMAND)

         # Write to log file...

         ltime = clktime(oldtime)
         call cnvdate(ltime,Memc[data],SZ_LINE)
         call fprintf(ld," \n")
         call fprintf(ld,"*****%s\n")
            call pargstr(Memc[data])
         call fprintf(ld,"%s \n")
            call pargstr(Memc[command])
     
         # Do the find command...

         call clcmdw(Memc[command])

         # Set up plot command...

         call sprintf(Memc[command],SZ_COMMAND,
            "prbs image=\"%s\" nplot=%d hcopy=%b ")
            call pargstr(Memc[ilist])
            call pargi(nplot)
            call pargb(hcopy)
                
         # Write to log file...

         call fprintf(ld,"%s \n")
            call pargstr(Memc[command])
                     
         # Do the plot command

         call clcmdw(Memc[command])
         call printf("Done with %s\n")
            call pargstr(Memc[ilist])
         call flush(STDOUT)
         if (hcopy) call clcmdw("gflush")
      }
     
      # Tidy and exit
      
      call close(ld)
      call sfree(sp)
end
                 
