

procedure rt_par_arrs(par,nmax,nread,vals)
#--------------------------------------------------------------------------------------
#      RT_PAR_ARR -- Generic routine to parse a parameter array from an input string
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) par:        (char) Name of the parameter to be requested
#      (>) nmax:       (int) Maximum number of parameters to be parsed
#      (<) nread:      (int) Number of parameter parsed
#      (<) vals:       (???) Generic output parameter array
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        26-MAR-1993
#      UPDATE:
#
#--------------------------------------------------------------------------------------

# Parameters

char par[ARB]
int nmax,nread
short vals[nmax]

# Local variables

pointer sp,wpt1,wpt2
int i

errchk rt_pra

begin

      # First get a bit of workspace

      call smark(sp)
      call salloc(wpt1,SZ_LINE,TY_CHAR)
      call salloc(wpt2,nmax,TY_REAL)

      # Get the parameters in string form...

      call clgstr(par,Memc[wpt1],SZ_LINE)

      # Call main routine to parse into the real array

      call rt_pra(par,Memc[wpt1],nmax,nread,Memr[wpt2])

      # Now transfer them over

      do i = 1,nread {
            vals[i] = nint(Memr[wpt2+i-1])
      }

      # Ditch workspace
 
      call sfree(sp)
end



procedure rt_par_arri(par,nmax,nread,vals)
#--------------------------------------------------------------------------------------
#      RT_PAR_ARR -- Generic routine to parse a parameter array from an input string
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) par:        (char) Name of the parameter to be requested
#      (>) nmax:       (int) Maximum number of parameters to be parsed
#      (<) nread:      (int) Number of parameter parsed
#      (<) vals:       (???) Generic output parameter array
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        26-MAR-1993
#      UPDATE:
#
#--------------------------------------------------------------------------------------

# Parameters

char par[ARB]
int nmax,nread
int vals[nmax]

# Local variables

pointer sp,wpt1,wpt2
int i

errchk rt_pra

begin

      # First get a bit of workspace

      call smark(sp)
      call salloc(wpt1,SZ_LINE,TY_CHAR)
      call salloc(wpt2,nmax,TY_REAL)

      # Get the parameters in string form...

      call clgstr(par,Memc[wpt1],SZ_LINE)

      # Call main routine to parse into the real array

      call rt_pra(par,Memc[wpt1],nmax,nread,Memr[wpt2])

      # Now transfer them over

      do i = 1,nread {
            vals[i] = nint(Memr[wpt2+i-1])
      }

      # Ditch workspace
 
      call sfree(sp)
end



procedure rt_par_arrl(par,nmax,nread,vals)
#--------------------------------------------------------------------------------------
#      RT_PAR_ARR -- Generic routine to parse a parameter array from an input string
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) par:        (char) Name of the parameter to be requested
#      (>) nmax:       (int) Maximum number of parameters to be parsed
#      (<) nread:      (int) Number of parameter parsed
#      (<) vals:       (???) Generic output parameter array
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        26-MAR-1993
#      UPDATE:
#
#--------------------------------------------------------------------------------------

# Parameters

char par[ARB]
int nmax,nread
long vals[nmax]

# Local variables

pointer sp,wpt1,wpt2
int i

errchk rt_pra

begin

      # First get a bit of workspace

      call smark(sp)
      call salloc(wpt1,SZ_LINE,TY_CHAR)
      call salloc(wpt2,nmax,TY_REAL)

      # Get the parameters in string form...

      call clgstr(par,Memc[wpt1],SZ_LINE)

      # Call main routine to parse into the real array

      call rt_pra(par,Memc[wpt1],nmax,nread,Memr[wpt2])

      # Now transfer them over

      do i = 1,nread {
            vals[i] = nint(Memr[wpt2+i-1])
      }

      # Ditch workspace
 
      call sfree(sp)
end



procedure rt_par_arrr(par,nmax,nread,vals)
#--------------------------------------------------------------------------------------
#      RT_PAR_ARR -- Generic routine to parse a parameter array from an input string
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) par:        (char) Name of the parameter to be requested
#      (>) nmax:       (int) Maximum number of parameters to be parsed
#      (<) nread:      (int) Number of parameter parsed
#      (<) vals:       (???) Generic output parameter array
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        26-MAR-1993
#      UPDATE:
#
#--------------------------------------------------------------------------------------

# Parameters

char par[ARB]
int nmax,nread
real vals[nmax]

# Local variables

pointer sp,wpt1,wpt2
int i

errchk rt_pra

begin

      # First get a bit of workspace

      call smark(sp)
      call salloc(wpt1,SZ_LINE,TY_CHAR)
      call salloc(wpt2,nmax,TY_REAL)

      # Get the parameters in string form...

      call clgstr(par,Memc[wpt1],SZ_LINE)

      # Call main routine to parse into the real array

      call rt_pra(par,Memc[wpt1],nmax,nread,Memr[wpt2])

      # Now transfer them over

      do i = 1,nread {
            vals[i] = Memr[wpt2+i-1]
      }

      # Ditch workspace
 
      call sfree(sp)
end



procedure rt_par_arrd(par,nmax,nread,vals)
#--------------------------------------------------------------------------------------
#      RT_PAR_ARR -- Generic routine to parse a parameter array from an input string
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) par:        (char) Name of the parameter to be requested
#      (>) nmax:       (int) Maximum number of parameters to be parsed
#      (<) nread:      (int) Number of parameter parsed
#      (<) vals:       (???) Generic output parameter array
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        26-MAR-1993
#      UPDATE:
#
#--------------------------------------------------------------------------------------

# Parameters

char par[ARB]
int nmax,nread
double vals[nmax]

# Local variables

pointer sp,wpt1,wpt2
int i

errchk rt_pra

begin

      # First get a bit of workspace

      call smark(sp)
      call salloc(wpt1,SZ_LINE,TY_CHAR)
      call salloc(wpt2,nmax,TY_REAL)

      # Get the parameters in string form...

      call clgstr(par,Memc[wpt1],SZ_LINE)

      # Call main routine to parse into the real array

      call rt_pra(par,Memc[wpt1],nmax,nread,Memr[wpt2])

      # Now transfer them over

      do i = 1,nread {
            vals[i] = Memr[wpt2+i-1]
      }

      # Ditch workspace
 
      call sfree(sp)
end


