bool procedure rt_filex(filename)
#-------------------------------------------------------------------------------
#      RT_FILEX -- Check an output file to see if it already exists.
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) filename:   (char) Output file name
#
#      Returns:
#           exist:     (bool) TRUE if the file exists.
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        21-OCT-1993
#      UPDATE:
#
#-------------------------------------------------------------------------------

# Parameters 

char filename[ARB]

# Local variables

pointer sp,filename2,section
bool exist

# Functions

int imaccess()

begin

      # Get stack workspace

      call smark(sp)
      call salloc(section,SZ_FNAME,TY_CHAR)
      call salloc(filename2,SZ_FNAME,TY_CHAR)

      # Does the filename already have a section?  If not, then
      # append a fake one.

      call imgsection(filename,Memc[section],SZ_FNAME)
      if (Memc[section] == EOS) {
         call strcpy(filename,Memc[filename2],SZ_FNAME)
         call strcat("[1,1]",Memc[filename2],SZ_FNAME) }
      else {
         call strcpy(filename,Memc[filename2],SZ_FNAME)
      }

      # Now does the file exist?
     
      exist = false
      if (imaccess(Memc[filename2],READ_ONLY) == YES) exist = true

      # Get rid of stack space

      call sfree(sp)

      # Return existence variable

      return (exist)
end
