procedure rt_pra(par,str,nmax,nread,vals)
#--------------------------------------------------------------------------------------
#      RT_PRA -- Routine to parse a parameter array from an input string
#                into an output real array
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) par:        (char) Name of the parameter to be requested
#      (>) str:        (char) String read from the cl
#      (>) nmax:       (int) Maximum number of parameters to be parsed
#      (<) nread:      (int) Number of parameter parsed
#      (<) vals:       (real) Output parameter array
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        26-MAR-1993
#      UPDATE:
#
#--------------------------------------------------------------------------------------

# Parameters

char str[ARB],par[ARB]
int nmax,nread
real vals[nmax]

# Local variables

real val
int index
char err[SZ_LINE]

# Functions

int ctor()

begin

      # Start by trying to read each element off the line.  Read a maximum
      # number (nmax) items.  If there aren't enough on the line then,
      # that is considered an error below.  If there are too many on the
      # line, then only the first (nmax) will be read and the rest ignored.

      index = 1
      for (nread=1; ctor(str,index,val) != 0 && nread <= nmax; nread = nread + 1) {
         vals[nread] = val
         index = index + 1
      }

      # If there were too few items on the line, then signal an error

      if (nread <= nmax) {
         call sprintf(err,SZ_LINE,"to few values specified for parameter: %s")
            call pargstr(par)
         call error(0,err) }
      else {
         nread = nread - 1
      }
end
