procedure cleanhd(input)
#------------------------------------------------------------------------------
#
#   -------------
#   C L E A N H D
#   -------------
#
#   Description
#   -----------
#   Clean file headers of sam specific items
#
#   
#   Scope of program
#   ----------------
#   - Dimensionality irrelevant
#   - Data type irrlevant
#   - Error files ignored
#   - Batch execution supported
#
#
#   Environment
#   -----------
#   IRAF
#
#
#   Language
#   --------
#   CL script
#
#
#   Parameters
#   ----------
#   input      This is a list of files whose headers need tidying (character)
#              (prompted for)
#
#   Propogation of data structure
#   -----------------------------
#   Not relevant
#
#   
#   Method
#   ------
#   - sam specific items are removed from the headers using hedit.
#
#
#   External applications called
#   ----------------------------
#   Package images:
#      hedit
#
#
#   Possible future upgrades
#   ------------------------
#
#
#   Author/s
#   --------
#   Jim Lewis      RGO
#
#
#   History
#   -------
#   04-MAR-93     - Original program 
#   11-NOV-93     - Redundant items removed from lists (JRL)
#
#
#------------------------------------------------------------------------------

# Query Parameters

string input {prompt="Name of file, please"}

begin

      # Local variables

      string infile

      # Get name of file

      infile = input

      # Get rid of objects

      hedit(images=infile,fields="axis,track,trace,dekker,nobj,pr_file",
         value="",add=no,delete=yes,verify=no,show=no,update=yes)

      # Now get rid of multiple objects

      hedit(images=infile,fields="pos*,swid*,skya*,skyb*",
         value="",add=no,delete=yes,verify=no,show=no,update=yes)
end
