procedure sam_aroff(track,ny1,ny2,nt,toff)
#--------------------------------------------------------------------------------------
#      SAM_AROFF -- Get appropriate workspace for offset array
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) track:      (bool) TRUE if a trace is being used
#      (>) ny1:        (int) Lower spectral limit
#      (>) ny2:        (int) Upper spectral limit
#      (<) nt:         (int) Number of elements in offset array
#      (<) toff:       (pointer) Pointer to workspace for offset array
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        11-NOV-1993
#      UPDATE:
#
#--------------------------------------------------------------------------------------

# Parameters

bool track
int ny1,ny2,nt
pointer toff

begin

      # If a trace is being used, then you need an element for each
      # spectral pixel being considered.  If not, then you only
      # need one element

      if (track) 
         nt = ny2 - ny1 + 1
      else
         nt = 1

      # Allocate the workspace

      call malloc(toff,nt,TY_SHORT)
end
