procedure sam_ctrace(track,tptr,ptr_tr)
#--------------------------------------------------------------------------------------
#      SAM_CTRACE -- Either close a trace file or release some workspace 
#                    associated with a dummy trace file
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) track:      (bool) TRUE if you have a trace file
#      (>) tptr:       (pointer) Pointer to the trace file
#      (>) ptr_tr:     (pointer) Pointer to workspace
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        22-FEB-1993
#      UPDATE:
#
#--------------------------------------------------------------------------------------

# Parameters

bool track
pointer tptr,ptr_tr

errchk imunmap,mfree

begin

      # If you have used a trace file, then close it...

      if (track) {
         call imunmap(tptr) }

      # Otherwise free the workspace which you allocated for the fake trace...

      else {
         call mfree(ptr_tr,TY_REAL)
      }
end
