include <imhdr.h>

pointer procedure sam_maket(nx,ny,pixtype,template)
#--------------------------------------------------------------------------------------
#      SAM_MAKET -- Make a temporary file of a given size and type.
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) nx:         (int) X dimension of file 
#      (>) ny:         (int) Y dimension of file
#      (>) pixtype:    (int) Pixel type of the file
#      (>) template:   (pointer) File for use as possible template
#
#      Returns:
#          fptr:       (pointer) Pointer to the temporary file
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        22-FEB-1993
#      UPDATE:      30-MAR-1993 -- Uses rt_crfile to create the file now (JRL)
#
#--------------------------------------------------------------------------------------

# Parameters

int nx,ny,pixtype
pointer template

# Local variables

pointer fptr,cp1,sp,temp
int dims[2],type

# Functions

pointer rt_crfile()

errchk rt_crfile

begin

      # Mark stack and get some workspace

      call smark(sp)
      call salloc(cp1,SZ_FNAME,TY_CHAR)

      # Create the temporary file name...

      call sam_fname(Memc[cp1])

      # Set up file information

      if (template == NULL) {
         type = NEW_FILE
         temp = 0 }
      else {
         type = NEW_COPY
         temp = template
      }
      dims[1] = nx
      dims[2] = ny

      # Open file now

      fptr = rt_crfile(Memc[cp1],type,temp,2,dims,pixtype)

      # Get rid of the workspace

      call sfree(sp)

      # Return the file pointer

      return(fptr)
end
