include <imhdr.h>

procedure sam_odekker(dname,nobj,dptr)
#--------------------------------------------------------------------------------------
#      SAM_ODEKKER -- Open a dekker file
#
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) dname:      (pointer) Pointer to dekker file name
#      (<) nobj:       (int) Number of objects
#      (<) dptr:       (pointer) Pointer to dekker file header
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        11-NOV-1993
#      UPDATE:      
#
#--------------------------------------------------------------------------------------

# Parameters

pointer dname,dptr
int nobj

# Local variables

int ndim,nx

# Functions

pointer immap()

errchk immap

begin

      # First open the file and get its dimensions...

      dptr = immap(Memc[dname],READ_ONLY,0)
      ndim = IM_NDIM(dptr)
      nx = IM_LEN(dptr,1)

      # Check whether there is any cause for panic.  First is the
      # file 2d?

      if (ndim != 2) 
         call error(0,"Dekker file must be two dimensional!") 

      # Does the file contain the right number of entries for each object?

      if (nx != 4) 
         call error(0,"Dekker file must contain 4 entries per object")

      # If it's made it through all that, then the number of objects
      # equals the number of rows.

      nobj = IM_LEN(dptr,2)
end
            
