procedure sub_tramx(iptr,eptr,er_ex,nx,ny,output,outvar)
#--------------------------------------------------------------------------------------
#      SUB_TRAMX -- Main subroutine to do tramline extraction (i.e. equal weights)
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) iptr:       (pointer) Pointer to input file
#      (>) eptr:       (pointer) Pointer to input error file
#      (>) er_ex:      (bool) TRUE if an error file exists
#      (>) nx:         (int) X dimension of input data
#      (>) ny:         (int) Y dimension of input data
#      (<) output:     (real[ny]) Output spectrum
#      (<) outvar:     (real,ny]) Output spectrum variance
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        22-FEB-1993
#      UPDATE:
#
#--------------------------------------------------------------------------------------

# Parameters

pointer iptr,eptr
int nx,ny
bool er_ex
real output[ny],outvar[ny]

# Local variables

pointer ptr1,ptr2
int i,j
real sum1,sum2,dat,var

# Functions

pointer imgl2r()

errchk imgl2r

begin

      # Loop through spectral axis...

      do j = 1,ny {
         sum1 = 0.0
         sum2 = 0.0
         ptr1 = imgl2r(iptr,j)
         if (er_ex) ptr2 = imgl2r(eptr,j)

         # Loop through the seeing profile

         do i = 1,nx {
            dat = Memr[ptr1+i-1]
            sum1 = sum1 + dat
            if (er_ex) {
               var = Memr[ptr2+i-1]
               sum2 = sum2 + var
            }
         }

         # Set output...

         output[j] = sum1
         if (er_ex) outvar[j] = sum2
      }
end

            