real procedure check_div(val)
#--------------------------------------------------------------------------------------
#      CHECK_DIV -- Check a divisor to see if it's too close to zero for comfort.
#                   If it is, then replace it with a preset value and clock up
#                   a trapped zero divide
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) val:        (real) Input value to be checked
#
#      Returns:
#             newval:  (real) Either the input divisor or the replacement value if
#                             the input value is too close to zero.
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        11-FEB-1993
#      UPDATE:
#
#--------------------------------------------------------------------------------------

# Parameters

real val

# Local variables

real repval,newval,tol
int nzero

common /replace/ repval,nzero

begin

      # Check that a number isn't too close to zero...

      tol = 1.0e-20
      newval = val
      if (abs(val) < tol) {
         newval = repval
         nzero = nzero + 1
      }
      return (newval)
end
