procedure sum_frames(nelm,array1,array2,inw,suma,sumw)

#--------------------------------------------------------------------------------------
#      SUM_FRAMES -- Do running sum of frames
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) nelm:       (int) Number of elements in array
#      (>) array1:     (real[nelm]) Input array
#      (>) array2:     (real[nelm]) Input array of running sum
#      (>) inw:        (real[nelm]) Input array of running sum of weights
#      (<) suma:       (real[nelm]) Output array of running sum
#      (<) sumw:       (real[nelm]) Output array of running sum of weights
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        18-NOV-1992
#      UPDATE:
#
#--------------------------------------------------------------------------------------

# Parameters

int nelm
real array1[nelm],array2[nelm],inw[nelm],suma[nelm],sumw[nelm]

# Local variables

int i

begin

      # Do the sum

      do i = 1,nelm {
         suma[i] = array2[i] + array1[i]
         sumw[i] = inw[i] + 1.0
      }
end
