procedure var_div(nelm,dat1,var1,dat2,var2,outvar)
#--------------------------------------------------------------------------------------
#      VAR_DIV -- Calculate variance of quotient of arrays
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) nelm:       (int) Number of elements in array
#      (>) dat1:       (real[nelm]) Input array
#      (>) var1:       (real[nelm]) Variance of dat1
#      (>) dat2:       (real[nelm]) Divisor array
#      (>) var2:       (real[nelm]) Divisor variance
#      (<) outvar:     (real[nelm]) Array of variance of quotients
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        18-NOV-1992
#      UPDATE:      11-FEB-1993 -- Now checks for zero divides (JRL)
#
#--------------------------------------------------------------------------------------

# Parameters

int nelm
real dat1[nelm],dat2[nelm],var1[nelm],var2[nelm],outvar[nelm]

# Local variables

int i
real re1,re2,d1,d2,quo

# Functions 

real check_div()

begin

      # Calculate the variance for a division

      do i = 1,nelm {
         d1 = check_div(dat1[i])
         d2 = check_div(dat2[i])
         quo = d1/d2
         re1 = var1[i]/(d1*d1)
         re2 = var2[i]/(d2*d2)
         outvar[i] = quo*quo*(re1 + re2) 
      }
end
