procedure rep_cr(iptr,nw,ncos,work1,work2,work3)
#--------------------------------------------------------------------------------------
#      REP_CR -- Replace cosmic ray candidate pixels with another value
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) iptr:       (pointer) Pointer to data array
#      (>) nw:         (int) Size of work arrays
#      (>) ncos:       (int) Number of cosmic ray candidates
#      (>) work1:      (int[nw]) X locations of CR candidates
#      (>) work2:      (int[nw]) Y locations of CR candidates
#      (>) work3:      (real[nw]) Replacement values for CR candidates
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        11-FEB-1993
#      UPDATE:
#
#--------------------------------------------------------------------------------------

# Parameters

pointer iptr
int nw,ncos,work2[nw],work3[nw]
real work1[nw]

# Local variables

int i,ii,jj
pointer ptr1

# Functions

pointer imps2r()

begin

      # Replace each each naughty pixel with its predetermined replacement value

      do i = 1,ncos {
         ii = work2[i]
         jj = work3[i]
         ptr1 = imps2r(iptr,ii,ii,jj,jj)
         Memr[ptr1] = work1[i]
      }
end
