procedure sixteen_bit(nelm,array,output)

#--------------------------------------------------------------------------------------
#      SIXTEEN_BIT -- Do 16 bit correction on array
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) nelm:       (int) Number of elements in array
#      (>) array:      (real[nelm]) Input array
#      (<) output:     (real[nelm]) Output array
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        18-NOV-1992
#      UPDATE:
#
#--------------------------------------------------------------------------------------

# Parameters

int nelm
real array[nelm],output[nelm]

# Local variables

int i
real val

begin

      # Do the correction

      do i = 1,nelm {
         val = array[i]
         if (val < 0.0) {
            output[i] = val + 65536.0 }
         else {
            output[i] = val
         }
      }
end
