include <imhdr.h>

procedure check_size(im,nx,ny)

#--------------------------------------------------------------------------------------
#      CHECK_SIZE -- Check that file has same size as chip
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) im:         (pointer) Pointer for data file
#      (>) nx:         (int) X dimension of chip
#      (>) ny:         (int) Y dimension of chip
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        18-NOV-1992
#      UPDATE:
#
#--------------------------------------------------------------------------------------

# Parameters

pointer im
int nx,ny

# Local variables

int nxi,nyi,ndim
pointer mp,sp

begin

      # Get some workspace

      call smark(sp)
      call salloc(mp,SZ_LINE,TY_CHAR)

      # Get the number of dimensions of the file

      ndim = IM_NDIM(im)
      if (ndim != 2) {
         call sprintf(Memc[mp],SZ_LINE,"File %s has wrong number of dimensions")
            call pargstr(IM_HDRFILE(im))
         call error(1,Memc[mp])
      }

      # Get the dimensions of the data array

      nxi = IM_LEN(im,1)
      nyi = IM_LEN(im,2)
      if ((nxi != nx) || (nyi !=ny)) {
         call sprintf(Memc[mp],SZ_LINE,
            "File %s has inappropriate data array dimensions")
            call pargstr(IM_HDRFILE(im))
         call error(2,Memc[mp])
      }

end
