procedure cre_var(nelm,data,read2,phot,variance)

#--------------------------------------------------------------------------------------
#      CRE_VAR -- Create a variance array
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) nelm:       (int) Number of elements in array
#      (>) data:       (real[nelm]) Input data array
#      (>) read2:      (real) Readout noise **2
#      (>) phot:       (real) Inverse of gain (adu/e-)
#      (<) variance:   (real[nelm]) Output variance array
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        18-NOV-1992
#      UPDATE:
#
#--------------------------------------------------------------------------------------

# Parameters

int nelm
real data[nelm],read2,phot,variance[nelm]

# Local variables

int i
real val

begin

      # Go through and create the variance image in ADUs

      do i = 1,nelm {
         val = data[i]
         variance[i] = read2 + phot*abs(val) 
      }
end
