include <imhdr.h>

procedure get_exp(im,exphead,exp_time)

#--------------------------------------------------------------------------------------
#      GET_EXP -- Get the exposure time from the header
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      (>) im:         (pointer) Pointer to data file 
#      (>) exphead:    (char[ARB]) Location in header of exposure time info
#      (<) exp_time:   (real) Exposure time
#
#
#      AUTHOR:      Jim Lewis -- RGO
#      DATE:        18-NOV-1992
#      UPDATE:
#
#--------------------------------------------------------------------------------------

# Parameters

pointer im
real exp_time
char exphead[ARB]

# Local variables

pointer sp,lp

# Functions

int imaccf()
real imgetr()

begin

      # Get some workspace

      call smark(sp)
      call salloc(lp,SZ_LINE,TY_CHAR)

      # Check to see that the exposure time exists...

      if (imaccf(im,exphead) == YES) {
         exp_time = imgetr(im,exphead)
         if (exp_time < 0.0) call error(0,"Negative exposure time")
      }
      else {
         call sprintf(Memc[lp],SZ_LINE,
         "Exposure time doesn't exist in header of %s")
            call pargstr(IM_HDRFILE(im))
         call error(0,Memc[lp])
      }

      # Free workspace

      call sfree(sp)
end
