int procedure scplog()
#--------------------------------------------------------------------------------------
#      SCPLOG -- Create log file name, making sure it is the next highest
#                version number.  Open the file and return the file descriptor
#
#      Parameters (">" Input, "<" Output, "W" Workspace, "!" Changed)
#
#      None
#
#      Returns:
#          fd:         (int) Descriptor for the output log file
#
#
#      AUTHOR:      Jim Lewis -- RGO, based on algorithm stolen from dp_oversion
#                                in the DAOPHOT package, author unknown.
#      DATE:        02-MAR-1992
#      UPDATE:
#
#--------------------------------------------------------------------------------------

# Local variables

char period
int newversion,version,len,fd
pointer sp,list,name,template

# Functions

int fntgfnb(),strldx(),ctoi(),open()
pointer fntopnb()

begin
      # Get stack workspace 

      call smark(sp)
      call salloc(name,SZ_FNAME,TY_CHAR)
      call salloc(template,SZ_FNAME,TY_CHAR)

      # Set up template list

      period = '.'
      call strcpy("scp_log.*",Memc[template],SZ_FNAME)
      list = fntopnb (Memc[template], NO)

      # Loop over the names in the list searchng for the highest version.

      newversion = 0
      while (fntgfnb (list,Memc[name],SZ_FNAME) != EOF) {
         len = strldx (period,Memc[name])
         len = len + 1
         if (ctoi (Memc[name],len,version) <= 0) next
         newversion = max(newversion,version)
      }

      # Make new output file name.

      newversion = newversion + 1
      len = strldx(period,Memc[template])
      call strcpy(Memc[template],Memc[name],len)
      call sprintf(Memc[name+len],SZ_FNAME,"%d")
         call pargi(newversion)

      # Now open the file

      fd = open(Memc[name],NEW_FILE,TEXT_FILE)

      # Ditch some workspace

      call fntclsb(list)
      call sfree(sp)

      # Return file descriptor

      return (fd)
end
