procedure calrun(images,type,wave,mpu0,dmpu,run)

# Query Parameters

string     type          {prompt="Image type"}
string     images        {prompt="List of input images"}
string     wave          {prompt="Wavelength in microns"}
string     mpu0          {prompt="Microprocessor coordinate for first frame"}
string     dmpu          {prompt="Microprocessor increment between frames"}
string     run           {prompt="Run number for this file"}

# Image list

struct     *inlist

begin

      # Local variables

      string typ,tmpfil,iname,rnum,wavelength,xmpu0,xdmpu

      # Get the image type first.  

      typ = type

      # Expand input image list

      tmpfil = mktemp("FP")
      sections(images,option="fullname",>tmpfil)
      inlist = tmpfil       
      
      # Loop until there are no more files...

      while(fscan(inlist,iname) != EOF) {
         print(" ")
         print("Information about frame:  ",iname)
         rnum = run

         # Test for file type

         if (typ == "cal" || typ == "obs") {
            wavelength = wave
            xmpu0 = mpu0
            xdmpu = dmpu
            hedit(iname,"run",rnum,add+,del-,ver-,show-,upd+)
            hedit(iname,"type",typ,add+,del-,ver-,show-,upd+)
            hedit(iname,"wave",wavelength,add+,del-,ver-,show-,upd+)
            hedit(iname,"mpu0",xmpu0,add+,del-,ver-,show-,upd+)
            hedit(iname,"dmpu",xdmpu,add+,del-,ver-,show-,upd+)
         } else if (typ == "mask") {
            hedit(iname,"run",rnum,add+,del-,ver-,show-,upd+)
            hedit(iname,"type","mask",add+,del-,ver-,show-,upd+)
         } else if (typ == "ring") {
            wavelength = wave
            xmpu0 = mpu0
            hedit(iname,"run",rnum,add+,del-,ver-,show-,upd+)
            hedit(iname,"type","ring",add+,del-,ver-,show-,upd+)
            hedit(iname,"wave",wavelength,add+,del-,ver-,show-,upd+)
            hedit(iname,"mpu0",xmpu0,add+,del-,ver-,show-,upd+)
         } else {
            error(1,"Unrecognised file type:  "//typ)
         }
      }
    
      # Ditch temporary file

      delete(tmpfil,go+,ver-,def+,all+,sub+)
end
