include <imhdr.h>                   
include <mwset.h>

procedure fpmw(mw,wave0,disp,r,w,cd,pdim)

# Parameters

pointer mw
real wave0,disp
int pdim
double r[pdim],w[pdim],cd[pdim,pdim]

# Local variables

int ival,axbits,axes[IM_MAXDIM],naxes,axmap,ax

# Functions

int mw_stati()

begin
      # Set the wcs

      iferr (call mw_newsystem(mw,"world",pdim)) 
         call mw_ssystem(mw,"world")

      # Get an axis list

      ival = 2**pdim - 1
      call bitpak(ival,axbits,1,pdim)
      call mw_gaxlist(mw,axbits,axes,naxes)
      if (naxes < 2) return

      # Switch off axis mapping

      axmap = mw_stati(mw,MW_USEAXMAP)
      call mw_seti(mw,MW_USEAXMAP,NO)

      # Get the Wterm of the wcs

      call mw_gwtermd(mw,r,w,cd,pdim)      

      # Which axis is this?

      ax = axes[1]

      # Set the dispersion and wavelength zeropoint in the Wterm 

      cd[ax,ax] = double(disp)
      r[ax] = 1.0d0
      w[ax] = double(wave0)
      call mw_swtermd(mw,r,w,cd,pdim)

      # Define the wavelength attributes for the spectral axis

      call mw_swtype(mw,ax,1,"linear","")
      call mw_swattrs(mw,ax,"label","Wavelength")
      call mw_swattrs(mw,ax,"units","Angstroms")

      # Reset axis mapping

      call mw_seti(mw,MW_USEAXMAP,axmap)
end

                    
