include "rings.h"
include <tbset.h>

pointer procedure ring_init()

# Local variables

pointer rp

begin

      # Allocate the structure space first...

      call malloc(rp,LEN_STR,TY_STRUCT)

      # Now fill in the names...

      call strcpy("RunNum",RING_CNAM(rp,COLRUN),SZ_COLNAME)
      call strcpy("mpu",RING_CNAM(rp,COLMPU),SZ_COLNAME)
      call strcpy("Xc",RING_CNAM(rp,COLXC),SZ_COLNAME)
      call strcpy("Yc",RING_CNAM(rp,COLYC),SZ_COLNAME)
      call strcpy("Radius",RING_CNAM(rp,COLRAD),SZ_COLNAME)
      call strcpy("Sigma",RING_CNAM(rp,COLSIG),SZ_COLNAME)
      call strcpy("Peak",RING_CNAM(rp,COLPK),SZ_COLNAME)
      call strcpy("Backgrnd",RING_CNAM(rp,COLBK),SZ_COLNAME)
      call strcpy("Ellipt",RING_CNAM(rp,COLELL),SZ_COLNAME)
      call strcpy("MeanErr",RING_CNAM(rp,COLME),SZ_COLNAME)
      call strcpy("Errflag",RING_CNAM(rp,COLFLG),SZ_COLNAME)

      # Fill in the units

      call strcpy("(none)",RING_CUNI(rp,COLRUN),SZ_COLUNITS)
      call strcpy("MPUs",RING_CUNI(rp,COLMPU),SZ_COLUNITS)
      call strcpy("pixels",RING_CUNI(rp,COLXC),SZ_COLUNITS)
      call strcpy("pixels",RING_CUNI(rp,COLYC),SZ_COLUNITS)
      call strcpy("pixels",RING_CUNI(rp,COLRAD),SZ_COLUNITS)
      call strcpy("pixels",RING_CUNI(rp,COLSIG),SZ_COLUNITS)
      call strcpy("counts",RING_CUNI(rp,COLPK),SZ_COLUNITS)
      call strcpy("counts",RING_CUNI(rp,COLBK),SZ_COLUNITS)
      call strcpy("b/a",RING_CUNI(rp,COLELL),SZ_COLUNITS)
      call strcpy("counts",RING_CUNI(rp,COLME),SZ_COLUNITS)
      call strcpy("(none)",RING_CUNI(rp,COLFLG),SZ_COLUNITS)

      # Fill in formats

      call strcpy("%6d",RING_CFMT(rp,COLRUN),SZ_COLFMT)
      call strcpy("%9.3f",RING_CFMT(rp,COLMPU),SZ_COLFMT)
      call strcpy("%9.3f",RING_CFMT(rp,COLXC),SZ_COLFMT)
      call strcpy("%9.3f",RING_CFMT(rp,COLYC),SZ_COLFMT)
      call strcpy("%9.3f",RING_CFMT(rp,COLRAD),SZ_COLFMT)
      call strcpy("%9.3f",RING_CFMT(rp,COLSIG),SZ_COLFMT)
      call strcpy("%9.3f",RING_CFMT(rp,COLPK),SZ_COLFMT)
      call strcpy("%9.3f",RING_CFMT(rp,COLBK),SZ_COLFMT)
      call strcpy("%9.3f",RING_CFMT(rp,COLELL),SZ_COLFMT)
      call strcpy("%9.3f",RING_CFMT(rp,COLME),SZ_COLFMT)
      call strcpy("%6d",RING_CFMT(rp,COLFLG),SZ_COLFMT)

      # Fill in the data types

      RING_CDTY(rp,COLRUN) = TY_INT
      RING_CDTY(rp,COLMPU) = TY_REAL
      RING_CDTY(rp,COLXC) = TY_REAL
      RING_CDTY(rp,COLYC) = TY_REAL
      RING_CDTY(rp,COLRAD) = TY_REAL
      RING_CDTY(rp,COLSIG) = TY_REAL
      RING_CDTY(rp,COLPK) = TY_REAL
      RING_CDTY(rp,COLBK) = TY_REAL
      RING_CDTY(rp,COLELL) = TY_REAL
      RING_CDTY(rp,COLME) = TY_REAL
      RING_CDTY(rp,COLFLG) = TY_INT

      # Return the pointer

      return (rp)
end


procedure ring_close(rp)

# Parameters

pointer rp

begin

      # Ditch workspace

      call mfree(rp,TY_STRUCT)
end
