include <tbset.h>
include "rings.h"

procedure rvclose(optr)

# Parameters

pointer optr

begin

      # Close the rvf/rvt table

      call tbtclo(optr)
end


pointer procedure rvcreate(rp,rvname)

# Parameters

pointer rvname,rp

# Local variables

int i 
pointer optr,wpt1

# Functions

pointer tbtopn()

begin

      # Open output rvf/rvt file and define the columns...

      optr = tbtopn(Memc[rvname],NEW_FILE,NULL)
      call tbtcre(optr)
      do i = 1,RING_NCOL
         call tbcdef(optr,wpt1,RING_CNAM(rp,i),RING_CUNI(rp,i),
            RING_CFMT(rp,i),RING_CDTY(rp,i),1,1)
      call tbtflu(optr)
      return (optr)
end

pointer procedure rvopen(rvname,mode)

# Parameters

pointer rvname
int mode

# Local variables

pointer optr

# Functions

pointer tbtopn()

begin

      # Open the rvf/rvt table

      optr = tbtopn(Memc[rvname],mode,NULL)
      return (optr)
end


procedure rvgetl(optr,rp,row,err,run,mpu,xc,yc,rad,sig,peak,back,ell,meanerr,
   flag)

# Parameters

pointer optr,rp
int run,flag,row
real mpu,xc,yc,rad,sig,peak,back,ell,meanerr
bool err

# Local variables

int i,dummy,irow
pointer cptr

begin

      # First get the results from the table

      irow = 2*(row-1) + 1
      if (err) irow = irow + 1
      do i = 1,RING_NCOL {
         call tbcfnd(optr,RING_CNAM(rp,i),cptr,1)
         switch (RING_CDTY(rp,i)) {
            case TY_REAL:
               call tbegtr(optr,cptr,irow,RING_RES(rp,i))
            case TY_INT:
               call tbegti(optr,cptr,irow,dummy)
               RING_RES(rp,i) = real(dummy) 
         }
      }

      # Now sort out the results 

      run = RING_RES(rp,COLRUN) 
      mpu = RING_RES(rp,COLMPU) 
      xc = RING_RES(rp,COLXC)  
      yc = RING_RES(rp,COLYC)  
      rad = RING_RES(rp,COLRAD) 
      sig = RING_RES(rp,COLSIG) 
      peak = RING_RES(rp,COLPK)  
      back = RING_RES(rp,COLBK)  
      ell = RING_RES(rp,COLELL) 
      meanerr = RING_RES(rp,COLME) 
      flag = RING_RES(rp,COLFLG) 
end

procedure rvputl(optr,rp,row,err,run,mpu,xc,yc,rad,sig,peak,back,ell,meanerr,
   flag)

# Parameters

pointer optr,rp
int run,flag,row
real mpu,xc,yc,rad,sig,peak,back,ell,meanerr
bool err

# Local variables

int i,irow
pointer cptr

begin

      # Sort out results initially...

      RING_RES(rp,COLRUN) = real(run)
      RING_RES(rp,COLMPU) = mpu
      RING_RES(rp,COLXC)  = xc
      RING_RES(rp,COLYC)  = yc
      RING_RES(rp,COLRAD) = rad
      RING_RES(rp,COLSIG) = sig
      RING_RES(rp,COLPK)  = peak
      RING_RES(rp,COLBK)  = back
      RING_RES(rp,COLELL) = ell
      RING_RES(rp,COLME) = meanerr
      RING_RES(rp,COLFLG) = real(flag)

      # Now write the results out to the table

      irow = 2*(row-1) + 1
      if (err) irow = irow + 1
      do i = 1,RING_NCOL {
         call tbcfnd(optr,RING_CNAM(rp,i),cptr,1)
         switch (RING_CDTY(rp,i)) {
            case TY_REAL:
               call tbeptr(optr,cptr,irow,RING_RES(rp,i))
            case TY_INT:
               call tbepti(optr,cptr,irow,nint(RING_RES(rp,i)))
         }
      }
end

procedure rvfinit(optr,rp,nz,mpu0,dmpu,run)

# Parameters

pointer optr,rp
int nz,run
real mpu0,dmpu

# Local variables

int i
real mpu

begin

      # Loop for the number of frames...

      do i = 1,nz {
         mpu = mpu0 + real(i-1)*dmpu
         call rvputl(optr,rp,i,false,run,mpu,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,
            RING_SKIP)
         call rvputl(optr,rp,i,true,run,mpu,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,
            RING_SKIP)
      }
end
          
int procedure rvnfrm(optr)

# Parameters

pointer optr

# Local variables

int nframes

# Functions

int tbpsta()

begin
   
      # Get the number of lines in the rvf/rvt and divide by two to 
      # account for the error esimates...

      nframes = tbpsta(optr,TBL_NROWS)/2
      return(nframes)
end
              
