include <ctype.h>
include <fset.h>
include <error.h>

procedure t_calbasic()

# Local variables

pointer sp,dname,fname,dirname,msg
bool stand
int fd,nset,iset,net,ieta,ndet,idet,ijunk
real junk

# Functions

bool clgetb()
int open(),fscan(),stridx(),clgeti(),fstati(),isdirectory()
real calr(),clgetr()

begin

      # Get some workspace

      call smark(sp)
      call salloc(dname,SZ_PATHNAME,TY_CHAR)
      call salloc(fname,SZ_FNAME,TY_CHAR)
      call salloc(dirname,SZ_PATHNAME,TY_CHAR)
      call salloc(msg,SZ_LINE,TY_CHAR)

      # Flush buffered output immediately

      if (fstati(STDOUT,F_REDIR) == NO) call fseti(STDOUT,F_FLUSHNL,YES)

      # Is this a standard or a DIY set up?

      stand = clgetb("stand")

      # If this is a standard setup, then start by finding the location
      # of the standard files...

      if (stand) {
         call clgstr("stddir",Memc[dname],SZ_PATHNAME)
         if (isdirectory(Memc[dname],Memc[dirname],SZ_PATHNAME) <= 0) {
            call sprintf(Memc[msg],SZ_LINE,"%s is not a directory")
               call pargstr(Memc[dname])
            call error(0,Memc[msg])
         }

         # Get the name of the setup file and open it

         call clgstr("setfile",Memc[fname],SZ_FNAME)
         call strcpy(Memc[dirname],Memc[dname],SZ_PATHNAME)
         call strcat(Memc[fname],Memc[dname],SZ_PATHNAME)
         iferr(fd = open(Memc[dname],READ_ONLY,TEXT_FILE)) {
            call sprintf(Memc[msg],SZ_LINE,"Can't find file %s")
               call pargstr(Memc[dname])
            call error(0,Memc[msg])
         }

         # Write the list of setups to the screen

         nset = 0
         while (fscan(fd) != EOF) {
            call gargstr(Memc[msg],SZ_LINE)
            if (stridx("#",Memc[msg]) == 1) break
            call printf("%s\n")
               call pargstr(Memc[msg])
            nset = nset + 1
         }
         nset = nset - 1  # Top line is a comment, not a setup

         # Which setup do you want?

         call clputi("n_setup.p_max",nset)
         iset = clgeti("n_setup")
         iferr(call findit(fd,iset,"setup",Memc[msg])) call erract(EA_ERROR)
               
         # Read the setup file and set the various parameters

         call calstr(fd,SZ_LINE,"setup",Memc[msg])
         call clpstr("tel_name",Memc[msg])
         call calstr(fd,SZ_LINE,"setup",Memc[msg])
         call clpstr("tel_stat",Memc[msg])
         junk = calr(fd,"setup")
         call clputr("tel_sc",junk)
         junk = calr(fd,"setup")
         call clputr("tel_fnum",junk)
         junk = calr(fd,"setup")
         call clputr("tel_flen",junk)
         junk = calr(fd,"setup")
         call clputr("inst_ver",nint(junk))
         junk = calr(fd,"setup")
         call clputr("col_flen",junk)
         junk = calr(fd,"setup")
         call clputr("cam_fnum",junk)
         junk = calr(fd,"setup")
         call clputr("cam_flen",junk)
         junk = calr(fd,"setup")
         call clputr("mask_sep",junk)

         # Now close that file and open the etalon file...

         call close(fd)
         call clgstr("etfile",Memc[fname],SZ_FNAME)
         call strcpy(Memc[dirname],Memc[dname],SZ_PATHNAME)
         call strcat(Memc[fname],Memc[dname],SZ_PATHNAME)
         iferr(fd = open(Memc[dname],READ_ONLY,TEXT_FILE)) {
            call sprintf(Memc[msg],SZ_LINE,"Can't find file %s")
               call pargstr(Memc[dname])
            call error(0,Memc[msg])
         }

         # Write the list of etalons to the screen

         net = 0
         while (fscan(fd) != EOF) {
            call gargstr(Memc[msg],SZ_LINE)
            if (stridx("#",Memc[msg]) == 1) break
            call printf("%s\n")
               call pargstr(Memc[msg])
            net = net + 1
         }
         net = net - 1   # First line is a comment

         # Which etalon do you want?

         call clputi("n_eta.p_max",net)
         ieta = clgeti("n_eta")
         iferr(call findit(fd,ieta,"etalon",Memc[msg])) call erract(EA_ERROR)
               
         # Now read the etalon file and set the various parameters

         call calstr(fd,SZ_LINE,"etalon",Memc[msg])
         call clpstr("et_name",Memc[msg])
         junk = calr(fd,"etalon")
         call clputr("et_rng1",junk)
         junk = calr(fd,"etalon")
         call clputr("et_rng2",junk)
         junk = calr(fd,"etalon")
         call clputr("et_refl",junk)
         junk = calr(fd,"etalon")
         call clputr("et_ngap",junk)

         # Now close that file and open the detector file...

         call close(fd)
         call clgstr("detfile",Memc[fname],SZ_FNAME)
         call strcpy(Memc[dirname],Memc[dname],SZ_PATHNAME)
         call strcat(Memc[fname],Memc[dname],SZ_PATHNAME)
         iferr(fd = open(Memc[dname],READ_ONLY,TEXT_FILE)) {
            call sprintf(Memc[msg],SZ_LINE,"Can't find file %s")
               call pargstr(Memc[dname])
            call error(0,Memc[msg])
         }

         # Write the list of detectors to the screen

         ndet = 0
         while (fscan(fd) != EOF) {
            call gargstr(Memc[msg],SZ_LINE)
            if (stridx("#",Memc[msg]) == 1) break
            call printf("%s\n")
               call pargstr(Memc[msg])
            ndet = ndet + 1
         }
         ndet = ndet - 1   # First line is a comment

         # Which detector do you want?

         call clputi("n_det.p_max",ndet)
         idet = clgeti("n_det")
         iferr(call findit(fd,idet,"detector",Memc[msg])) call erract(EA_ERROR)

         # Now read the detector file

         call calstr(fd,SZ_LINE,"detector",Memc[msg])
         call clpstr("det_name",Memc[msg])
         call close(fd)

      # If this isn't a standard setup then just prompt for all the values...

      } else {

         # Setup parameters

         call clgstr("tel_name",Memc[msg],SZ_LINE)
         call clgstr("tel_stat",Memc[msg],SZ_LINE)
         junk = clgetr("tel_sc")
         junk = clgetr("tel_fnum")
         junk = clgetr("tel_flen")
         ijunk = clgeti("inst_ver")
         junk = clgetr("col_flen")
         junk = clgetr("cam_fnum")
         junk = clgetr("cam_flen")
         junk = clgetr("mask_sep")
               
         # Etalon parameters

         call clgstr("et_name",Memc[msg],SZ_LINE)
         junk = clgetr("et_rng1")
         junk = clgetr("et_rng2")
         junk = clgetr("et_refl")
         junk = clgetr("et_ngap")

         # Detector parameters

         call clgstr("det_name",Memc[msg],SZ_LINE)
      }

      # Ditch workspace

      call sfree(sp)
end


real procedure calr(fd,type)

# Parameters

int fd
char type[ARB]

# Local variables

pointer sp,data
int junk,ist
real val

# Functions

int fscan(),strldx(),sscan()

begin

      # Get workspace

      call smark(sp)
      call salloc(data,SZ_LINE,TY_CHAR)

      # Read a line from the file

      junk = fscan(fd)
      if (junk == EOF) {
         call sprintf(Memc[data],SZ_LINE,"Premature end of %s file")
            call pargstr(type)
         call error(0,Memc[data])
      }
      call gargstr(Memc[data],SZ_LINE)

      # Find out where the ! is in the file and increment it

      ist = strldx("!",Memc[data]) + 1
      if (ist == 1) {
         call sprintf(Memc[data],SZ_LINE,"Missing ! in %s file")
            call pargstr(type)
         call error(0,Memc[data])
      }

      # Take out the white spaces

      while (IS_WHITE(Memc[data+ist-1]))
         ist = ist + 1

      # Now read the value in the data string

      junk = sscan(Memc[data+ist-1])
         call gargr(val)

      # Ditch workspace

      call sfree(sp)

      # Return the value

      return(val)
end



procedure calstr(fd,maxch,type,val)

# Parameters

int fd,maxch
char val[ARB],type[ARB]

# Local variables

pointer sp,data
int junk,ist

# Functions

int fscan(),strldx()

begin

      # Get some workspace

      call smark(sp)
      call salloc(data,SZ_LINE,TY_CHAR)

      # Read a line from the file

      junk = fscan(fd)
      if (junk == EOF) {
         call sprintf(Memc[data],SZ_LINE,"Premature end of %s file")
            call pargstr(type)
         call error(0,Memc[data])
      }
      call gargstr(Memc[data],SZ_LINE)

      # Find out where the ! is in the file and increment it

      ist = strldx("!",Memc[data]) + 1
      if (ist == 1) {
         call sprintf(Memc[data],SZ_LINE,"Missing ! in %s file")
            call pargstr(type)
         call error(0,Memc[data])
      }

      # Take out the white spaces

      while (IS_WHITE(Memc[data+ist-1]))
         ist = ist + 1

      # Now copy the data over

      call strcpy(Memc[data+ist-1],val,maxch)

      # Ditch workspace

      call sfree(sp)
end


procedure findit(fd,which,type,data)

# Parameters

int fd,which
char type[ARB],data[ARB]

# Local variables

int nfound

# Functions

int fscan(),stridx()

begin

      # Search for # in first column to denote start of a new setup.

      nfound = 1
      while (nfound != which) {
         while (fscan(fd) != EOF) {
            call gargstr(data,SZ_LINE)
            if (stridx("#",data) == 1) break
         }
         if (stridx("#",data) == 1) {
            nfound = nfound + 1
         } else {
            call sprintf(data,SZ_LINE,"Couldn't find %s #%d in standard file.")
               call pargstr(type)
               call pargi(which)
            call error(0,data)
         }
      }

      # Send out a friendly message

      call printf(" \n")
      call printf("You have chosen %s:   %s\n")
         call pargstr(type)
         call pargstr(data)
      call printf(" \n")
end
