include "tgrid.h"

procedure t_grid()

# Local variables

pointer sp,oname,tgp,template,optr,ptr,wptr,xptr,yptr,dxxptr,dxyptr,
   dyxptr,dyyptr
int ndim,dims[3]

# Functions

pointer tg_init(),rt_crfile(),imps3s()

begin

      # Allocate some workspace

      call smark(sp)
      call salloc(oname,SZ_FNAME,TY_CHAR)

      # Open tg structure and fill it.

      tgp = tg_init()

      # Get name of output file and open it...

      call clgstr("gfile",Memc[oname],SZ_FNAME)
      template = NULL
      ndim = 3
      dims[1] = 2
      dims[2] = TG_XMAX(tgp)
      dims[3] = TG_YMAX(tgp)
      optr = rt_crfile(Memc[oname],NEW_FILE,template,ndim,dims,TY_SHORT)

      # Map the whole output file...

      ptr = imps3s(optr,1,dims[1],1,dims[2],1,dims[3])

      # Allocate some workspace

      call calloc(wptr,dims[2],TY_REAL)
      call malloc(xptr,dims[2],TY_REAL)
      call malloc(yptr,dims[2],TY_REAL)
      call malloc(dxxptr,dims[2],TY_REAL)
      call malloc(dxyptr,dims[2],TY_REAL)
      call malloc(dyxptr,dims[2],TY_REAL)
      call malloc(dyyptr,dims[2],TY_REAL)

      # Create the grid...

      call sub_grid(dims[1],dims[2],dims[3],tgp,Memr[wptr],Memr[xptr],
         Memr[yptr],Memr[dxxptr],Memr[dxyptr],Memr[dyxptr],Memr[dyyptr],
         Mems[ptr])

      # Add some stuff to the grid header

      call imaddr(optr,"pixx",TG_PIXX(tgp))
      call imaddr(optr,"pixy",TG_PIXY(tgp))

      # Release some workspace

      call imunmap(optr)
      call tg_close(tgp)
      call mfree(wptr,TY_REAL)
      call mfree(xptr,TY_REAL)
      call mfree(yptr,TY_REAL)
      call mfree(dxxptr,TY_REAL)
      call mfree(dxyptr,TY_REAL)
      call mfree(dyxptr,TY_REAL)
      call mfree(dyyptr,TY_REAL)
      call sfree(sp)
end

procedure sub_grid(nz,nx,ny,tgp,sumy,xt,yt,dxx,dxy,dyx,dyy,output)

# Parameters

int nz,nx,ny
real sumy[nx],xt[nx],yt[nx],dxx[nx],dxy[nx],dyx[nx],dyy[nx]
short output[nz,nx,ny]
pointer tgp

# Local variables

int i,j
real pixx,pixy,sumx,ddx,ddy

begin

      # Initialise a few things

      pixx = TG_PIXX(tgp)
      pixy = TG_PIXY(tgp)

      # Now create the real type grid

      do i = 1,nx
         xt[i] = real(i)
      do j = 1,ny {
         sumx = 0.0
         call amovkr(real(j),yt,nx)
         call gsder(TG_GSFX(tgp),xt,yt,dxx,nx,1,0)
         call gsder(TG_GSFX(tgp),xt,yt,dxy,nx,0,1)
         call gsder(TG_GSFY(tgp),xt,yt,dyx,nx,1,0)
         call gsder(TG_GSFY(tgp),xt,yt,dyy,nx,0,1)
         do i = 1,nx {
            ddx = TG_SHRINK(tgp)*sqrt(dxx[i]*dxx[i] + dyx[i]*dyx[i])/pixx
            #not pixy. on next line...want sq.pix
            ddy = TG_SHRINK(tgp)*sqrt(dxy[i]*dxy[i] + dyy[i]*dyy[i])/pixx 
            sumx = sumx + ddx
            sumy[i] = sumy[i] + ddy
            output[1,i,j] = nint(100*(sumx - xt[i]))
            output[2,i,j] = nint(100*(sumy[i] - yt[i]))
         }
         if (mod(j,50) == 0) {
            call printf("Done line %d\n")
               call pargi(j)
            call flush(STDOUT)
         }
      }
end
