include "tau.h"

pointer procedure tau_open(mode)

# Parameters

int mode

# Local variables

pointer sp,dbase,errmsg,name,taupt
int acc,i

# Functions

int access(),tbtacc(),strldx(),strlen()
pointer tau_init()

begin

      # Get some work space

      call smark(sp)
      call salloc(dbase,SZ_FNAME,TY_CHAR)
      call salloc(errmsg,SZ_LINE,TY_CHAR)
      call salloc(name,SZ_FNAME,TY_CHAR)

      # Get the database subdirectory. Make sure there is a / at the end.

      call clgstr("taucal.dbase",Memc[dbase],SZ_FNAME)
      call clpstr("dbase",Memc[dbase],SZ_FNAME)
      call clgstr("dbase",Memc[dbase],SZ_FNAME)
      if (strldx("/",Memc[dbase]) != strlen(Memc[dbase])) 
         call strcat("/",Memc[dbase],SZ_FNAME)

      # Can we access this directory?

      acc = access(Memc[dbase],0,0)

      # If the database already exists and we wanted to create a new
      # one, then signal an error here...

      if (mode == NEW_FILE && acc == YES) {
         call sprintf(Memc[errmsg],SZ_LINE,
            "Cannot create new database in subdirectory %s")
         call pargstr(Memc[dbase])
         call error(0,Memc[errmsg])

      # If the database doesn't exist and we wanted to open an old one,
      # then signal an error 

      } else if (mode != NEW_FILE && acc == NO) {
         call sprintf(Memc[errmsg],SZ_LINE,
            "Cannot open old database in subdirectory %s")
         call pargstr(Memc[dbase])
         call error(0,Memc[errmsg])

      # Otherwise go through the database and see what you have...

      } else {
         taupt = tau_init()
         call strcpy(Memc[dbase],TAU_DB(taupt),SZ_FNAME)
         do i = 1,TAU_NTYPE {
            call strcpy(Memc[dbase],Memc[name],SZ_FNAME)
            call strcat(TYPE_NAM(taupt,i),Memc[name],SZ_FNAME)
            TAB_ACC(taupt,i) = tbtacc(Memc[name])
         }
      }

      # Free some workspace

      call sfree(sp)

      # Return the pointer 

      return (taupt)
end


pointer procedure tau_init()

# Local variables

pointer taupt

begin

      # Allocate the scratch space for the TAUCAL data structure

      call calloc(taupt,LEN_TS,TY_STRUCT)

      # Set up table file names...

      call tau_names(taupt)

      # Return the pointer

      return (taupt)
end

procedure tau_names(taupt)

# Parameters

pointer taupt

begin

      # Assign the file names

      call strcpy("basic",TYPE_NAM(taupt,TAU_BASIC),TAU_TYSZ)
      call strcpy("mask",TYPE_NAM(taupt,TAU_MASK),TAU_TYSZ)
      call strcpy("grid",TYPE_NAM(taupt,TAU_GRID),TAU_TYSZ)
      call strcpy("rvf",TYPE_NAM(taupt,TAU_RVF),TAU_TYSZ)
      call strcpy("rvt",TYPE_NAM(taupt,TAU_RVT),TAU_TYSZ)
      call strcpy("run",TYPE_NAM(taupt,TAU_RUN),TAU_TYSZ)
end

procedure tau_close(taupt)

# Parameters

pointer taupt

begin

      # Release the workspace associated with TAUCAL data structure

      call mfree(taupt,TY_STRUCT)

end

