procedure knit (firstfile,output) 

file   firstfile    {prompt="Name of first file of set"}
file   output       {prompt="Output file name"}

begin

    file first,out,fname,oname,temp
    int firstrun,currun

    # Get query parameters

    first = firstfile
    out = output

    # Create an output file 

    mkpattern(out,output="",pattern="constant",option="replace",v1=0,v2=0,
        size=1,pixtype="real",ndim=2,title="",ncols=3072,nlines=3074,
        n3=1,n4=1,n5=1,n6=1,header=first)

    # Get the run number for the first file.

    hselect(first,"RUN",yes) | scan(firstrun)

    # Ok, start copying...

    currun = firstrun + 2
    fname = "r"//currun//"[1:2048:2,1:4100:2]"
    oname = out//"[1:1024,1:2050]"
    imcopy(fname,oname,verbose=no)
    currun = firstrun + 3
    fname = "r"//currun//"[1:2048:2,1:4100:2]"
    oname = out//"[1025:2048,1:2050]"
    imcopy(fname,oname,verbose=no)
    currun = firstrun
    fname = "r"//currun//"[1:2048:2,1:4100:2]"
    oname = out//"[2049:3072,1:2050]"
    imcopy(fname,oname,verbose=no)

    # Rotate number two

    temp = mktemp("tmpiraf")
    currun = firstrun + 1
    fname = "r"//currun//"[1:2048:2,1:4100:2]"
    rotate(fname,temp,-90.0,xin=512,yin=1025,xout=1025,yout=512,ncols=2050,
        nlines=1024,interpolant="linear",boundary="nearest",constant=0,
        nxblock=512,nyblock=512,verbose=no)

    # Now copy that one in

    oname = out//"[1023:3072,2051:3074]"
    imcopy(temp//"[1:2050,1:1024]",oname,verbose=no)
    imdelete(temp,verify=no)
end

