#ifndef APDEF
#define APDEF
typedef struct
{
	short int areal[8];	/* height above thresh of areal-prof cuts */
	int lsiz;		/* size of a line */
	int maxip;		/* max no. of parents ever used. */
	int maxbl;		/* size of pixel-storage block stack */
	int maxpa;		/* size of parent-stack. */
	int ipnop;		/* parent-number-of-pixels, min size of image */
	int nimages;		/* count of images */
	int ipstack;		/* parent-name stack pointer */
	int ibstack;		/* pixel-block name stack pointer */
	int thresh;		/* threshold for image detection */
	int background;		/* background value */
	float sigma;		/* median background sigma */
	int multiply;		/* smoothing multiplication */

	int *blink;		/* block-link array */
	int *bstack;		/* stack of pixel names */
	struct {		/* Image control block array */
		int first;	/* link to first data block */
		int last;	/* current last block	*/
		int pnop;	/* Parent no. pixels (-1 = inactive) */
		int growing;
		int touch;	/* 0 = does not touch an edge */
		} *parent;

	short int *pstack;	/* stack of parent names */
	struct {		/* x,y,i storage array */
		int x,y,z;
		} *plessey;
	short int *lastline;	/* Parents on last line */
} ap_t;
typedef struct
{
	float x;		/* x position 				*/
	float y;		/* y position				*/
	float total;		/* total integrated intensity		*/
	int area;		/* image area in pixels			*/
	int peak;		/* peak image intensity above sky	*/
	float xx;		/* 2nd moment x				*/
	float xy;		/* 2nd moment cross term		*/
	float yy;		/* 2nd moment y				*/
	int areal[8];		/* areal profile of image		*/
} apmCat_t;
#endif
