#include <stdlib.h>
#include "ap.h"

void apinit(ap_t *ap)
{
	int maxpa;
	int maxbl = 10000;

	int i;

	maxpa = ap->lsiz / 2;		/* max possible parents */
	ap->lastline = calloc(ap->lsiz + 1, sizeof(short int));
	ap->maxip = 0;
	ap->maxpa = maxpa;
	ap->pstack = malloc(maxpa * sizeof(*ap->pstack));
	ap->parent = malloc(maxpa * sizeof(*(ap->parent)));
	for(i=0; i<maxpa; i++)
	{
		ap->pstack[i] = i;
		ap->parent[i].pnop = -1;	/* mark all parents inactive */
	}
	ap->ipstack = 1;
	ap->maxbl = maxbl;
	ap->bstack = malloc(ap->maxbl * sizeof(*ap->bstack));
	ap->blink = malloc(ap->maxbl * sizeof(*ap->blink));
	ap->plessey = malloc(ap->maxbl * sizeof(*ap->plessey));
	for (i=0; i<maxbl; i++)
		ap->bstack[i] = i;
	ap->ibstack = 2;	/* block 1 will get overwritten; don't use it */
	ap->nimages = 0;

	/* set up exponential areal-profile levels: */
	ap->areal[0] = 1;
	for (i=1; i<8; i++)
		ap->areal[i] = ap->areal[i-1]*2;
}

void apclose(ap_t *ap) {
    free(ap->lastline);
    free(ap->pstack);
    free(ap->parent);
    free(ap->bstack);
    free(ap->blink);
    free(ap->plessey);
}
