#include <stdio.h>
#include "ap.h"

void apline(ap_t   *ap,	/* Associative-Processor structure */
	            int dat[],		/* Raw data	*/
	            int smoothed[],	/* smoothed (added)
				         * version of data */
		    int j)		/* line number (ie j coordinate)   */

{
	int             i, i1, loop;
	int             icompare;
	int             is;	/* parent name for image in this slice */
	int             ip;	/* parent name for image on last line */
	int             ib;	/* data block name */

	int i2compare;

	i2compare = ap->background + ap->thresh;
	icompare = i2compare * ap->multiply;

	for (i = 0; i < ap->lsiz; i++)
	{
		if (smoothed[i] > icompare)
		{
			/*
			 * Pixel is above threshold, find which parent it
			 * belongs to.
			 */
			is = ap->lastline[i];		/* Parent last pixel
                                                         *this line */
			ip = ap->lastline[i + 1];	/* Guess belongs to
							 * above line */
			if (ip == 0)
			{
				/* New parent, or, horizontal slice: */
				if (is == 0)
				{
					/* Ah - new parent. */
					ip = ap->pstack[ap->ipstack++];

					ap->parent[ip].first =
						ap->bstack[ap->ibstack];
					ap->parent[ip].pnop = 0;
					ap->parent[ip].growing = 0;
					if (j == 0)
						/* It touches first line: */
						ap->parent[ip].touch = 1;
					else
						ap->parent[ip].touch = 0;

					/* For hunt thru list for terminates: */
					if (ip > ap->maxip)
						ap->maxip = ip;
				} else
				{
					/* Slice with no vertical join: */
					ip = is;
				}
			} else if ((ip > 0 && is > 0) && (ip != is))
			{
				/* merge: */
				/* Join linked lists: */
				ap->blink[ap->parent[ip].last] =
					ap->parent[is].first;
				/* Copy `last block': */
				ap->parent[ip].last = ap->parent[is].last;
				ap->parent[ip].pnop += ap->parent[is].pnop;

				/* Fix `lastline' correlator array: */
				ib = ap->parent[is].first;
				loop = 1;
				while (loop)
				{
					i1 = ap->plessey[ib].x;
					if (ap->lastline[i1 + 1] == is)
						ap->lastline[i1 + 1] = ip;
					if (ap->parent[ip].last == ib)
						loop = 0;
					else
						ib = ap->blink[ib];
				}
				/* Mark parent inactive: */
				ap->parent[is].pnop = -1;
				/* return name to stack: */
				ap->pstack[--ap->ipstack] = is;
			}
			/* Add in pixel to linked list: */
			ib = ap->bstack[ap->ibstack++];
			/* Patch forward link into last data block: */
			if (ap->parent[ip].pnop > 0)
				ap->blink[ap->parent[ip].last] = ib;
			/* Remember last block in chain: */
			ap->parent[ip].last = ib;
			/* Store the data: */
			ap->plessey[ib].x = i;
			ap->plessey[ib].y = j;
			ap->plessey[ib].z = dat[i] - i2compare;
			/* increment active count: */
			ap->parent[ip].pnop++;
			/* remember which parent this pixel was for next line: */
			ap->lastline[i + 1] = ip;
		} else
		{
			/* Pixel was below threshold, mark lastline: */
			ap->lastline[i + 1] = 0;
		}
	}
	/* Check for images touching left & right edges:
         * OR the touch flag with 2 for left, 4 for right: */
	if(ap->lastline[1] > 0 )
		ap->parent[ap->lastline[1]].touch |= 2;
	if(ap->lastline[ap->lsiz] > 0)
		ap->parent[ap->lastline[ap->lsiz]].touch |= 4;
}
