#include <stdio.h>
#include <math.h>
#include "ap.h"

void moments(ap_t *ap, int ip)
{
	float xbar,ybar,total;
	int ib,ilast;
	int iz,ipmax;
	float x,y,z;
	int loop;
	static FILE *coords = NULL;
	apmCat_t cat;
	int i;

	if(coords == NULL)
		coords = fopen("coords.dat","w");
	ap->nimages++;

	xbar = 0.0;
	ybar = 0.0;
	total = 0.0;
	ipmax = 0;

	cat.area = ap->parent[ip].pnop;
	cat.xx = 0.0;
	cat.xy = 0.0;
	cat.yy = 0.0;
	for (i=0; i<8; i++)
		cat.areal[i] = 0;
	ib = ap->parent[ip].first;
	ilast = ap->parent[ip].last;
	loop = 1;
	while(loop)
	{
		x = (float)ap->plessey[ib].x;
		y = (float)ap->plessey[ib].y;
		iz = ap->plessey[ib].z;
		z = (float)iz;
		if(iz > ipmax) ipmax = iz;
		xbar += x*z;
		ybar += y*z;
		total = total + z;
		/* +1/12 in cross-moments accounts for finite pixel size: */
		cat.xx += (x*x + 1.0/12.0)*z;
		cat.xy += x*y*z;
		cat.yy += (y*y + 1.0/12.0)*z;
		for(i=0; i<8 && iz >= ap->areal[i]; i++)
			cat.areal[i]++;
		if(ib == ilast)
			loop = 0;
			else
			ib = ap->blink[ib];
	}
	xbar /= total;
	ybar /= total;
	cat.xx = cat.xx/total - xbar*xbar;
	cat.xy = cat.xy/total - xbar*ybar;
	cat.yy = cat.yy/total - ybar*ybar;
	fprintf(coords, "%7.1f%8.1f%8.1f\n",
		xbar+1.0,ybar+1.0, sqrt(cat.area/3.141));

	/* Package up and send off to IRAF table: */
	cat.x = xbar;
	cat.y = ybar;
	cat.peak = ipmax;
	cat.total = total;

	tabAdd(cat);
}
