#include <stdio.h>
#include "ap.h"

void restack(ap_t *ap, int ip)
{
	int i,ib;
	ib = ap->parent[ip].first;
	for(i=ap->ibstack - ap->parent[ip].pnop; i < ap->ibstack-1;  i++)
	{
		/* Stash all blocks back in a burst:*/
		ap->bstack[i] = ib;
		ib = ap->blink[ib];
	}
	/* and the last one: */
	ap->bstack[ap->ibstack-1] = ib;
	ap->ibstack -= ap->parent[ip].pnop;

	/* Put parent name back on stack: */
	ap->pstack[--ap->ipstack] = ip;

	/* Mark that parent inactive: */
	ap->parent[ip].pnop = -1;
}

void terminate(ap_t *ap)
{
	int ip;

	/* Search through all possible parents!  */
	for(ip = 1; ip <= ap->maxip; ip++)
	{
		if(ap->parent[ip].pnop != -1)
		{
			if(ap->parent[ip].pnop == ap->parent[ip].growing)
			{
				/* That's a termination: */
				if(ap->parent[ip].pnop >= ap->ipnop &&
					ap->parent[ip].touch == 0)
					moments(ap, ip);
				restack(ap, ip);
			}
			else
			{
				/* This parent still active: */
				ap->parent[ip].growing = ap->parent[ip].pnop;
			}
		}
	}
}
void apfu(ap_t *ap)
{
	int ip, big, ipbig;

	/* Search through all possible parents and just junk the biggest
	 * one to free space:  */
	big = 0;
	for(ip = 1; ip <= ap->maxip; ip++)
	{
		if(ap->parent[ip].pnop != -1)
		{
			if(ap->parent[ip].pnop > big)
			{
				big = ap->parent[ip].pnop;
				ipbig = ip;
			}
		}
	}
	if(big > 0)
	{
		restack(ap, ipbig);
		/* clearout lastline references to this parent: */
		for (ip = 0; ip < ap->lsiz; ip++)
			if(ap->lastline[ip] == ipbig) ap->lastline[ip] = 0;
	}
}
