include "hddb.h"
include <ctype.h>
include <imio.h>
include <mach.h>

pointer procedure hdopen(iptr)

# Parameters 

pointer iptr

# Local variables

pointer hp
int j

begin

      # First allocate the main structure workspace

      call malloc(hp,NALLOC,TY_STRUCT)

      # Fill in the values...

      BUFSIZ(hp) = 0
      PTRDIFF(hp) = 0
      MINPTR(hp) = MAX_INT
      MAXPTR(hp) = -MAX_INT
      CURFIB(hp) = 0
      DPTR(hp) = NULL
      IMPTR(hp) = iptr
      do j = 1,NHEADMAX
         DATLOCS(hp,j) = NULL

      return(hp)
end

procedure hdgfib(hp,fibnum)

# Parameters

pointer hp
int fibnum

# Local variables

char key[SZKEY]
int junk,dr,ip,neol
pointer rp1,rp2,dp

# Functions

int idb_findrecord()

begin

      # Search for the fibre key.

      CURFIB(hp) = fibnum
      call sprintf(key,SZKEY,"F%03d?*")
         call pargi(fibnum)
      junk = idb_findrecord(IMPTR(hp),key,rp1)

      # Search for the requisite number of EOL marks...

      neol = 0
      ip = rp1
      while (Memc[ip] != EOS) {
         if (Memc[ip] == '\n') {
            neol = neol + 1
         }
         if (neol == NHEADMAX)
            break
         ip = ip + 1
      }
      rp2 = ip

      # Get workspace appropriate for the amount of header we're reading...

      dr = rp2 - rp1 + 1
      if (BUFSIZ(hp) == 0) {
         BUFSIZ(hp) = dr
         call malloc(DPTR(hp),dr,TY_CHAR)
      } else if (BUFSIZ(hp) != dr) {
         BUFSIZ(hp) = dr
         call realloc(DPTR(hp),dr,TY_CHAR)
      }

      # Move the header info into the workspace

      dp = DPTR(hp)
      PTRDIFF(hp) = rp1 - dp
      call amovc(Memc[rp1],Memc[dp],dr)

      # Search for all of the header items now

      call hdsearch(hp)

      # Update the min and max pointers...

      call hdptrs(hp)
end

procedure hdclose(hp)

# Parameters

pointer hp

begin

      # Close down the header buffers

      if (BUFSIZ(hp) > 0) 
         call mfree(DPTR(hp),TY_CHAR)
      call mfree(hp,TY_STRUCT)
end

procedure hdsearch(hp)

# Parameters

pointer hp

# Local variables

char key[SZKEY],ch,item[SZKEY]
pointer sp,pat,patbuf,rp,dp,data
int ip,j,nchars,junk,i,nc,jst

# Function

int strlen(),patmake(),patmatch()

begin

      # Get some workspace

      call smark(sp)
      call salloc(pat,SZ_FNAME,TY_CHAR)
      call salloc(patbuf,SZ_LINE,TY_CHAR)

      # Loop for each of the header keywords...

      ip = 0
      nc = strlen(HDDICT)
      call salloc(data,nc,TY_CHAR)
      call strcpy(HDDICT,Memc[data],nc)
      jst = 1
      do j = 1,NHEADMAX {

         # Strip the next item out of the header dictionary

         do i = 1,SZKEY {
            jst = jst + 1
            if (Memc[data+jst-1] == '|')
               break
            item[i] = Memc[data+jst-1]
         }
         item[i] = EOS    
 
         # Form the keyword

         call sprintf(key,SZKEY,"F%03d%s")
            call pargi(CURFIB(hp))
            call pargstr(item)
         nchars = strlen(key)

         # Search unblocked records...

         rp = NULL
         dp = DPTR(hp)
         if (IM_UABLOCKED(IMPTR(hp)) == NO) {
            call sprintf(Memc[pat],SZ_FNAME,"^{%s}[ =]")
               call pargstr(key)
            junk = patmake(Memc[pat],Memc[patbuf],SZ_LINE)
            for (ip = dp; Memc[ip] != EOS; ip = ip + 1) {
               if (patmatch(Memc[ip],Memc[patbuf]) > 0) {
                  rp = ip
                  break
               }
               while(Memc[ip] != '\n' && Memc[ip] != EOS)
                  ip = ip + 1
            }

         # Search blocked records...

         } else {
            for (ip = dp; Memc[ip] != EOS; ip = ip + HEADLEN + 1) {
               ch = Memc[ip]
               if (ch == EOS)
                  break
               else if (ch != key[1])
                  next
               else {
                  ch = Memc[ip+nchars]
                  if (ch != ' ' && ch != '=')
                     next
               }
               do i = 1,nchars-1 {
                  ch = Memc[ip+i]
                  if (ch != key[i+1]) {
                     ch = 0
                     break
                  }
               }
               if (ch != 0) {
                  rp = ip
                  break
               }
            }
         }

         # Store the resulting location

         DATLOCS(hp,j) = rp
      }
       
      # Ditch workspace

      call sfree(sp)
  
end

procedure hdgstr(hp,item,outstr,maxch)

# Parameters

pointer hp
char item[ARB],outstr[ARB]
int maxch

# Local variables

char key[SZKEY],junk[SZKEY]
int j,istart,op,ip
pointer dp,data,sp,rp

# Functions

int strdic(),ctowrd(),strlen(),stridx(),idb_findrecord()

begin

      # Get some workspace

      call smark(sp)
      call salloc(data,maxch,TY_CHAR)

      # Which item is this?

      call sprintf(key,SZKEY,"F%03d%s")
         call pargi(CURFIB(hp))
         call pargstr(item)
      j = strdic(item,junk,SZKEY,HDDICT)
      dp = DATLOCS(hp,j)

      # If no offset was defined try and find it by searching the
      # header.  If you still can't find it then return an EOS

      if (dp == NULL) {
         if (idb_findrecord(IMPTR(hp),key,rp) == 0)
            outstr[1] = EOS
         else
            call imgstr(IMPTR(hp),key,outstr,maxch)

      # Otherwise copy it over...

      } else {
         istart = stridx("=",Memc[dp]) + 2
         if (ctowrd(Memc[dp],istart,Memc[data],maxch) > 0) {
            op = strlen(Memc[data])
            for (ip = 1; ip <= op && IS_WHITE(Memc[data+ip-1]); ip = ip + 1)
               ;
            call strcpy(Memc[data+ip-1],outstr,maxch)
            op = strlen(outstr)
            while (op > 0 && (IS_WHITE(outstr[op]) || outstr[op] == '\n'))
               op = op - 1
            outstr[op+1] = EOS
         } else
            outstr[1] = EOS
      }
      call sfree(sp)
end

real procedure hdgetr(hp,item)

# Parameters

pointer hp
char item[ARB]

# Local variables

pointer sp,outstr
real val
int ip

# Functions

int ctor()

begin 

      # Get some workspace

      call smark(sp)
      call salloc(outstr,SZ_LINE,TY_CHAR)

      # Get the string result first

      call hdgstr(hp,item,Memc[outstr],SZ_LINE)

      # Convert this to a real.

      if (Memc[outstr] == EOS)
         val = INDEF
      else {
         ip = 1
         if (ctor(Memc[outstr],ip,val) < 0)
           val = INDEF
      }
      return(val)
end

procedure hdptrs(hp)

# Parameters

pointer hp

# Local variables

pointer ddd
int i

begin

      # Find the min and max pointer locations

      do i = 1,NHEADMAX {
         if (DATLOCS(hp,i) != NULL) {
            ddd = DATLOCS(hp,i) + PTRDIFF(hp)
            MINPTR(hp) = min(ddd,MINPTR(hp))
            MAXPTR(hp) = max(ddd,MAXPTR(hp))
         }
      }

end

procedure hddelf(hp)

# Parameters

pointer hp

# Local variables

int off

# Functions

int stridxs()
begin

      # Search from the maxptr for an EOL character. Copy everything
      # after it to the location of the first pointer.

      off = stridxs("\n",Memc[MAXPTR(hp)])
      if (off > 0)
         call strcpy(Memc[MAXPTR(hp)+off],Memc[MINPTR(hp)],ARB)
      else
         Memc[MINPTR(hp)] = EOS
end
