include <imhdr.h>
include <error.h>

define   INITALLOC  32
define   ALLOC      ($1*2)
define   APER       Memi[$1+($2-1)*2]
define   NSP        Memi[$1+($2-1)*2+1]

procedure t_chkresp()

# Local variables

pointer sp,rname,line,fname,rptr,sl,wptr,ptr
int nx,fd,ialloc,nk,isp,ap,bm,fg,fb,i,junk
real rejthresh,highval,clipval,sig,mean

# Functions

pointer immap(),imgl2r()
int open(),aavgr(),fscan()
real clgetr(),ahivr()

begin

      # Get some workspace

      call smark(sp)
      call salloc(rname,SZ_FNAME,TY_CHAR)
      call salloc(line,SZ_LINE,TY_CHAR)
      call salloc(fname,SZ_FNAME,TY_CHAR)

      # Start by opening response file

      call clgstr("response",Memc[rname],SZ_FNAME)
      iferr (rptr = immap(Memc[rname],READ_ONLY,0)) {
         call eprintf("Can't find %s\n")
            call pargstr(Memc[rname])
         call erract(EA_ERROR)
      }
      nx = IM_LEN(rptr,1)

      # Open the slist file

      call clgstr("slistf",Memc[fname],SZ_FNAME)
      iferr (fd = open(Memc[fname],READ_ONLY,TEXT_FILE)) {
         call eprintf("Can't find %s\n")
            call pargstr(Memc[fname])
         call erract(EA_ERROR)
      }

      # Now read the slist file and toss out the spectra which aren't
      # sky beams.

      ialloc = INITALLOC
      call malloc(sl,ALLOC(ialloc),TY_STRUCT)
      nk = 0
      while (fscan(fd) != EOF) {
         call gargwrd(Memc[line],SZ_LINE)
         call gargi(isp)
         call gargi(ap)
         call gargi(bm)

         # Check to see if the current entry is a sky beam

         if (bm == 0) {
            nk = nk + 1
            if (nk > ialloc) {
               ialloc = ialloc + INITALLOC
               call realloc(sl,ALLOC(ialloc),TY_STRUCT)
            }
            APER(sl,nk) = ap
            NSP(sl,nk) = isp
         }
      }
      if (nk == 0) 
         call error(0,"No spectra in the specified aperture/beam range")
      call realloc(sl,ALLOC(nk),TY_STRUCT)

      # Get the rejection threshold and open the two aperture files.

      rejthresh = clgetr("rejthresh")
      call clgstr("goodaps",Memc[fname],SZ_FNAME)
      iferr (fg = open(Memc[fname],NEW_FILE,TEXT_FILE)) {
         call eprintf("Can't open new file: %s\n")
            call pargstr(Memc[fname])
         call erract(EA_ERROR)
      }
      call clgstr("badaps",Memc[fname],SZ_FNAME)
      iferr (fb = open(Memc[fname],NEW_FILE,TEXT_FILE)) {
         call eprintf("Can't open new file: %s\n")
            call pargstr(Memc[fname])
         call erract(EA_ERROR)
      }

      # Get some more workspace

      call salloc(wptr,nk,TY_REAL)

      # Loop for each of the spectra and calculate the average response

      for (i=1; i<=nk; i = i + 1) {
         ptr = imgl2r(rptr,NSP(sl,i))
         junk = aavgr(Memr[ptr],nx,Memr[wptr+i-1],sig)
      }

      # Calculate the highest value, the ensemble mean and sigma 

      highval = ahivr(Memr[wptr],nk)
      junk = aavgr(Memr[wptr],nk,mean,sig)
      clipval = mean + 3.0*sig

      # If the maximum response is higher than the clip value, then
      # recalculate the ensemble mean and sigma. Normalise the mean
      # response array by this new max

      if (highval > clipval) {
         highval = 0.0
         do i = 1,nk {
            if (Memr[wptr+i-1] < clipval) 
               highval = max(highval,Memr[wptr+i-1])
         }
      }
      call adivkr(Memr[wptr],highval,Memr[wptr],nk)

      # Now go through and reject apertures with responses which are
      # lower than the rejection threshold.

      do i = 1,nk {
         if (Memr[wptr+i-1] > rejthresh) 
            call fprintf(fg,"%d\n")
         else 
            call fprintf(fb,"%d\n")
         call pargi(APER(sl,i))
      }

      # Close things up and get out of here

      call close(fb)
      call close(fg)
      call close(fd)
      call imunmap(rptr)
      call mfree(sl,TY_STRUCT)
      call sfree(sp)
end
