include <imhdr.h>
include <error.h>
include <math/curfit.h>
include <pkg/center1d.h>
include <pkg/dttext.h>

define  INITALLOC  32
define  ALLOC      (2*$1)
define  APER       Memi[$1+($2-1)*2]
define  SHFT       Memr[$1+($2-1)*2+1]

define  FALLOC     (10*$1)
define  PIX        Memd[P2D($1+($2-1)*10)]
define  USER       Memd[P2D($1+($2-1)*10+2)]
define  WTS        Memd[P2D($1+($2-1)*10+4)]
define  FWIDTH     Memr[$1+($2-1)*10+6]
define  FTYPE      Memi[$1+($2-1)*10+7]
define  NEWPOS     Memd[P2D($1+($2-1)*10+8)]

procedure t_fitrest()

# Local variables

pointer sp,iname,rootname,dbname,line,slist,dt,iptr,sl,ftp,fwp,ptrd,template
pointer fe,ic,coefs,wptr1,wptr2,xp,yp,wp,ptrt,rejpts,cv,pp,sptr1,sptr2
int nx,nspec,apfirst,fd,ialloc,ns,spfirst,junkint,record,nfeat,isect
int ncoefs,type,jst,jfn,jinc,j,jsp,nfit,nf,i,ishift,absshift,nx2,nx3,nx4
int dstart,tstart,i1,i2,newshift,totshift
real width,crad,cthresh,tband1,tband2,guess,new
double dval1,dval2,dval3

# Functions

pointer immap(),imgl2r(),clopset()
int open(),fscan(),dtgeti(),dtscan(),ic_geti(),dcvstati(),cc_terry()
real center1d(),dtgetr(),ic_getr(),clgpsetr()
double dcveval(),dcvstatd()

begin

      # Get some workspace

      call smark(sp)
      call salloc(iname,SZ_FNAME,TY_CHAR)
      call salloc(rootname,SZ_FNAME,TY_CHAR)
      call salloc(dbname,SZ_FNAME,TY_CHAR)
      call salloc(line,SZ_LINE,TY_CHAR)
      call salloc(slist,SZ_FNAME,TY_CHAR)

      # Get input file name and database name. Strip any extra rubbish
      # off the input file name.

      call clgstr("input",Memc[iname],SZ_FNAME)
      call xt_imroot(Memc[iname],Memc[rootname],SZ_FNAME)
      call sprintf(Memc[iname],SZ_LINE,"id%s")
         call pargstr(Memc[rootname])
      call clgstr("database",Memc[dbname],SZ_FNAME)

      # Map the input file...

      iferr (iptr = immap(Memc[rootname],READ_ONLY,0)) {
         call eprintf("Can't open file %s \n")
            call pargstr(Memc[rootname])
         call erract(EA_ERROR)
      }
      nx = IM_LEN(iptr,1)
      nspec = IM_LEN(iptr,2)

      # Open the database file...

      dt = NULL
      iferr (call dtremap(dt,Memc[dbname],Memc[iname],READ_ONLY)) {
         call eprintf("Can't map file %s in %s/\n")
            call pargstr(Memc[iname])
            call pargstr(Memc[dbname])
         call erract(EA_ERROR)
      }

      # Find which was the last successful identification and get
      # the number of features listed.

      record = DT_NRECS(dt)
      apfirst = dtgeti(dt,record,"aperture")
      nfeat = dtgeti(dt,record,"features")
      if (nfeat <= 0)
         call error(0,"No features identified in the first aperture")

      # Read the feature information

      call malloc(fe,FALLOC(nfeat),TY_STRUCT)
      nf = 0
      do i = 1,nfeat {
         junkint = dtscan(dt)
         call gargd(dval1)
         call gargd(dval2)
         call gargd(dval3)
         if (!IS_INDEFD(dval1) && !IS_INDEFD(dval3)) {
            nf = nf + 1
            PIX(fe,nf) = dval1
            USER(fe,nf) = dval3
            call gargr(FWIDTH(fe,nf))
            call gargi(FTYPE(fe,nf))
            call gargd(WTS(fe,nf))
         }
      }
      nfeat = nf
      call realloc(fe,FALLOC(nfeat),TY_STRUCT)

      # Open the slist file...

      call clgstr("slistf",Memc[slist],SZ_FNAME)
      iferr (fd = open(Memc[slist],READ_ONLY,TEXT_FILE)) {
         call eprintf("Can't find file %s")
            call pargstr(Memc[slist])
         call erract(EA_ERROR)
      }

      # Read the slist information into memory and close the file

      ialloc = INITALLOC
      call malloc(sl,ALLOC(ialloc),TY_STRUCT)
      ns = 0
      spfirst = 0
      while (fscan(fd) != EOF) {
         ns = ns + 1
         if (ns > ialloc) {
            ialloc = ialloc + INITALLOC
            call realloc(sl,ALLOC(ialloc),TY_STRUCT)
         }
         call gargwrd(Memc[line],SZ_LINE)
         call gargi(junkint)
         call gargi(APER(sl,ns))
         call gargi(junkint)
         call gargi(junkint)
         call gargr(SHFT(sl,ns))
         if (APER(sl,ns) == apfirst)
            spfirst = ns
      }
      call realloc(sl,ALLOC(ns),TY_STRUCT)
      call close(fd)
      if (spfirst == 0)
         call error(0,"First aperture doesn't exist in slist file")

      # Open the ICFIT structure

      call ic_open(ic)
      call dtgstr(dt,record,"function",Memc[line],SZ_LINE)
      call ic_pstr(ic,"function",Memc[line])
      call ic_puti(ic,"order",dtgeti(dt,record,"order"))
      call dtgstr(dt,record,"sample",Memc[line],SZ_LINE)
      call ic_pstr(ic,"sample",Memc[line])
      call ic_puti(ic,"naverage",dtgeti(dt,record,"naverage"))
      call ic_puti(ic,"niterate",dtgeti(dt,record,"niterate"))
      call ic_putr(ic,"low",dtgetr(dt,record,"low_reject"))
      call ic_putr(ic,"high",dtgetr(dt,record,"high_reject"))
      call ic_putr(ic,"grow",dtgetr(dt,record,"grow"))

      # Open the CURFIT structure

      ncoefs = dtgeti(dt,record,"coefficients")
      call salloc(coefs,ncoefs,TY_DOUBLE)
      call dtgad(dt,record,"coefficients",Memd[coefs],ncoefs,ncoefs)
      call dcvrestore(cv,Memd[coefs])
      call ic_putr(ic,"xmin",real(dcvstatd(cv,CVXMIN)))
      call ic_putr(ic,"xmax",real(dcvstatd(cv,CVXMAX)))

      # Now remap the database so that you can write to it...

      iferr (call dtremap(dt,Memc[dbname],Memc[iname],APPEND)) {
         call eprintf("Can't map file %s in %s/\n")
            call pargstr(Memc[iname])
            call pargstr(Memc[dbname])
         call erract(EA_ERROR)
      }

      # Get some centring info

      pp = clopset("wyfpars")
      width = clgpsetr(pp,"fwidth")
      type = EMISSION
      crad = clgpsetr(pp,"cradius")
      cthresh = clgpsetr(pp,"cthresh")
      call clcpset(pp)

      # Get some workspace

      call malloc(wptr1,nx,TY_REAL)
      call malloc(wptr2,nx,TY_REAL)
      call malloc(sptr1,nx,TY_REAL)
      call malloc(sptr2,nx,TY_REAL)
      call malloc(xp,nfeat,TY_DOUBLE)
      call malloc(yp,nfeat,TY_DOUBLE)
      call malloc(wp,nfeat,TY_DOUBLE)
      call malloc(ftp,nfeat,TY_INT)
      call malloc(fwp,nfeat,TY_REAL)
      call malloc(template,nx,TY_REAL)

      # Get the template spectrum

      ptrt = imgl2r(iptr,spfirst)
      call amovr(Memr[ptrt],Memr[template],nx)

      # Loop through twice.  Once from the central spectrum backwards and
      # once from the central spectrum forwards.

      do i = 1,2 {
         if (i == 1) {
            jst = spfirst - 1
            jfn = 1
            jinc = -1
         } else {
            jst = spfirst + 1
            jfn = ns
            jinc = 1
         }

         # Loop for each of the spectra

         do jsp = jst,jfn,jinc {

            # Set the new peak positions to indefinite

            do j = 1,nfeat
                NEWPOS(fe,j) = INDEFD

            # Get the mean shift between the current spectrum and the 
            # template.

            ptrd = imgl2r(iptr,jsp)
            ishift = cc_terry(Memr[ptrd],Memr[template],nx)

            # Copy the overlapping bits of the spectra into work arrays.

            absshift = abs(ishift)
            nx2 = nx - absshift
            if (ishift == 0) {
                dstart = 0
                tstart = 0
                call amovr(Memr[ptrd],Memr[sptr1],nx2)
                call amovr(Memr[template],Memr[sptr2],nx2)
            } else if (ishift > 0) {
                dstart = absshift
                tstart = 0
                call amovr(Memr[ptrd+absshift],Memr[sptr1],nx2)
                call amovr(Memr[template],Memr[sptr2],nx2)
            } else if (ishift < 0) {
                 dstart = 0
                 tstart = absshift
                 call amovr(Memr[ptrd],Memr[sptr1],nx2)
                 call amovr(Memr[template+absshift],Memr[sptr2],nx2)
            }

            # Ok break the spectra into four sections.  Find the mean shift
            # within those four sections.  Then use that to predict where 
            # in the _original_ spectrum you should be able to find features.

            nx3 = nx2/4
            do isect = 1,4 {
                i1 = (isect-1)*nx3 + 1
                i2 = min(nx2,i1+nx3-1)
                nx4 = i2 - i1 + 1
                call amovr(Memr[sptr1+i1-1],Memr[wptr1],nx4)
                call amovr(Memr[sptr2+i1-1],Memr[wptr2],nx4)
                newshift = cc_terry(Memr[wptr1],Memr[wptr2],nx4)
                totshift = ishift + newshift

                # The variable totshift is the amount you have to add to
                # the template peaks positions to find them in the program
                # spectrum.  Loop through all the peaks and see if you can 
                # centre the ones that are in this band...

                tband1 = real(tstart + (isect-1)*nx3 + 1)
                tband2 = tband1 + real(nx4-1)
                do j = 1,nfeat {
                    if (PIX(fe,j) < tband1 || PIX(fe,j) > tband2)
                        next
                    guess = real(PIX(fe,j)) + real(totshift)
                    new = center1d(guess,Memr[ptrd],nx,width,type,crad,cthresh)
                    if (!IS_INDEF(new)) 
                        NEWPOS(fe,j) = dble(new)
                    else
                        NEWPOS(fe,j) = INDEFD
                }
            }

            # Having defined the line centres, copy the positional and
            # wavelength info into fitting arrays.

            nfit = 0
            do j = 1,nfeat {
               if (!IS_INDEFD(NEWPOS(fe,j))) {
                  nfit = nfit + 1
                  Memd[xp+nfit-1] = NEWPOS(fe,j)
                  Memd[yp+nfit-1] = USER(fe,j)
                  Memd[wp+nfit-1] = WTS(fe,j)
                  Memr[fwp+nfit-1] = FWIDTH(fe,j)
                  Memi[ftp+nfit-1] = FTYPE(fe,j)
               }
            }

            # Now do the fit.

            call ic_fitd(ic,cv,Memd[xp],Memd[yp],Memd[wp],nfit,YES,
               YES,YES,YES)
            if (ic_geti(ic,"nreject") > 0 && ic_geti(ic,"nfit") == nfit)
               rejpts = ic_geti(ic,"rejpts")
            else
               rejpts = NULL

            # Write out the header to the database...

            call dtptime(dt)
            call sprintf(Memc[line],SZ_LINE,"begin\tidentify %s - Ap %d\n")
               call pargstr(Memc[rootname])
               call pargi(APER(sl,jsp))
            call dtput(dt,Memc[line])
            call sprintf(Memc[line],SZ_LINE,"\tid\t%s\n")
               call pargstr(Memc[rootname])
            call dtput(dt,Memc[line])
            call dtput(dt,"\ttask\tfitrest\n")
            call sprintf(Memc[line],SZ_LINE,"\timage\t%s - Ap %d\n")
               call pargstr(Memc[rootname])
               call pargi(APER(sl,jsp))
            call dtput(dt,Memc[line])
            call sprintf(Memc[line],SZ_LINE,"\taperture\t%d\n")
               call pargi(APER(sl,jsp))
            call dtput(dt,Memc[line])
            call dtput(dt,"\taplow\t1.\n")
            call dtput(dt,"\taphigh\t1.\n")

            # Write out the feature info

            call sprintf(Memc[line],SZ_LINE,"\tfeatures\t%d\n")
               call pargi(nfit)
            call dtput(dt,Memc[line])
            do j = 1,nfit {
               call sprintf(Memc[line],SZ_LINE,
                  "\t    %10.2f %10.8g %10.8g %5.1f %d %d\n")
                  call pargd(Memd[xp+j-1])
                  call pargd(dcveval(cv,Memd[xp+j-1]))
                  call pargd(Memd[yp+j-1])
                  call pargr(Memr[fwp+j-1])
                  call pargi(Memi[ftp+j-1])
                  if (rejpts != NULL) {
                     if (Memi[rejpts+j-1] == YES)
                        call pargd(0.0d0)
                     else
                        call pargd(Memd[wp+j-1])
                  } else
                    call pargd(Memd[wp+j-1])
               call dtput(dt,Memc[line])
            }
            call dtput(dt,"\n")

            # Write out the fit information

            call ic_gstr(ic,"function",Memc[line],SZ_LINE)
            call dtput(dt,"\tfunction %s\n")
               call pargstr(Memc[line])
            call dtput(dt,"\torder %d\n")
               call pargi(ic_geti(ic,"order"))
            call ic_gstr(ic,"sample",Memc[line],SZ_LINE)
            call dtput(dt,"\tsample %s\n")
               call pargstr(Memc[line])
            call dtput(dt,"\tnaverage %d\n")
               call pargi(ic_geti(ic,"naverage"))
            call dtput(dt,"\tniterate %d\n")
               call pargi(ic_geti(ic,"niterate"))
            call dtput(dt,"\tlow_reject %g\n")
               call pargr(ic_getr(ic,"low"))
            call dtput(dt,"\thigh_reject %g\n")
               call pargr(ic_getr(ic,"high"))
            call dtput(dt,"\tgrow %g\n")
               call pargr(ic_getr(ic,"grow"))
            ncoefs = dcvstati(cv,CVNSAVE)
            call dcvsave(cv,Memd[coefs])
            call dtput(dt,"\tcoefficients\t%d\n")
               call pargi(ncoefs)
            do j = 1,ncoefs {
               call dtput(dt,"\t\t%g\n")
                  call pargd(Memd[coefs+j-1])
            }
            call dtput(dt,"\n")
         }
      }

      # Close fitting structures

      call dcvfree(cv)
      call ic_closed(ic)

      # Close the database file and the spectrum file

      call dtunmap(dt)
      call imunmap(iptr)

      # Free workspace and leave

      call mfree(xp,TY_DOUBLE)
      call mfree(yp,TY_DOUBLE)
      call mfree(wp,TY_DOUBLE)
      call mfree(ftp,TY_INT)
      call mfree(fwp,TY_REAL)
      call mfree(wptr1,TY_REAL)
      call mfree(wptr2,TY_REAL)
      call mfree(sptr1,TY_REAL)
      call mfree(sptr2,TY_REAL)
      call mfree(sl,TY_STRUCT)
      call mfree(fe,TY_STRUCT)
      call sfree(sp)
end

int procedure cc_terry(data,template,npts)

# Parameters

int npts
real data[npts],template[npts]

# Local variables

pointer wpt1,wpt2,wpt3,wpt4
int nx2,nxrem,j,i,irem,ploc
real maxval,factor,location

# Functions

real asumr()

begin

    # Get some workspace

    call malloc(wpt1,2*npts,TY_REAL)
    call malloc(wpt2,npts,TY_REAL)
    call malloc(wpt3,npts,TY_REAL)
    call malloc(wpt4,npts,TY_REAL)

    # Load up the template in a padded cell.

    nx2 = npts/2
    nxrem = npts - nx2
    call amovkr(0.0,Memr[wpt1],nxrem)
    call amovr(template,Memr[wpt1+nxrem],npts)
    call amovkr(0.0,Memr[wpt1+nxrem+npts],nx2)

    # Do the CCF...

    j = 0
    do i = -nxrem,nx2 {
        factor = real(npts-abs(i))/real(npts)
        ploc = wpt1 + nxrem + i
        call amulr(data,Memr[ploc],Memr[wpt2],npts)
        j = j + 1
        Memr[wpt3+j-1] = -real(i)
        Memr[wpt4+j-1] = factor*asumr(Memr[wpt2],npts)
    }

    # Find the maximum value

    maxval = Memr[wpt4]
    irem = 1
    do i = 2,npts {
        if (Memr[wpt4+i-1] > maxval) {
            maxval = Memr[wpt4+i-1]
            irem = i
        }
    }
    location = Memr[wpt3+irem-1]

    # Return the result

    call mfree(wpt1,TY_REAL)
    call mfree(wpt2,TY_REAL)
    call mfree(wpt3,TY_REAL)
    call mfree(wpt4,TY_REAL)
    return(location)
end

