include <mach.h>

procedure t_matchem()

# Local variables

pointer sp,fname,saveme,fieldnm,line,iptr,list
int fd
double jdobj,mindiff,jdsky,djd

# Functions

int access(),open(),imtgetim()
pointer immap(),imtopenp()
double imgetd()
bool streq()

errchk immap,imgstr,imgetd
define exit_ 99

begin

      # Get workspace

      call smark(sp)
      call salloc(fname,SZ_FNAME,TY_CHAR)
      call salloc(saveme,SZ_FNAME,TY_CHAR)
      call salloc(fieldnm,SZ_LINE,TY_CHAR)
      call salloc(line,SZ_LINE,TY_CHAR)

      # Open the output file

      call clgstr("output",Memc[fname],SZ_FNAME)
      if (access(Memc[fname],0,0) == YES) 
         call delete(Memc[fname])
      fd = open(Memc[fname],NEW_FILE,TEXT_FILE)

      # Get the object file name and open it.

      call clgstr("obj",Memc[fname],SZ_FNAME)
      iferr {
         iptr = immap(Memc[fname],READ_ONLY,0)
         call imgstr(iptr,"AF2FLDNM",Memc[fieldnm],SZ_LINE)
         jdobj = imgetd(iptr,"JD")
         call imunmap(iptr)
      } then
         goto exit_

      # Get the offset sky list and open it

      Memc[saveme] = EOS
      mindiff = double(MAX_REAL)
      list = imtopenp("skylist")
      while (imtgetim(list,Memc[fname],SZ_FNAME) != EOF) {

         # Open each file in turn and read the field name and JD

         iferr {
            iptr = immap(Memc[fname],READ_ONLY,0)
            call imgstr(iptr,"AF2FLDNM",Memc[line],SZ_LINE)
            jdsky = imgetd(iptr,"JD")
            call imunmap(iptr)
         } then
            next

         # Check for field name match and then see if the difference
         # in JD is less than the previous minimum

         if (streq(Memc[line],Memc[fieldnm])) {
            djd = abs(jdsky - jdobj)
            if (djd < mindiff) {
               mindiff = djd
               call strcpy(Memc[fname],Memc[saveme],SZ_FNAME)
            }
         }
      }
      call imtclose(list)

      # If you got something, the write it to the output file

      if (Memc[saveme] != EOS) {
         call fprintf(fd,"%s\n")
            call pargstr(Memc[saveme])
      }

      # Exit

exit_
      call close(fd)
      call sfree(sp)
end
