include <imhdr.h>
include <error.h>

define   INITALLOC  32
define   ALLOC      ($1*3)
define   APER       Memi[$1+($2-1)*3]
define   NSP        Memi[$1+($2-1)*3+1]
define   GOODBAD    Memi[$1+($2-1)*3+2]

define   SE_GOOD    1
define   SE_BADRESP 2
define   SE_HRES    3
define   SE_LRES    4
define   SE_CURVE   5
define   SE_USERDEL 6

define   MAXBUF     10240

procedure t_skyedit()

# Local variables

pointer sp,fname,line,goodaps,badaps,iptr,sl,wptr,wptr2,wptr3,wptr4,wptr5
pointer tptr,ptr1,ptr2,co,rp,logfile
int nx,nx2,nx3,fd,ialloc,nk,ap,ngood,nrej,dims[2],i,j,ist,ido,np,k,ld,mode
long one_l,v1[IM_MAXDIM]
bool inter,go,ans
real lcut1,lcut2,lcut3,lcut4,hcut1,hcut2,hcut3,hcut4,mean,sigma,thresh

# Functions

pointer immap(),crfile(),imgl2r(),impl2r(),comap(),cogetr(),rng_open()
int open(),fscan(),access(),aravr(),imgnlr()
bool clgetb(),rng_inrangei()
real asumr(),chauvenet()

begin

      # Get workspace

      call smark(sp)
      call salloc(fname,SZ_FNAME,TY_CHAR)
      call salloc(line,SZ_LINE,TY_CHAR)
      call salloc(goodaps,SZ_FNAME,TY_CHAR)
      call salloc(badaps,SZ_FNAME,TY_CHAR)
      call salloc(logfile,SZ_FNAME,TY_CHAR)

      # Get the input image and open it

      call clgstr("input",Memc[fname],SZ_FNAME)
      iferr (iptr = immap(Memc[fname],READ_ONLY,0)) {
         call eprintf("Can't open %s\n")
            call pargstr(Memc[fname])
         call erract(EA_ERROR)
      }
      nx = IM_LEN(iptr,1)
      nx2 = nx/2
      nx3 = nx - nx2

      # Get the slist file and read it

      call clgstr("slistf",Memc[fname],SZ_FNAME)
      iferr (fd = open(Memc[fname],READ_ONLY,TEXT_FILE)) {
         call eprintf("Can't open %s\n")
            call pargstr(Memc[fname])
         call erract(EA_ERROR)
      }
      ialloc = INITALLOC
      call malloc(sl,ALLOC(ialloc),TY_STRUCT)
      nk = 0
      while (fscan(fd) != EOF) {
         nk = nk + 1
         if (nk > ialloc) {
            ialloc = ialloc + INITALLOC
            call realloc(sl,ALLOC(ialloc),TY_STRUCT)
         }
         call gargwrd(Memc[line],SZ_LINE)
         call gargi(NSP(sl,nk))
         call gargi(APER(sl,nk))
         GOODBAD(sl,nk) = SE_GOOD
      }
      call realloc(sl,ALLOC(nk),TY_STRUCT)
      call close(fd)
      ngood = nk
      
      # Get the goodaps and badaps files. Open the latter

      call clgstr("goodaps",Memc[goodaps],SZ_FNAME)
      call clgstr("badaps",Memc[badaps],SZ_FNAME)
      iferr (fd = open(Memc[badaps],READ_ONLY,TEXT_FILE)) {
         call eprintf("Can't open badaps file %s\n")
            call pargstr(Memc[badaps])
         call erract(EA_ERROR)
      }

      # Read the badaps file and mark the bad apertures in the
      # slist structure.  These all have low response functions.

      while (fscan(fd) != EOF) {
         call gargi(ap)
         do i = 1,nk {
            if (APER(sl,i) == ap) {
               GOODBAD(sl,i) = SE_BADRESP
               ngood = ngood - 1
               break
            }
         }
      }
      call close(fd)

      # Is this being done interactively? 

      inter = clgetb("interactive")

      # Get name of log file and open it.

      call clgstr("logfile",Memc[logfile],SZ_FNAME)
      if (Memc[logfile] != EOS) {
         if (access(Memc[logfile],0,0) == YES) 
            mode = APPEND
         else
            mode = NEW_FILE
         ld = open(Memc[logfile],mode,TEXT_FILE)
      } else
         ld = NULL

      # Ok, if the good aperture file exists, then delete it.

      if (access(Memc[goodaps],0,0) == YES) 
         call delete(Memc[goodaps])

      # Get workspace for mean spectrum

      call malloc(wptr,nx,TY_REAL)

      # OK, now begin the mean iteration loop.  Loop until you stop
      # rejecting apertures.

      one_l = 1
      go = true
      while (go) {
         nrej = 0

         # Create a temporary file

         call mktemp("tmp",Memc[fname],SZ_FNAME)
         dims[1] = nx
         dims[2] = ngood
         tptr = crfile(Memc[fname],NEW_FILE,0,2,dims,TY_REAL)

         # Fill in the temporary file with good spectra from the input file

         j = 0
         do i = 1,nk {
            if (GOODBAD(sl,i) == SE_GOOD) {
               j = j + 1
               ptr1 = imgl2r(iptr,NSP(sl,i))
               ptr2 = impl2r(tptr,j)
               call amovr(Memr[ptr1],Memr[ptr2],nx)
            }
         }
         call imflush(tptr)

         # Define limits for calculating means

         if (ngood > 4) {
            ist = 3
            ido = ngood - 4
         } else if (ngood > 2) {
            ist = 2
            ido = ngood - 2
         } else {
            ist = 1
            ido = ngood
         }

         # Get three workspaces

         call malloc(wptr2,ngood,TY_REAL)
         call malloc(wptr3,ngood,TY_REAL)
         call malloc(wptr4,ngood,TY_REAL)
         call malloc(wptr5,ngood,TY_REAL)

         # Set up temporary file for column access

         co = comap(tptr,MAXBUF)
         
         # Ok, loop for each column.  Sort the data in each column and
         # exclude however many at each end when forming the mean

         do i = 1,nx {
            ptr1 = cogetr(co,i,1,ngood)
            call asrtr(Memr[ptr1],Memr[ptr1],ngood)
            Memr[wptr+i-1] = asumr(Memr[ptr1+ist-1],ido)/real(ido)
         }
         call counmap(co)

         # Subtract this mean sky from all of the input skies in the 
         # temporary file.  Calculate clipped mean residual for each
         # spectrum and then clipped means for each half a spectrum

         j = 0
         call amovkl(one_l,v1,IM_MAXDIM)
         while (imgnlr(tptr,ptr1,v1) != EOF) {
            j = j + 1
            call asubr(Memr[ptr1],Memr[wptr],Memr[ptr1],nx)
            np = aravr(Memr[ptr1],nx2,Memr[wptr3+j-1],sigma,4.0)
            np = aravr(Memr[ptr1+nx2],nx3,Memr[wptr4+j-1],sigma,4.0)
            Memr[wptr2+j-1] = 0.5*(Memr[wptr3+j-1] + Memr[wptr4+j-1]) 
            Memr[wptr5+j-1] = Memr[wptr3+j-1] - Memr[wptr4+j-1]
         }
         
         # Right... you can get rid of the temporary file now

         call imunmap(tptr)
         call imdelete(Memc[fname])

         # Check the full residuals, the half residuals and the difference
         # between the half residuals to see which ones might be outliers

         thresh = max(2.0,chauvenet(ngood))
         call aavgr(Memr[wptr2],ngood,mean,sigma)
         lcut1 = mean - thresh*sigma
         hcut1 = mean + thresh*sigma
         call aavgr(Memr[wptr3],ngood,mean,sigma)
         lcut2 = mean - thresh*sigma
         hcut2 = mean + thresh*sigma
         call aavgr(Memr[wptr4],ngood,mean,sigma)
         lcut3 = mean - thresh*sigma
         hcut3 = mean + thresh*sigma
         call aavgr(Memr[wptr5],ngood,mean,sigma)
         lcut4 = mean - thresh*sigma
         hcut4 = mean + thresh*sigma
         k = 0
         do j = 1,nk {
            if (GOODBAD(sl,j) == SE_GOOD) {
               k = k + 1
               if (Memr[wptr2+k-1] > hcut1)
                  GOODBAD(sl,j) = SE_HRES
               else if (Memr[wptr2+k-1] < lcut1)
                  GOODBAD(sl,j) = SE_LRES
               else if (Memr[wptr3+k-1] < lcut2 || Memr[wptr3+k-1] > hcut2)
                  GOODBAD(sl,j) = SE_CURVE
               else if (Memr[wptr4+k-1] < lcut3 || Memr[wptr4+k-1] > hcut3)
                  GOODBAD(sl,j) = SE_CURVE
               else if (Memr[wptr5+k-1] < lcut4 || Memr[wptr5+k-1] > hcut4)
                  GOODBAD(sl,j) = SE_CURVE
               if (GOODBAD(sl,j) != SE_GOOD)
                  nrej = nrej + 1
            }
         }

         # Ditch workspace

         call mfree(wptr2,TY_REAL)
         call mfree(wptr3,TY_REAL)
         call mfree(wptr4,TY_REAL)
         call mfree(wptr5,TY_REAL)
         
         # If no rejections, then get out of here

         ngood = ngood - nrej
         if (nrej == 0 || ngood == 0) 
            break
      }     

      # Ok, we've escaped from the rejection loop -- just check that
      # we haven't rejected everything...

      if (ngood == 0) {
         call eprintf("All sky spectra rejected -- editing failed\n")
         do j = 1,nk {
            if (GOODBAD(sl,j) != SE_BADRESP)
               GOODBAD(sl,j) = SE_GOOD
         }
      }

      # Now, give the user some stats about each of the sky spectra

      call gimme_stats(iptr,sl,nk,STDOUT)
      call gimme_stats(iptr,sl,nk,ld)

      # See if this edit is OK by the user...

      if (inter) 
         ans = clgetb("ok")
      else
         ans = true

      # If the user isn't happy with this edit, then get a range of
      # of aperture to delete from the cl.

      while (!ans) {
         call clgstr("listdel",Memc[line],SZ_LINE)
         if (Memc[line] == EOS) {
            call eprintf("You can't delete all apertures!\n")
         } else {
            iferr (rp = rng_open(Memc[line],INDEF,INDEF,INDEF)) {
               call eprintf("Error in delete range\n")
            } else {
   
               # Loop through the list and see if the apertures are
               # in the hit list.

               do j = 1,nk {
                  if (GOODBAD(sl,j) != SE_BADRESP) {
                     if (rng_inrangei(rp,APER(sl,j)))
                        GOODBAD(sl,j) = SE_USERDEL
                     else               
                        GOODBAD(sl,j) = SE_GOOD
                  }
               }
               call rng_close(rp)
            }

            # Ok, now give the user another estimate of the quality
            # of the sky stats.
        
         }
         call gimme_stats(iptr,sl,nk,STDOUT)
         call gimme_stats(iptr,sl,nk,ld)
         ans = clgetb("ok")
      }

      # Right, now we've been through all this editing, write out
      # a new version of the good apertures file.

      fd = open(Memc[goodaps],NEW_FILE,TEXT_FILE)
      do i = 1,nk {
         if (GOODBAD(sl,i) == SE_GOOD) {
            call fprintf(fd,"%d\n")
               call pargi(APER(sl,i))
         }
      }
      call close(fd)

      # Clean up
 
      if (ld != NULL)
         call close(ld)
      call mfree(wptr,TY_REAL)
      call mfree(sl,TY_STRUCT)
      call imunmap(iptr)
      call sfree(sp)
end


pointer procedure crfile(name,mode,template,ndim,dims,type)

# Parameters

char name[ARB]
int mode,ndim,dims[ndim],type
pointer template

# Local variables

pointer fptr,ptr1
int i
long vin[IM_MAXDIM],vout[IM_MAXDIM],one_l

# Functions

pointer immap(),impgsr()

errchk immap,impgsr

begin

      # Begin by mapping the new file

      fptr = immap(name,mode,template)

      # Now set the necessary header items...

      IM_NDIM(fptr) = ndim
      do i = 1,ndim
         IM_LEN(fptr,i) = dims[i]
      IM_PIXTYPE(fptr) = type

      # Set up some data array indicies

      one_l = 1
      call amovkl(one_l,vin,IM_MAXDIM)
      call amovkl(one_l,vout,IM_MAXDIM)

      # Now map some data and close the file.  This creates the data array.
      # Reopen it READ_WRITE access...

      ptr1 = impgsr(fptr,vin,vout,ndim)
      call imunmap(fptr)
      fptr = immap(name,READ_WRITE,0)

      # Return the pointer

      return (fptr)
end

procedure gimme_stats(iptr,sl,nk,fd)

# Parameters

pointer iptr,sl
int nk,fd

# Local variables

int j,nrej,naccept,nx
long one_l,v1[IM_MAXDIM]
real sum,sumsq,mean,sig,median,pct
pointer ptr1

# Functions

real amedr()
int imgnlr()

begin

      # If there is no file descriptor, then get out of here...

      if (fd == NULL)
         return

      # Initialise a few things and print a banner

      j = 0
      nrej = 0
      sum = 0.0
      sumsq = 0.0
      nx = IM_LEN(iptr,1)
      call fprintf(fd,"\nSpec  Aper      Mean     Median    Stddev\n")
      call fprintf(fd,"-----------------------------------------\n")

      # Do consecutive lines in the input file

      one_l = 1
      call amovkl(one_l,v1,IM_MAXDIM)
      while (imgnlr(iptr,ptr1,v1) != EOF) {
         j = j + 1

         # Calculate mean, dispersion and median of sky spectrum
         # Print them out and tell why a spectrum has been rejected

         call aavgr(Memr[ptr1],nx,mean,sig)
         median = amedr(Memr[ptr1],nx)
         call fprintf(fd,"%3d   %3d   %8.2f   %8.2f  %8.2f")
            call pargi(NSP(sl,j))
            call pargi(APER(sl,j))
            call pargr(mean)
            call pargr(median)
            call pargr(sig)
         switch (GOODBAD(sl,j)) {
            case SE_GOOD:
               call fprintf(fd,"  Accepted\n")
               sum = sum + median
               sumsq = sumsq + median*median
            case SE_BADRESP:
               call fprintf(fd,"  Deleted -- Bad Response\n")
            case SE_HRES:
               call fprintf(fd,"  Deleted -- High Residuals\n")
            case SE_LRES:
               call fprintf(fd,"  Deleted -- Low Residuals\n")
            case SE_CURVE:
               call fprintf(fd,"  Deleted -- Curvature\n")
            case SE_USERDEL:
               call fprintf(fd,"  Deleted -- By User\n")
         }
         if (GOODBAD(sl,j) != SE_GOOD)
            nrej = nrej + 1
      }

      # Give an account of the number of accepted and rejected apertures

      call fprintf(fd,"\nNumber of sky spectra rejected: %d\n")
         call pargi(nrej)
      naccept = nk - nrej
      call fprintf(fd,"Number of good sky spectra: %d\n")
         call pargi(naccept)

      # Calculate the ensemble mean and standard deviation of the 
      # medians of the spectra.

      if (naccept > 0) 
         mean = sum/real(naccept)
      else
         mean = INDEF
      if (naccept > 1) {
         sig = (sumsq - sum*mean)/real(naccept-1)
         if (sig > 0) 
            sig = sqrt(sig)
         else
            sig = 0
         pct = 100.0*sig/mean
      } else {
         sig = INDEF
         pct = INDEF
      }
      call fprintf(fd,"\nEnsemble average of good sky medians: %g\n")
         call pargr(mean)
      call fprintf(fd,"Ensemble dispersion of good sky medians: %g\n")
         call pargr(sig)
      call fprintf(fd,"Ratio dispersion/mean: %g%%\n")
         call pargr(pct)
end

real procedure chauvenet(n)

# Parameters

int n
real val

# Local variables

real logn

begin

      # Do the calculation...

      logn = log10(real(n))
      val = logn*(-0.1042*logn + 1.1695) + 0.8895
      return(val)
end
