include <error.h>
include <mach.h>

define   INITALLOC  32
define   ALLOC      ($1*6)
define   APER       Memi[$1+($2-1)*6]
define   BEAM       Memi[$1+($2-1)*6+1]
define   WST        Memr[$1+($2-1)*6+2]
define   WFN        Memr[$1+($2-1)*6+3]
define   DISP       Memr[$1+($2-1)*6+4]
define   KEEP       Memi[$1+($2-1)*6+5]

procedure t_specrng()

# Local variables

pointer sp,slistf,sl,junkstr,wptr
int fd,ialloc,nk,i,ap,bm,npix,j,nn
real lam1,dlam,lcut,hcut,mean,sigma,minw,maxw

# Functions

int open(),fscan(),aavgr(),awvgr()

define exit_ 99

begin

      # Get some workspace

      call smark(sp)
      call salloc(slistf,SZ_FNAME,TY_CHAR)
      call salloc(junkstr,SZ_LINE,TY_CHAR)

      # Open the slist file

      call clgstr("slistf",Memc[slistf],SZ_FNAME)
      iferr (fd = open(Memc[slistf],READ_ONLY,TEXT_FILE)) {
         call eprintf("Can't open %s\n")
            call pargstr(Memc[slistf])
         call erract(EA_ERROR)
      }

      # Open the slist structure

      ialloc = INITALLOC
      call malloc(sl,ALLOC(ialloc),TY_STRUCT)

      # Now read the slist file and toss out the spectra which aren't
      # in the aperture range and which aren't in the beam range.

      nk = 0
      while (fscan(fd) != EOF) {
         call gargwrd(Memc[junkstr],SZ_LINE)
         call gargi(i)
         call gargi(ap)
         call gargi(bm)
         call gargi(i)
         call gargr(lam1)
         call gargr(dlam)
         call gargi(npix)

         # Check to see if the current entry is a sky beam

         if (bm == 0) {
            nk = nk + 1
            if (nk > ialloc) {
               ialloc = ialloc + INITALLOC
               call realloc(sl,ALLOC(ialloc),TY_STRUCT)
            }
            APER(sl,nk) = ap
            BEAM(sl,nk) = bm
            WST(sl,nk) = lam1
            WFN(sl,nk) = lam1 + real(npix-1)*dlam
            DISP(sl,nk) = dlam
            KEEP(sl,nk) = YES
         }
      }
      if (nk == 0) {
         call eprintf("No sky spectra in file\n")
         minw = -1.0
         maxw = -1.0
         goto exit_
      }         
      call realloc(sl,ALLOC(nk),TY_STRUCT)

      # Ok, do some stats on the dispersion to search for cock-ups in
      # the dispersion solution.  Iterate twice and kick out 3 sigma outliers

      call malloc(wptr,nk,TY_REAL)
      do i = 1,nk 
         Memr[wptr+i-1] = DISP(sl,i)
      nn = aavgr(Memr[wptr],nk,mean,sigma)
      lcut = mean - 3.0*sigma
      hcut = mean + 3.0*sigma
      do i = 1,2 {
         nn = awvgr(Memr[wptr],nk,mean,sigma,lcut,hcut)
         do j = 1,nk {
            if (Memr[wptr+j-1] < lcut || Memr[wptr+j-1] > hcut)
               KEEP(sl,j) = NO
         }
         if (i == 1) {
            lcut = mean - 3.0*sigma
            hcut = mean + 3.0*sigma
         }
      }

      # Right, now having decided which spectra have valid dispersion
      # solutions, then go through the list and decide the largest minimum
      # wavelength and the smallest maximum wavelength.

      minw = 0.0
      maxw = MAX_REAL
      do i = 1,nk {
         if (KEEP(sl,i) == YES) {
            minw = max(minw,WST(sl,i))
            maxw = min(maxw,WFN(sl,i))
         }
      }
      if (minw == 0.0 && maxw == MAX_REAL) {
         minw = 0.0
         maxw = MAX_REAL
         do i = 1,nk {
            minw = max(minw,WST(sl,i))
            maxw = min(maxw,WFN(sl,i))
         }
      }

      # Give me the result

exit_
      call printf("%g %g\n")
         call pargr(minw)
         call pargr(maxw)

      # Close up and exit

      call close(fd)
      call mfree(sl,TY_STRUCT)
      call mfree(wptr,TY_REAL)
      call sfree(sp)
end
