procedure t_stddir()

# Local variables

pointer sp,othername,egname,outfile,rootdir,tempname,dirname,fname,list
pointer fptr,msg,wkptr,data
real wave1,wave2,sumdlam,minwave,maxwave,lamda,mag,dlam,lminus,lplus
real avedlam,totfrac
int nfound,nalloc,ngood,i,j,fd,nbin,nloc
bool found,test1,test2

# Functions

real clgetr()
pointer imtopen()
int imtgetim(),isdirectory(),access(),open(),fscan(),stridx(),strldx()

begin

      # Get some workspace

      call smark(sp)
      call salloc(othername,SZ_LINE,TY_CHAR)
      call salloc(egname,SZ_LINE,TY_CHAR)
      call salloc(outfile,SZ_FNAME,TY_CHAR)
      call salloc(rootdir,SZ_PATHNAME,TY_CHAR)
      call salloc(tempname,SZ_FNAME,TY_CHAR)
      call salloc(dirname,SZ_PATHNAME,TY_CHAR)
      call salloc(fname,SZ_PATHNAME,TY_CHAR)
      call salloc(msg,SZ_LINE,TY_CHAR)
      call salloc(data,SZ_LINE,TY_CHAR)

      # Get the star's names, the file for the output results and the
      # root directory for the start of the search.

      call clgstr("othername",Memc[othername],SZ_LINE)
      call clgstr("egname",Memc[egname],SZ_LINE)
      call clgstr("outfile",Memc[outfile],SZ_FNAME)
      call clgstr("rootdir",Memc[rootdir],SZ_FNAME)

      # Get the spectral range of the input spectrum.

      wave1 = clgetr("w1")
      wave2 = clgetr("w2")

      # Set the file template and open the list

      call strcpy(Memc[rootdir],Memc[tempname],SZ_FNAME)
      call strcat("*",Memc[tempname],SZ_FNAME)
      list = imtopen(Memc[tempname])

      # Now loop for all files in the list.  If the current file is not a
      # directory, then skip it.

      nfound = 0
      while (imtgetim(list,Memc[dirname],SZ_FNAME) != EOF) {
         found = false
         if (isdirectory(Memc[dirname],Memc[fname],SZ_PATHNAME) == 0)
            next

         # Form the first file name

         call sprintf(Memc[fname],SZ_PATHNAME,"%s/%s.dat")
            call pargstr(Memc[dirname])
            call pargstr(Memc[othername])

         # If you can access that file, then keep it

         if (access(Memc[fname],0,0) == YES) 
            found = true

         # If not, then try the eg name.

         else {
            call sprintf(Memc[fname],SZ_PATHNAME,"%s/%s.dat")
               call pargstr(Memc[dirname])
               call pargstr(Memc[egname])
            if (access(Memc[fname],0,0) == YES)
               found = true
         }

         # If you've found one then store the file name away.

         if (found) {
            nfound = nfound + 1
            if (nfound == 1)
               call malloc(fptr,SZ_PATHNAME,TY_CHAR)
            else
               call realloc(fptr,SZ_PATHNAME*nfound,TY_CHAR)
            call strcpy(Memc[fname],Memc[fptr+(nfound-1)*SZ_PATHNAME],
               SZ_PATHNAME)
         }
      }
      call imtclose(list)

      # If any files were found then do some calculations to see how much of
      # the input spectrum will be covered by each calibration file.

      if (nfound == 0) {
         call sprintf(Memc[msg],SZ_LINE,"No calibration files found for: %s %s")
            call pargstr(Memc[othername])
            call pargstr(Memc[egname])
         call error(0,Memc[msg])
      } else {
         nalloc = 5*nfound
         call malloc(wkptr,nalloc,TY_REAL)

         # Open each file in turn and calculate the coverage.

         ngood = 0
         for (i = 1; i <= nfound; i = i + 1) {
            fd = open(Memc[fptr+(i-1)*SZ_PATHNAME],READ_ONLY,TEXT_FILE)
            nbin = 0
            sumdlam = 0.0
            minwave = wave2 + 1.0
            maxwave = wave1 - 1.0
            while (fscan(fd) != EOF) {
               call gargstr(Memc[data],SZ_LINE)
               if (stridx("#",Memc[data]) > 0)
                  next

               # Scan the string and get the wavelength, magnitude and bandwidth

               call sscan(Memc[data])
                  call gargr(lamda)
                  call gargr(mag)
                  call gargr(dlam)

               # Test for overlap with the spectrum

               lminus = lamda - dlam*0.5
               lplus = lamda + dlam*0.5
               if (lminus > wave2)
                  break
               if (lplus < wave1)
                  next
               test1 = (lminus >= wave1 && lminus <= wave2)
               test2 = (lplus >= wave1 && lplus <= wave2)
               if (test1 || test2) {
                  nbin = nbin + 1
                  sumdlam = sumdlam + dlam
                  minwave = min(minwave,lminus)
                  maxwave = max(maxwave,lplus)
               }
            }
            call close(fd)
            minwave = max(minwave,wave1)
            maxwave = min(maxwave,wave2)

            # If there is no overlap, then skip this one

            if (nbin == 0) 
               next

            # If there is overlap, then calculate how much of the spectrum is
            # covered.

            else {
               avedlam = sumdlam/real(nbin)
               ngood = ngood + 1
               totfrac = 1.0
               if (minwave > wave1)
                  totfrac = totfrac - ((minwave - wave1)/(wave2 - wave1))
               if (maxwave < wave2)
                  totfrac = totfrac - ((wave2 - maxwave)/(wave2 - wave1))

               # Store the results -- sort as you go along. 
               
               for (j = 1; j <= ngood - 1; j = j+ 1) { 
                  if (totfrac < Memr[wkptr+(j-1)*5+3]) 
                     next 
                  else if (totfrac == Memr[wkptr+(j-1)*5+3]) 
                      if (avedlam > Memr[wkptr+(j-1)*5+4]) 
                         next 
                      else 
                         break
                  else 
                     break 
               } 
               nloc = j 
               if (nloc == ngood) { 
                  Memr[wkptr+(nloc-1)*5] = real(i)
                  Memr[wkptr+(nloc-1)*5+1] = minwave 
                  Memr[wkptr+(nloc-1)*5+2] = maxwave
                  Memr[wkptr+(nloc-1)*5+3] = totfrac 
                  Memr[wkptr+(nloc-1)*5+4] = avedlam 
               } else {
                  for (j = ngood; j > nloc; j = j - 1) { 
                     Memr[wkptr+(j-1)*5] = Memr[wkptr+(j-2)*5] 
                     Memr[wkptr+(j-1)*5+1] = Memr[wkptr+(j-2)*5+1]
                     Memr[wkptr+(j-1)*5+2] = Memr[wkptr+(j-2)*5+2] 
                     Memr[wkptr+(j-1)*5+3] = Memr[wkptr+(j-2)*5+3] 
                     Memr[wkptr+(j-1)*5+4] = Memr[wkptr+(j-2)*5+4] 
                  }
                  Memr[wkptr+(nloc-1)*5] = real(i) 
                  Memr[wkptr+(nloc-1)*5+1] = minwave
                  Memr[wkptr+(nloc-1)*5+2] = maxwave 
                  Memr[wkptr+(nloc-1)*5+3] = totfrac
                  Memr[wkptr+(nloc-1)*5+4] = avedlam 
               } 
            } 
         }   
  
         # If no good files were found (zero coverage) send an error message

         if (ngood == 0)
            call error(0,"No cal files have proper wavelength coverage")
         else {
            fd = open(Memc[outfile],NEW_FILE,TEXT_FILE)
            for (i = 1; i <= ngood; i = i + 1) {
               nloc = nint(Memr[wkptr+(i-1)*5])
               j = strldx("/",Memc[fptr+(nloc-1)*SZ_PATHNAME])
               call strcpy(Memc[fptr+(nloc-1)*SZ_PATHNAME],Memc[dirname],j)
               call strcpy(Memc[fptr+(nloc-1)*SZ_PATHNAME+j],Memc[fname],
                  SZ_FNAME)
               call fprintf(fd,"%s %s %0.6g %0.6g %0.6g %0.6g\n")
                  call pargstr(Memc[dirname])
                  call pargstr(Memc[fname])
                  call pargr(Memr[wkptr+(i-1)*5+1])
                  call pargr(Memr[wkptr+(i-1)*5+2])
                  call pargr(Memr[wkptr+(i-1)*5+3])
                  call pargr(Memr[wkptr+(i-1)*5+4])
            }
            call close(fd)
            call mfree(wkptr,TY_REAL)
         }
         call mfree(fptr,TY_CHAR)
      }

      # Free stack workspace

      call sfree(sp)
end

                  
