procedure w_arcref1(arcrefms)

# w_arcrefs algorithm for totally automatic arc line id.

file   arcrefms

struct *fd

begin

      file temp,arms
      int i,j,junkint,nsol
      real ishift
      string str1
      bool goodsol

      # Get name of file

      arms = arcrefms

      # Make temporary file

      temp = mktemp ("tmp$iraf")

      # List the spectra in the arc file and set a few counters to zero

      slist(arms,aper="1-999",long_header=no, > temp)
      fd = temp

      # Loop for all the spectra in the file

      goodsol = no
      while (fscan(fd,str1,i,j,junkint,junkint,ishift) != EOF) {
         ishift = ishift - 1.0

         # Do automatic line id and see whether any solutions were found

         autoarc(arms,i,1,apshift=ishift,coordlist=wyf_red.coordlist,
            arclog=wyfpars.arclog,dflip=wyfpars.dflip) | scan(nsol)

         # If a solution was found then do a fit.  Keep track of which
         # spectra do and don't have a valid solution

         if (nsol > 0) {
            print("f \n q \n l \n f \n q \n q \n") |
            identify (arms, section="line "//i, database=database,
               coordlist=wyf_red.coordlist, units="", nsum=1, match=wyfpars.match,
               maxfeatures=wyfpars.maxfeat, zwidth=100., ftype="emission",
               fwidth=wyfpars.fwidth, cradius=wyfpars.cradius,
               threshold=wyfpars.cthresh, minsep=real(wyfpars.sep),
               function=wyfpars.i_function, order=wyfpars.i_order,
               sample="*", niterate=wyfpars.i_niterate,
               low_reject=wyfpars.i_low, high_reject=wyfpars.i_high,
               grow=0., autowrite=yes, cursor="STDIN", aidpars="", >G "dev$null", 
               >& "dev$null")
            goodsol = yes
            break
         }
      }
      fd = ""

      # If no automatic solutions were found, signal an error

      if (!goodsol) {
         error(0,"Auto line id failed for all spectra in "//arms)
   
      # Otherwise fit the rest of the spectra
      
      } else {
         fitrest(arms,temp)
      }

      # Clean up and add flag into header so that it can be scrunched.

      delete(temp, verify=no)
      hedit (arms, "refspec1", arms, add=yes, show=no, 
         verify=no)
end
