procedure w_arcref3(arcrefms)

# w_arcrefs algorithm for fully manual line id

file   arcrefms

struct *fd

begin

      file temp
      int junkint,irem,jrem,i,j
      string str1

      # Set up temporary file

      temp = mktemp ("tmp$iraf")

      # Do a slist of the arc file...

      slist(arcrefms,apertures="1-999",long_header=no, > temp)

      # Read the info for the first arc line and do the ids for it.

      fd = temp
      junkint = fscan(fd,str1,irem,jrem)
      if (nscan() == 0) 
         error(0,"No spectra in input arc file")
      
      # Do manual identification of first line.

      identify (arcrefms, section="line "//irem, database=database,
         coordlist=wyf_red.coordlist, units="",nsum=1, match=wyfpars.match,
         maxfeatures=50, zwidth=100., ftype="emission",
         fwidth=wyfpars.fwidth, cradius=wyfpars.cradius,
         threshold=wyfpars.cthresh, minsep=2.,
         function=wyfpars.i_function, order=wyfpars.i_order,
         sample="*", niterate=wyfpars.i_niterate,
         low_reject=wyfpars.i_low, high_reject=wyfpars.i_high,
         grow=0., autowrite=yes, aidpars="")
      hedit (arcrefms, "refspec1", arcrefms, add=yes,
         show=no, verify=no)

      # Now loop for the rest of the lines in the file...

      while (fscan(fd,str1,i,j) != EOF) {

         # First read the information on the previous fit, but delete
         # all the lines.  This gives a rough wavelength calibration
         # such that the calibration for a given spectrum can probably
         # be done just by shifting a few lines...

         print(":r "//arcrefms//" "//jrem//" \na \nd") |
         identify (arcrefms, section="line "//i, database=database,
            coordlist=wyf_red.coordlist, units="", nsum=1, match=wyfpars.match,
            maxfeatures=50, zwidth=100., ftype="emission",
            fwidth=wyfpars.fwidth, cradius=wyfpars.cradius,
            threshold=wyfpars.cthresh, minsep=2.,
            function=wyfpars.i_function, order=wyfpars.i_order,
            sample="*", niterate=wyfpars.i_niterate,
            low_reject=wyfpars.i_low, high_reject=wyfpars.i_high, grow=0., 
            autowrite=yes, cursor="STDIN", aidpars="", >G "dev$null", > "dev$null")

         # Now do the manual id...

         identify (arcrefms, section="line "//i, database=database,
            coordlist=wyf_red.coordlist, units="", nsum=1, match=wyfpars.match,
            maxfeatures=50, zwidth=100., ftype="emission",
            fwidth=wyfpars.fwidth, cradius=wyfpars.cradius,
            threshold=wyfpars.cthresh, minsep=2.,
            function=wyfpars.i_function, order=wyfpars.i_order,
            sample="*", niterate=wyfpars.i_niterate,
            low_reject=wyfpars.i_low, high_reject=wyfpars.i_high,
            grow=0., autowrite=yes, aidpars="")

         # Remember the numbers of this line...

         irem = i
         jrem = j
      }

      # Do a bit of cleanup and get out of here

      delete(temp,verify=no)
      fd = ""
end

