procedure w_hdcomp(input,log1,log2,log3,listonly)

string    input
file      log1
file      log2
file      log3
bool      listonly

struct    *fd

begin

      string inp,data
      file temp,infile
      bool comp

      # Make a temporary file

      temp = mktemp("tmp$iraf")

      # Get the input list

      inp = input
      sections(inp, option="fullname", > temp)

      # Loop for each file in the list

      fd = temp
      comp = yes
      while (fscan(fd,infile) != EOF) {

         # If in listonly mode then see if the file needs compressing

         if (listonly) {
            hselect(infile,"F001DAT1",yes) | scan(data)
            if (nscan() == 0)
               comp = yes
            else
               comp = no
         }
  
         # Send a message about the file and compress if necessary

         if (!listonly) {
            fixhead(infile,verbose=no,stdtype="SK") | tee(log1, >log2)
         } else if (comp) {
            print(infile," will have its header compressed") | tee(log1,>log2)
         } else {
            print(infile," already has a compressed header") | tee(log1,>log2)
         } 
      }
      fd = ""

      # Ditch the temporary file and get out of here

      delete(temp,verify=no)
end

