procedure w_mksafe(input,wyflim1,wyflim2)

# Make the parts of a flat field exposure which are not covered by
# the WYFFOS specral limits equal to one.

file  input    {prompt="Name of input file"}
int   wyflim1  {prompt="Lower WYFFOS limit"}
int   wyflim2  {prompt="Upper WYFFOS limit"}

begin

      file   temp,infile
      real   x1,x2

      # Temporary file name

      temp = mktemp("tmp$iraf")
      infile = input

      # Copy over the file to a temporary place but exclude the bits 
      # you don't want.  This will will physically move the spectra to 
      # the beginning of each line and modify the header.

      x1 = real(wyflim1)
      x2 = real(wyflim2)
      scopy(infile,temp,w1=x1,w2=x2,apertures="",bands="",beams="",
        apmodulus=0,format="multispec",renumber=no,offset=0,clobber=yes,
        merge=yes,rebin=no,verbose=no)

      # Delete the original and replace it with the temporary...

      imdelete(infile,verify=no)
      imrename(temp,infile,verbose=no)
end
