procedure w_qends(apref)

file   apref   {prompt="Name of aperture reference file"}

struct *fd

begin

      int nx,wyflim1,wyflim2
      real rx,x1,x2,ishift
      string log1,log2

      # Set logging

      tee.append = yes
      if (logfile == "")
         log1 = "dev$null"
      else
         log1 = logfile
      log2 = "dev$null"

      # What is the number of pixels in the spectral direction?

      hselect(apref,"i_naxis"//dispaxis,yes)  | scan(nx)
      rx = real(nx)

      # Are we doing the sawtooth correction?  If not, then the quickie
      # ends are just either end of the spectrum

      if (!wyfpars.dosaw) {
         wyflim1 = 1
         wyflim2 = nx

      # If not, then read the shifts file and find out what the maximum shift
      # is (in either direction). 

      } else {
         fd = wyfpars.sfile
         x1 = 1.0
         x2 = rx
         while (fscan(fd,ishift) != EOF) {
            if ((1.0 + ishift) < x1)
               x1 = 1.0 + ishift
            if ((rx + ishift) > x2)
               x2 = rx + ishift
         }
         fd = ""
         wyflim1 = nint(x1)
         wyflim2 = nint(x2)
      }

      # Log the correct answer and add the results into the header of 
      # the aperture reference file.

      print("Spectral limits found from file ",apref," are ",wyflim1,wyflim2) |
         tee (log1, >log2)
      hedit(apref,"wyflim1",wyflim1,add=yes,delete=no,verify=no,
         show=no,update=yes)
      hedit(apref,"wyflim2",wyflim2,add=yes,delete=no,verify=no,
         show=no,update=yes)
end
