# DOFIBERS -- Process fiber spectra from 2D to wavelength calibrated 1D.
#
# The task PROC does all of the interactive work and BATCH does the
# background work.  This procedure is organized this way to minimize the
# dictionary space when the background task is submitted.

procedure wyf_dofibers (objects)

string  objects = ""            {prompt="List of object spectra"}

file    apref = ""              {prompt="Aperture reference spectrum"}
file    flat = ""               {prompt="Flat field spectrum"}
file    throughput = ""         {prompt="Throughput file or image (optional)"}
string  arcs1 = ""              {prompt="List of arc spectra"}
string  readnoise = "0."        {prompt="Read out noise sigma (photons)"}
string  gain = "1."             {prompt="Photon gain (photons/data number)"}
real    datamax = INDEF         {prompt="Max data value / cosmic ray threshold"}
int     fibers = 97             {prompt="Number of fibers"}
real    width = 12.             {prompt="Width of profiles (pixels)"}
real    minsep = 8.     {prompt="Minimum separation between fibers (pixels)"}
real    maxsep = 15.    {prompt="Maximum separation between fibers (pixels)"}
file    apidtable = ""          {prompt="Aperture identifications"}
bool    scattered = no          {prompt="Subtract scattered light?"}
bool    arcscat = no            {prompt="Subtract scattered light from arcs?"}
bool    fitflat = yes           {prompt="Fit and ratio flat field spectrum?"}
bool    clean = yes             {prompt="Detect and replace bad pixels?"}
bool    dispcor = yes           {prompt="Dispersion correct spectra?"}
bool    skysubtract = yes       {prompt="Subtract sky?"}
bool    skyedit = yes           {prompt="Edit the sky spectra?"}
bool    saveskys = yes          {prompt="Save sky spectra?"}
bool    tippex = yes            {prompt="Tippex out sky line residuals?"}
file    tfile = ""              {prompt="Name of tippex file"}
bool    splot = no              {prompt="Plot the final spectrum?"}
bool    redo = no               {prompt="Redo operations if previously done?"}
bool    update = yes            {prompt="Update spectra if cal data changes?"}
bool    listonly = no           {prompt="List steps but don't process?\n"}

pset    wyfpars = ""            {prompt="Algorithm parameters"}

bool    batch

begin
      apscript.readnoise = readnoise
      apscript.gain = gain
      apscript.nfind = fibers
      apscript.width = width
      apscript.t_width = width
      apscript.minsep = minsep
      apscript.maxsep = maxsep
      apscript.radius = minsep
      apscript.clean = clean
      w_proc.datamax = datamax
      w_proc.batch = batch

      w_proc(objects,apref,flat,throughput,arcs1,fibers,apidtable,
         scattered,arcscat,fitflat,clean,dispcor,skysubtract,skyedit,saveskys,
         tippex,tfile,splot,redo,update,listonly)
end
